<?xml version="1.0" encoding="iso-8859-1"?>
<!-- Todo:
  
     [xsl:include] Using a hardcoded path is B A D. Maybe the XML document
     should contain the correct working directory. How else might we determine
     this at runtime?

  -->
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
  <!-- [ ! ] --><xsl:include href="common.xsl"/>

  <xsl:template match="/">
    <HTML>
      <xsl:variable name="cfg" select="dialog/head/vm/cfg"/>
      <xsl:variable name="displayName" select="dialog/head/vm/cfg@displayName"/>
      <HEAD>
        <TITLE><xsl:value-of select="dialog/head/title/vm/displayName"/> <xsl:value-of select="dialog/head/title"/></TITLE>
        <LINK rel="stylesheet" href="{$common}style.css" type="text/css"/>
        <META http-equiv="Content-Type" content="text/html; charset=iso-8859-1"/>
      </HEAD>

      <BODY background="{$imx}FFFFE6.png" bgcolor="#FFFFE6">

        <TABLE border="0" cellpadding="3" cellspacing="2" width="100%">
          <TR>
            <xsl:variable name="icon">
              <xsl:choose>
                <xsl:when test="string(dialog@type) = 'notice'">info.gif</xsl:when>
                <xsl:when test="string(dialog@type) = 'alert'">error.gif</xsl:when>
                <xsl:when test="string(dialog@type) = 'prompt'">question.gif</xsl:when>
                <xsl:otherwise>info.gif</xsl:otherwise>
              </xsl:choose>
            </xsl:variable>
            <TD width="1%" rowspan="4" valign="top"><IMG src="{$common.imx}{$icon}" width="32" height="32"/></TD>
            <TD><B><xsl:value-of select="dialog/head/title"/></B></TD>
          </TR>
          <TR>
            <TD>
              <xsl:for-each select="dialog/body/p">
                <P><SMALL><xsl:value-of select="."/></SMALL></P>
              </xsl:for-each>
            </TD>
          </TR>
          <TR>
            <TD><IMG src="{$imx}spacer.gif" width="1" height="1"/></TD>
          </TR>
          <TR>
            <TD background="{$imx}CCCCB3.png" bgcolor="#CCCCB3"><TABLE border="0" cellpadding="3" cellspacing="1">
              <TR>
                <TD width="1%" align="right" valign="baseline" nowrap="true"><SMALL>Virtual Machine</SMALL></TD>
                <TD valign="baseline" background="{$imx}FFFFE6.png" bgcolor="#FFFFE6"><SMALL><xsl:value-of select="$displayName"/></SMALL></TD>
              </TR>
              <xsl:if test="string($displayName) != string($cfg)">
                <TR>
                  <TD width="1%" align="right" valign="baseline" nowrap="true"><SMALL>Configuration</SMALL></TD>
                  <TD valign="baseline" background="{$imx}FFFFE6.png" bgcolor="#FFFFE6"><SMALL><xsl:value-of select="$cfg"/></SMALL></TD>
                </TR>
              </xsl:if>
            </TABLE></TD>
          </TR>
        </TABLE>

      </BODY>
    </HTML>
  </xsl:template>
</xsl:stylesheet>

