<?xml version="1.0" encoding="iso-8859-1"?>
<!DOCTYPE html [
  <!ENTITY nbsp "<xsl:text disable-output-escaping='yes'>&amp;nbsp;</xsl:text>">
  <!ENTITY copy "<xsl:text disable-output-escaping='yes'>&amp;copy;</xsl:text>">
  <!ENTITY ampersand "<xsl:text disable-output-escaping='yes'>&amp;</xsl:text>">
]>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
  <!-- Establish working directories -->
  <xsl:variable name="docroot">/vmware/</xsl:variable>
  <xsl:variable name="imx"><xsl:value-of select="$docroot"/>imx/</xsl:variable>
  <xsl:variable name="en"><xsl:value-of select="$docroot"/>en/</xsl:variable>
  <xsl:variable name="en.imx"><xsl:value-of select="$en"/>en/imx/</xsl:variable>
  <xsl:variable name="common"><xsl:value-of select="$docroot"/>themes/default/</xsl:variable>
  <xsl:variable name="common.imx"><xsl:value-of select="$common"/>imx/</xsl:variable>
  <xsl:variable name="common.en"><xsl:value-of select="$common"/>en/</xsl:variable>
  <xsl:variable name="common.en.imx"><xsl:value-of select="$common.en"/>imx/</xsl:variable>
  <xsl:variable name="theme"><xsl:value-of select="$docroot"/>themes/default/<xsl:choose>
    <xsl:when test="/server">
      <xsl:choose>
        <xsl:when test="/server/product@id='ESX'">ss</xsl:when>
        <xsl:otherwise>wgs</xsl:otherwise>
      </xsl:choose>
    </xsl:when>
    <xsl:otherwise>
      <xsl:choose>
        <xsl:when test="/input/product@id='ESX'">ss</xsl:when>
        <xsl:otherwise>wgs</xsl:otherwise>
      </xsl:choose>
    </xsl:otherwise>
  </xsl:choose>/</xsl:variable>
  <xsl:variable name="theme.imx"><xsl:value-of select="$theme"/>imx/</xsl:variable>
  <xsl:variable name="theme.en"><xsl:value-of select="$theme"/>en/</xsl:variable>
  <xsl:variable name="theme.en.imx"><xsl:value-of select="$theme.en"/>imx/</xsl:variable>

  <!-- Useful for placing ampersands into the search portion of URLs -->
  <xsl:variable name="ampersand">&ampersand;</xsl:variable>

<!-- button usage
=============================================================================
     <xsl:call-template name="button">
       <xsl:with-param name="label">Label</xsl:with-param>
       <xsl:with-param name="action">javascript:action();</xsl:with-param>
     </xsl:call-template>
=============================================================================
-->

  <xsl:template name="button">
    <xsl:param name="label">OK</xsl:param>
    <xsl:param name="action"/>
    <xsl:param name="icon"/>
    <xsl:param name="small"/>
    <xsl:param name="base">CCCCCC</xsl:param>
    <xsl:param name="gutter-shadow">999999</xsl:param>
    <xsl:param name="gutter-hilite">FFFFFF</xsl:param>
    <xsl:param name="edge-shadow">999999</xsl:param>
    <xsl:param name="edge-hilite">FFFFFF</xsl:param>
    <xsl:param name="text">000000</xsl:param>

    <TABLE border="0" cellpadding="0" cellspacing="0">
      <TR><!-- 9 : 7 -->
        <TD colspan="7" bgcolor="#{$gutter-shadow}"><IMG src="{$imx}spacer.gif" width="1" height="1"/></TD>
      </TR>
      <TR><!-- 9 : 6 --><!-- 0 : 5 --><!-- F : 5 -->
        <TD rowspan="6" bgcolor="#{$gutter-shadow}"><IMG src="{$imx}spacer.gif" width="1" height="1"/></TD>
        <TD colspan="5" bgcolor="#000000"><IMG src="{$imx}spacer.gif" width="1" height="1"/></TD>
        <TD rowspan="5" bgcolor="#{$gutter-hilite}"><IMG src="{$imx}spacer.gif" width="1" height="1"/></TD>
      </TR>
      <TR><!-- 0 : 4 --><!-- F : 3 --><!-- 0 : 3 -->
        <TD rowspan="4" bgcolor="#000000"><IMG src="{$imx}spacer.gif" width="1" height="1"/></TD>
        <TD colspan="3" bgcolor="#{$edge-hilite}"><IMG src="{$imx}spacer.gif" width="1" height="1"/></TD>
        <TD rowspan="3" bgcolor="#000000"><IMG src="{$imx}spacer.gif" width="1" height="1"/></TD>
      </TR>
      <TR><!-- F : 2 --><!-- C : 1 --><!-- 9 : 1 -->
        <TD rowspan="2" bgcolor="#{$edge-hilite}"><IMG src="{$imx}spacer.gif" width="1" height="1"/></TD>
        <TD bgcolor="#{$base}"><TABLE border="0" cellpadding="1" cellspacing="0"><TR>
          <xsl:choose>
            <xsl:when test="not($small)">
              <TD align="center" nowrap="true"><NOBR><SMALL>
                <A style="text-decoration:none;">
                  <xsl:choose>
                    <xsl:when test="$action">
                      <xsl:attribute name="href"><xsl:value-of select="$action"/></xsl:attribute>
                    </xsl:when>
                    <xsl:otherwise>
                      <xsl:attribute name="name"><xsl:value-of select="$label"/></xsl:attribute>
                    </xsl:otherwise>
                  </xsl:choose>
                  <FONT color="#{$text}">&nbsp; &nbsp;<xsl:value-of select="$label"/>&nbsp; &nbsp;</FONT>
                </A>
              </SMALL></NOBR></TD>
            </xsl:when>
            <xsl:otherwise>
              <TD align="center" nowrap="true"><NOBR><SMALL><SMALL>
                <A style="text-decoration:none;">
                  <xsl:choose>
                    <xsl:when test="$action and not($action = '')">
                      <xsl:attribute name="href"><xsl:value-of select="$action"/></xsl:attribute>
                    </xsl:when>
                    <xsl:otherwise>
                      <xsl:attribute name="name"><xsl:value-of select="$label"/></xsl:attribute>
                    </xsl:otherwise>
                  </xsl:choose>
                  <FONT color="#{$text}">&nbsp; &nbsp;<xsl:value-of select="$label"/>&nbsp; &nbsp;</FONT>
                </A>
              </SMALL></SMALL></NOBR></TD>
            </xsl:otherwise>
          </xsl:choose>
        </TR></TABLE></TD>
        <TD bgcolor="#{$edge-shadow}"><IMG src="{$imx}spacer.gif" width="1" height="1"/></TD>
      </TR>
      <TR><!-- 9 : 2 -->
        <TD colspan="2" bgcolor="#{$edge-shadow}"><IMG src="{$imx}spacer.gif" width="1" height="1"/></TD>
      </TR>
      <TR><!-- 0 : 4 -->
        <TD colspan="4" bgcolor="#000000"><IMG src="{$imx}spacer.gif" width="1" height="1"/></TD>
      </TR>
      <TR><!-- F : 6 -->
        <TD colspan="6" bgcolor="#{$gutter-hilite}"><IMG src="{$imx}spacer.gif" width="1" height="1"/></TD>
      </TR>
    </TABLE>
  </xsl:template>

  <xsl:template name="operationForm">
    <FORM name="operation" method="POST">
      <INPUT name="c" type="hidden"/>
      <INPUT name="f" type="hidden"/>
    </FORM>
  </xsl:template>

  <xsl:template name="pageHeader">
    <xsl:param name="uiPath">
      <current>VMs on <xsl:value-of select="/server/host"/><xsl:if test="/server/host@domain">.<xsl:value-of select="/server/host@domain"/> (System CPUs: <xsl:value-of select="/server/hostinfo/cpu"/>, System RAM: <xsl:value-of select="/server/hostinfo/memory/total"/><xsl:text> </xsl:text><xsl:value-of select="/server/hostinfo/memory/total@units"/>)</xsl:if></current>
    </xsl:param>
    <xsl:param name="xtra_ctrl">
      <none/>
    </xsl:param>

    <xsl:choose>
      <xsl:when test="not(/server/mui@layout='new')">
        <TABLE width="100%" border="0" cellpadding="0" cellspacing="0">
          <TR>
            <TD width="1%" nowrap="true"><IMG src="{$theme.imx}header.gif" width="451" height="62"/></TD>
            <!-- TD nowrap="true"><NOBR>
            <SMALL>VMware Management Interface for <xsl:value-of select="/server/username"/></SMALL>
            </NOBR></TD -->
            <TD align="right" valign="top" nowrap="true" background="{$theme.imx}header-bg.gif">
              <NOBR><SMALL><SMALL><BR/>Management Interface for
                <xsl:if test="/server/username">
                user: <xsl:value-of select="/server/username"/>
              </xsl:if>
              <xsl:if test="/input/username">
                user: <xsl:value-of select="/input/username"/>
              </xsl:if>
              &nbsp;<BR/>
              <xsl:if test="/server/build">
                Build: <xsl:value-of select="/server/build"/>
              </xsl:if>
              <xsl:if test="/input/build">
                Build: <xsl:value-of select="/input/build"/>
              </xsl:if>
              &nbsp;
              </SMALL></SMALL></NOBR>
            </TD>
          </TR>
        </TABLE>
      </xsl:when>
      <xsl:otherwise>
        <NOBR>
          <SMALL><SMALL>
            <SCRIPT>document.write("Last Updated: " +  new Date().toString());</SCRIPT>
          </SMALL></SMALL>
        </NOBR>
      </xsl:otherwise>
    </xsl:choose>
    <TABLE width="100%" border="0" cellpadding="1" cellspacing="0">
      <TR><TD><IMG src="{$imx}spacer.gif" width="1" height="4"/></TD></TR>
      <TR><TD bgcolor="#999980">
        <TABLE width="100%" border="0" cellpadding="3" cellspacing="0">
          <TR bgcolor="#CCCCB3">
            <xsl:if test="not(/server/mui@layout='new')">
             <TD>
               <TABLE border="0" cellpadding="3" cellspacing="0">
                 <TR>
                   <xsl:for-each select="$uiPath/location">
                     <TD><NOBR><SMALL><SMALL><A href="{@href}"><xsl:value-of select="."/></A></SMALL></SMALL></NOBR></TD>
                     <TD><NOBR><SMALL><SMALL>|</SMALL></SMALL></NOBR></TD>
                   </xsl:for-each>
                   <TD><NOBR><SMALL><SMALL><B><xsl:value-of select="$uiPath/current"/></B></SMALL></SMALL></NOBR></TD>
                 </TR>
               </TABLE>
             </TD>
            </xsl:if>
            <xsl:if test="/server/adminuser=1">
              <TD width="1%" align="right">
                <xsl:call-template name="button">
                  <xsl:with-param name="label">
                      Configure System
                  </xsl:with-param>
                  <xsl:with-param name="action">
                    <xsl:choose>
                      <xsl:when test="/server/product@id='ESX' or
                         /input/product@id='ESX'">
                        /vmware/config
                      </xsl:when>
                      <xsl:otherwise>/config/</xsl:otherwise>
                    </xsl:choose>
                  </xsl:with-param>
                  <xsl:with-param name="small">1</xsl:with-param>
                  <xsl:with-param name="gutter-shadow">999980</xsl:with-param>
                  <xsl:with-param name="gutter-hilite">FFFFE6</xsl:with-param>
                  <xsl:with-param name="edge-shadow">999980</xsl:with-param>
                  <xsl:with-param name="edge-hilite">FFFFE6</xsl:with-param>
                  <xsl:with-param name="base">CCCCB3</xsl:with-param>
                </xsl:call-template>
              </TD>
            </xsl:if>
            <xsl:for-each select="$xtra_ctrl/ctrl">
              <TD width="1%" align="right">
                <xsl:call-template name="button">
                  <xsl:with-param name="label"><xsl:value-of select="label"/></xsl:with-param>
                  <xsl:with-param name="action"><xsl:value-of select="action"/></xsl:with-param>
                  <xsl:with-param name="small">1</xsl:with-param>
                  <xsl:with-param name="gutter-shadow">999980</xsl:with-param>
                  <xsl:with-param name="gutter-hilite">FFFFE6</xsl:with-param>
                  <xsl:with-param name="edge-shadow">999980</xsl:with-param>
                  <xsl:with-param name="edge-hilite">FFFFE6</xsl:with-param>
                  <xsl:with-param name="base">CCCCB3</xsl:with-param>
                </xsl:call-template>
              </TD>
            </xsl:for-each>
            <xsl:if test="/server/product@id='ESX' and not(/server/mui@layout='new')">
              <TD width="1%" align="right">
                <xsl:call-template name="button">
                  <xsl:with-param name="label">Manage Files</xsl:with-param>
                  <xsl:with-param name="action">javascript:openFileManager();</xsl:with-param>
                  <xsl:with-param name="small">1</xsl:with-param>
                  <xsl:with-param name="gutter-shadow">999980</xsl:with-param>
                  <xsl:with-param name="gutter-hilite">FFFFE6</xsl:with-param>
                  <xsl:with-param name="edge-shadow">999980</xsl:with-param>
                  <xsl:with-param name="edge-hilite">FFFFE6</xsl:with-param>
                  <xsl:with-param name="base">CCCCB3</xsl:with-param>
                </xsl:call-template>
              </TD>
            </xsl:if>
            <xsl:if test="not(/server/mui@layout='new')">
            <TD width="1%" align="right">
              <xsl:call-template name="button">
                <xsl:with-param name="label">Help</xsl:with-param>
                <xsl:with-param name="action">javascript:openHelp(<xsl:choose><xsl:when test="/server/product@id='ESX'">'http://www.vmware.com/support/server/esx/doc/'</xsl:when><xsl:otherwise>'http://www.vmware.com/support/gsx2/doc'</xsl:otherwise></xsl:choose>, 700, 500);</xsl:with-param>
                <xsl:with-param name="small">1</xsl:with-param>
                <xsl:with-param name="gutter-shadow">999980</xsl:with-param>
                <xsl:with-param name="gutter-hilite">FFFFE6</xsl:with-param>
                <xsl:with-param name="edge-shadow">999980</xsl:with-param>
                <xsl:with-param name="edge-hilite">FFFFE6</xsl:with-param>
                <xsl:with-param name="base">CCCCB3</xsl:with-param>
              </xsl:call-template>
            </TD>
            <TD width="1%" align="right">
              <xsl:call-template name="button">
                <xsl:with-param name="label">Logout</xsl:with-param>
                <xsl:with-param name="action">javascript:logout();</xsl:with-param>
                <xsl:with-param name="small">1</xsl:with-param>
                <xsl:with-param name="gutter-shadow">999980</xsl:with-param>
                <xsl:with-param name="gutter-hilite">FFFFE6</xsl:with-param>
                <xsl:with-param name="edge-shadow">999980</xsl:with-param>
                <xsl:with-param name="edge-hilite">FFFFE6</xsl:with-param>
                <xsl:with-param name="base">CCCCB3</xsl:with-param>
              </xsl:call-template>
            </TD>
            </xsl:if>
          </TR>
        </TABLE>
      </TD></TR>
    </TABLE>
  </xsl:template>

  <xsl:template name="vmHeader">
    <xsl:param name="states"><off/><suspend/><on/><reset/></xsl:param>
    <xsl:param name="stats"><none/></xsl:param>
    <xsl:param name="config"><none/></xsl:param>
    <xsl:variable name="rowspan">
      <xsl:choose>
        <xsl:when test="$stats/cpu-active">2</xsl:when>
        <xsl:when test="$stats/ram-active">2</xsl:when>
        <xsl:when test="$stats/net">2</xsl:when>
        <xsl:otherwise>1</xsl:otherwise>
      </xsl:choose>
    </xsl:variable>
    <TR bgcolor="#CCCCB3">
      <xsl:if test="not(/server/mui@layout='new')">
        <TD rowspan="{$rowspan}" width="1%" valign="bottom" nowrap="true"><NOBR><IMG src="{$imx}spacer.gif" width="15" height="15"/></NOBR></TD>
      </xsl:if>
      <xsl:if test="$states/off">
        <TD rowspan="{$rowspan}" width="1%" align="center" valign="bottom" nowrap="true"><NOBR><IMG src="{$common.imx}POWEROFF_header.gif" width="15" height="15" border="0"/></NOBR></TD>
      </xsl:if>
      <xsl:if test="$states/suspend">
        <TD rowspan="{$rowspan}" width="1%" align="center" valign="bottom" nowrap="true"><NOBR><IMG src="{$common.imx}SUSPEND_header.gif" width="15" height="15" border="0"/></NOBR></TD>
      </xsl:if>
      <xsl:if test="$states/on">
        <TD rowspan="{$rowspan}" width="1%" align="center" valign="bottom" nowrap="true"><NOBR><IMG src="{$common.imx}POWERON_header.gif" width="15" height="15" border="0"/></NOBR></TD>
      </xsl:if>
      <xsl:if test="not(/server/mui@layout='new')">
        <xsl:if test="$states/reset">
          <TD rowspan="{$rowspan}" width="1%" align="center" valign="bottom" nowrap="true"><NOBR><IMG src="{$common.imx}RESET_header.gif" width="15" height="15" border="0"/></NOBR></TD>
        </xsl:if>
      </xsl:if>
      <TD rowspan="{$rowspan}" valign="bottom" nowrap="true"><NOBR><SMALL>Virtual Machine</SMALL></NOBR></TD>
      <TD rowspan="{$rowspan}" colspan="3" width="1%" align="center" valign="bottom" nowrap="true"><NOBR><SMALL>Rights</SMALL></NOBR></TD>
      <xsl:if test="$stats/heartbeat">
        <TD rowspan="{$rowspan}" colspan="2" width="1%" align="center" valign="bottom" nowrap="true"><NOBR><SMALL>%HB</SMALL></NOBR></TD>
      </xsl:if>
      <xsl:if test="$stats/uptime">
        <TD rowspan="{$rowspan}" width="1%" align="center" valign="bottom" nowrap="true"><NOBR><SMALL>Up Time</SMALL></NOBR></TD>
      </xsl:if>
      <xsl:choose>
        <xsl:when test="$rowspan&gt;1">
          <TD colspan="3" width="1%" align="center" nowrap="true"><NOBR><SMALL><SMALL>CPU</SMALL></SMALL></NOBR></TD>
          <TD colspan="5" width="1%" align="center" nowrap="true"><NOBR><SMALL><SMALL>RAM</SMALL></SMALL></NOBR></TD>
          <xsl:if test="/server/system/nfshaper = '1'">
            <TD colspan="2" width="1%" align="center" nowrap="true"><NOBR><SMALL><SMALL>Network</SMALL></SMALL></NOBR></TD>
          </xsl:if>
        </xsl:when>
        <xsl:otherwise>
          <xsl:if test="$stats/cpu">
            <TD colspan="2" width="1%" align="center" nowrap="true"><NOBR><SMALL>% CPU</SMALL></NOBR></TD>
          </xsl:if>
          <xsl:if test="$stats/ram">
            <TD colspan="2" width="1%" align="center" nowrap="true"><NOBR><SMALL>% RAM</SMALL></NOBR></TD>
          </xsl:if>
        </xsl:otherwise>
      </xsl:choose>
      <xsl:if test="$config/ip">
        <TD rowspan="{$rowspan}" width="1%" align="center" valign="bottom" nowrap="true"><NOBR><SMALL>IP Address</SMALL></NOBR></TD>
      </xsl:if>
      <xsl:if test="$config/os">
        <TD rowspan="{$rowspan}" width="1%" align="center" valign="bottom" nowrap="true"><NOBR><SMALL>Guest OS</SMALL></NOBR></TD>
      </xsl:if>
      <xsl:if test="$config/memsize">
        <TD rowspan="{$rowspan}" width="1%" align="center" valign="bottom" nowrap="true"><NOBR><SMALL>Memory</SMALL></NOBR></TD>
      </xsl:if>
      <xsl:if test="$stats/mem-chart">
        <TD rowspan="{$rowspan}" width="1%" align="center" valign="bottom" nowrap="true"><NOBR><SMALL>Total</SMALL></NOBR></TD>
        <TD rowspan="{$rowspan}" align="center" valign="bottom" nowrap="true"><NOBR><SMALL>Memory Allocation</SMALL></NOBR></TD>
      </xsl:if>
    </TR>
    <xsl:if test="$rowspan&gt;1">
      <TR bgcolor="#CCCCB3">
        <xsl:if test="$stats/cpu">
          <TD colspan="2" width="1%" align="center" nowrap="true"><NOBR><SMALL><SMALL>% Granted</SMALL></SMALL></NOBR></TD>
        </xsl:if>
        <xsl:if test="$stats/cpu-active">
          <TD width="1%" align="center" nowrap="true"><NOBR><SMALL><SMALL>Shares</SMALL></SMALL></NOBR></TD>
        </xsl:if>
        <xsl:if test="$stats/ram">
          <TD colspan="3" width="1%" align="center" nowrap="true"><NOBR><SMALL><SMALL>MB Granted</SMALL></SMALL></NOBR></TD>
        </xsl:if>
        <xsl:if test="$stats/ram-active">
          <TD colspan="2" width="1%" align="center" nowrap="true"><NOBR><SMALL><SMALL>MB Active</SMALL></SMALL></NOBR></TD>
        </xsl:if>
        <xsl:if test="$stats/net">
          <TD colspan="2" width="1%" align="center" nowrap="true"><NOBR><SMALL><SMALL>bps Active</SMALL></SMALL></NOBR></TD>
        </xsl:if>
      </TR>
    </xsl:if>
  </xsl:template>

  <xsl:template name="vmRow">
    <xsl:param name="position"/>
    <xsl:param name="states"><off/><suspend/><on/><reset/></xsl:param>
    <xsl:param name="stats"><none/></xsl:param>
    <xsl:param name="config"><none/></xsl:param>
    <xsl:param name="disable"><none/></xsl:param>
    <xsl:param name="vm_script_name">/details</xsl:param>

    <xsl:variable name="vmi">vm<xsl:value-of select="$position - 1"/></xsl:variable>
    <xsl:variable name="qvm">'<xsl:value-of select="$position - 1"/>'</xsl:variable>
    <xsl:variable name="ivm"><xsl:value-of select="$position - 1"/></xsl:variable>
    <xsl:variable name="state"><xsl:value-of select="/server/vm[position()=$position]/state"/></xsl:variable>
    <xsl:variable name="cfg"><xsl:value-of select="/server/vm[position()=$position]/safe_cfg"/></xsl:variable>
    <xsl:variable name="unreachable">
      <xsl:choose>
        <xsl:when test="$state='-1' or $state='4'">1</xsl:when>
        <xsl:otherwise>0</xsl:otherwise>
      </xsl:choose>
    </xsl:variable>
    <xsl:variable name="readonly">
      <xsl:choose>
        <xsl:when test="not(/server/vm[position()=$position]/capabilities/execute)">1</xsl:when>
        <xsl:otherwise>0</xsl:otherwise>
      </xsl:choose>
    </xsl:variable>
    <xsl:variable name="softable">
      <xsl:choose>
        <xsl:when test="/server/vm[position()=$position]/guest/state='running' and /server/vm[position()=$position]/guest/tools/softPowerCapable='1' and /server/vm[position()=$position]/guest/tools/softPowerPending='0'">1</xsl:when>
        <xsl:otherwise>0</xsl:otherwise>
      </xsl:choose>
    </xsl:variable>
    <xsl:variable name="poweroff">
      <xsl:choose>
        <xsl:when test="$state='0'"><xsl:value-of select="$common.imx"/>POWEROFF_rb-2.gif</xsl:when>
        <xsl:when test="$readonly='1'"><xsl:value-of select="$common.imx"/>POWEROFF_rb-3.gif</xsl:when>
        <xsl:when test="$state='1' and $softable='1'"><xsl:value-of select="$common.imx"/>POWEROFF_rb-0.gif</xsl:when>
        <xsl:otherwise><xsl:value-of select="$common.imx"/>POWEROFF_rb-3.gif</xsl:otherwise>
      </xsl:choose>
    </xsl:variable>
    <xsl:variable name="vmResumed"><xsl:value-of select="/server/vm[position()=$position]/state@resumed"/></xsl:variable>
    <xsl:variable name="vmResumeRepeatable"><xsl:value-of select="/server/vm[position()=$position]/resume.repeatable"/></xsl:variable>
    <xsl:variable name="suspend">
      <xsl:choose>
        <xsl:when test="$state='2'"><xsl:value-of select="$common.imx"/>SUSPEND_rb-2.gif</xsl:when>
        <xsl:when test="$readonly='1'"><xsl:value-of select="$common.imx"/>SUSPEND_rb-3.gif</xsl:when>
        <xsl:when test="$vmResumed='true' and $vmResumeRepeatable='true'"><xsl:value-of select="$common.imx"/>SUSPEND_rb-3.gif</xsl:when>
        <xsl:when test="$state='1'"><xsl:value-of select="$common.imx"/>SUSPEND_rb-0.gif</xsl:when>
        <xsl:otherwise><xsl:value-of select="$common.imx"/>SUSPEND_rb-3.gif</xsl:otherwise>
      </xsl:choose>
    </xsl:variable>
    <xsl:variable name="poweron">
      <xsl:choose>
        <xsl:when test="$state='1'"><xsl:value-of select="$common.imx"/>POWERON_rb-2.gif</xsl:when>
        <xsl:when test="$readonly='1'"><xsl:value-of select="$common.imx"/>POWERON_rb-3.gif</xsl:when>
        <xsl:when test="$state='0' or $state='2'"><xsl:value-of select="$common.imx"/>POWERON_rb-0.gif</xsl:when>
        <xsl:otherwise><xsl:value-of select="$common.imx"/>POWERON_rb-3.gif</xsl:otherwise>
      </xsl:choose>
    </xsl:variable>
    <xsl:variable name="reset">
      <xsl:choose>
        <xsl:when test="$readonly='1'"><xsl:value-of select="$common.imx"/>RESET_rb-3.gif</xsl:when>
        <xsl:when test="$state='1' and $softable='1'"><xsl:value-of select="$common.imx"/>RESET_rb-0.gif</xsl:when>
        <xsl:otherwise><xsl:value-of select="$common.imx"/>RESET_rb-3.gif</xsl:otherwise>
      </xsl:choose>
    </xsl:variable>
    <xsl:variable name="remote">
      <xsl:choose>
        <xsl:when test="$state='-1'"><xsl:value-of select="$common.imx"/>rd-0.gif</xsl:when>
        <xsl:otherwise><xsl:value-of select="$common.imx"/>rd-0.gif</xsl:otherwise>
      </xsl:choose>
    </xsl:variable>

    <INPUT type="hidden" name="vm" value="{$cfg}"/>
    <INPUT type="hidden" name="vmState" value="{$state}"/>
    <INPUT type="hidden" name="vmSoftable" value="{$softable}"/>
    <INPUT type="hidden" name="mode" value="{/server/vm[position()=$position]/capabilities@mode}"/>
    <INPUT type="hidden" name="vmResumed" value="{$vmResumed}"/>
    <INPUT type="hidden" name="vmResumeRepeatable" value="{$vmResumeRepeatable}"/>
    <TR id="{$vmi}.row" style="background-color:FFFFE6;">
      <xsl:variable name="upMenu">if(isLoaded()){ctrlMenu[
        <xsl:choose>
          <xsl:when test="$readonly='1'">4</xsl:when>
          <xsl:when test="$unreachable='1'">5</xsl:when>
          <xsl:when test="$softable='1'">3</xsl:when>
          <xsl:otherwise><xsl:value-of select="$state"/></xsl:otherwise>
        </xsl:choose>
        ].up(event,<xsl:value-of select="$ivm"/>,'<xsl:value-of select="$vmi"/>.6','<xsl:value-of select="$common.imx"/>rd-1.gif');}
      </xsl:variable>
      <xsl:if test="not(/server/mui@layout='new')">
        <!-- rbosch: must specify width (instead of 1%) because of position:absolute -->
        <TD width="17" valign="top" nowrap="true"><NOBR>
          <xsl:choose>
            <xsl:when test="/server/vm[position()=$position]@type='console'">&nbsp;</xsl:when>
            <xsl:otherwise>
              <A href="javascript:console({$ivm});" onMouseOver="{$upMenu}"><IMG name="{$vmi}.6" id="{$vmi}.6" src="{$remote}" width="17" height="17" border="0">
                <xsl:if test="/server/agent = 'ie' or /server/agent/@version &gt;= 5">
                  <xsl:attribute name="style">
                    position:absolute;
                  </xsl:attribute>
                </xsl:if>
              </IMG></A>
            </xsl:otherwise>
          </xsl:choose>
        </NOBR></TD>
      </xsl:if>
      <xsl:if test="$states/off">
        <TD width="1%" valign="top" nowrap="true"><NOBR>
         <xsl:choose>
           <xsl:when test="not(/server/mui@layout='new')">
            <A href="javascript:poweroff({$ivm});" onmouseover="return prelightVM({$qvm},POWEROFF);" onmouseout="return postlightVM({$qvm},POWEROFF);"><IMG name="{$vmi}.0" src="{$poweroff}" width="17" height="17" border="0"/></A>
           </xsl:when>
           <xsl:otherwise>
             <IMG name="{$vmi}.0" src="{$poweroff}" width="17" height="17" border="0"/>
           </xsl:otherwise>
         </xsl:choose>
         </NOBR></TD>
      </xsl:if>
      <xsl:if test="$states/suspend">
        <TD width="1%" valign="top" nowrap="true"><NOBR>
        <xsl:choose>
          <xsl:when test="not(/server/mui@layout='new')">
           <A href="javascript:suspend({$ivm});" onmouseover="return prelightVM({$qvm},SUSPEND);" onmouseout="return postlightVM({$qvm},SUSPEND);"><IMG name="{$vmi}.2" src="{$suspend}" width="17" height="17" border="0"/></A>
          </xsl:when>
           <xsl:otherwise>
             <IMG name="{$vmi}.2" src="{$suspend}" width="17" height="17" border="0"/>
           </xsl:otherwise>
         </xsl:choose>
         </NOBR></TD>
      </xsl:if>
      <xsl:if test="$states/on">
        <TD width="1%" valign="top" nowrap="true"><NOBR>
         <xsl:choose>
          <xsl:when test="not(/server/mui@layout='new')">
            <A href="javascript:poweron({$ivm});" onmouseover="return prelightVM({$qvm},POWERON);" onmouseout="return postlightVM({$qvm},POWERON);"><IMG name="{$vmi}.1" src="{$poweron}" width="17" height="17" border="0"/></A>
          </xsl:when>
          <xsl:otherwise>
            <IMG name="{$vmi}.1" src="{$poweron}" width="17" height="17" border="0"/>
          </xsl:otherwise>
         </xsl:choose>
        </NOBR></TD>
      </xsl:if>
      <xsl:if test="not(/server/mui@layout='new')">
        <xsl:if test="$states/reset">
          <TD width="1%" valign="top" nowrap="true"><NOBR><A href="javascript:reset({$ivm});" onmouseover="return prelightVM({$qvm},RESET);" onmouseout="return postlightVM({$qvm},RESET);"><IMG name="{$vmi}.3" src="{$reset}" width="17" height="17" border="0"/></A></NOBR></TD>
        </xsl:if>
      </xsl:if>
      <TD><SMALL>
        <xsl:choose>
          <xsl:when test="/server/vm[position()=$position]@type='console'">
            <xsl:variable name="vmid" select="/server/vm[position()=$position]/@id"/>
            Console OS (<xsl:value-of select="$vmid"/>)
            <xsl:if test="$vm_script_name = '/resources/editor' and (/server/mui@layout='new')"><BR/><NOBR><SMALL><A href="{$vm_script_name}?c={$vmid}&amp;mui=new">Edit Resources</A></SMALL></NOBR></xsl:if>
            <xsl:if test="$vm_script_name = '/resources/editor' and not(/server/mui@layout='new')"><BR/><NOBR><SMALL><A href="{$vm_script_name}?c={$vmid}">Edit Resources</A></SMALL></NOBR></xsl:if>
          </xsl:when>
          <xsl:otherwise>
            <xsl:variable name="win32_suffix">
              <xsl:if test="/server/host@os = 'MSWin32'">/index.pl</xsl:if>
            </xsl:variable>
            <xsl:variable name="link_title">
              <xsl:if test="not(/server/vm[position()=$position]/displayName=/server/vm[position()=$position]@cfg)">
                <xsl:value-of select="/server/vm[position()=$position]/displayName"/><xsl:text>&#10;</xsl:text>
              </xsl:if>
              <xsl:value-of select="/server/host"/><xsl:if test="/server/host@domain">.<xsl:value-of select="/server/host@domain"/></xsl:if>:<xsl:value-of select="/server/vm[position()=$position]@cfg"/>
            </xsl:variable>
            <xsl:if test="/server/mui@layout='new'">
               <A href="javascript:parent.openNewMuiTab('details', '{$cfg}', 'memory');" title="{$link_title}">
                 <xsl:value-of select="/server/vm[position()=$position]/displayName"/>
               </A>
            </xsl:if>
            <xsl:if test="not(/server/mui@layout='new')">
               <A href="/details{$win32_suffix}?c={$cfg}" title="{$link_title}"><xsl:value-of select="/server/vm[position()=$position]/displayName"/></A>
            </xsl:if>
            <xsl:if test="/server/vm[position()=$position]/@pid or /server/vm[position()=$position]/@id">
              <xsl:text> </xsl:text>
              <small>
                (<xsl:if test="/server/vm[position()=$position]/@pid">PID: <xsl:value-of select="/server/vm[position()=$position]@pid"/></xsl:if>
                <xsl:if test="/server/product@id='ESX' and /server/vm[position()=$position]/@id">
                  <xsl:if test="/server/vm[position()=$position]/@pid">, </xsl:if>VMID: <xsl:value-of select="/server/vm[position()=$position]/@id"/>
                </xsl:if>)
              </small>
            </xsl:if>
            <xsl:if test="$vm_script_name = '/resources/editor' and not(/server/mui@layout='new')"><BR/><NOBR><SMALL><A href="{$vm_script_name}?c={$cfg}">Edit Resources</A></SMALL></NOBR></xsl:if>
          </xsl:otherwise>
        </xsl:choose>
        <xsl:if test="$softable='0' and $state='1'"><BR /><SMALL>
          <xsl:choose>
            <xsl:when test="/server/vm[position()=$position]/guest/state='halting' or /server/vm[position()=$position]/guest/state='rebooting' or /server/vm[position()=$position]/guest/state='halting/rebooting'">
              The guest OS is shutting down or rebooting.
            </xsl:when>
            <xsl:when test="/server/vm[position()=$position and not(@type='console')]">
              Server tools not available.
            </xsl:when>
          </xsl:choose>
        </SMALL></xsl:if>
        <xsl:if test="not($disable/needinput) and /server/vm[position()=$position]/question"><SMALL>
          <xsl:for-each select="/server/vm[position()=$position]/question">
            <xsl:variable name="id" select="@id"/>
            <BR />Waiting for input: <A href="/eventlog?c={$cfg}">View event log.</A>
          </xsl:for-each>
        </SMALL></xsl:if>
        <xsl:if test="/server/vm[position()=$position]/error"><SMALL>
          <xsl:for-each select="/server/vm[position()=$position]/error">
            <BR />Error: <xsl:value-of select="."/>
          </xsl:for-each>
        </SMALL></xsl:if>
      </SMALL></TD>
      <TD width="1%">
          <xsl:choose>
            <xsl:when test="/server/vm[position()=$position and @type='console']">
              <xsl:attribute name="colspan">3</xsl:attribute>
              <xsl:attribute name="align">center</xsl:attribute>
            </xsl:when>
            <xsl:otherwise/>
          </xsl:choose>
        <SMALL><TT><xsl:choose>
          <xsl:when test="/server/vm[position()=$position and @type='console']">
            <TT class="xs"><FONT color="#999999">N/A</FONT></TT>
          </xsl:when>
          <xsl:when test="/server/vm[position()=$position]/capabilities/read">r</xsl:when>
          <xsl:otherwise>-</xsl:otherwise>
        </xsl:choose></TT></SMALL>
      </TD>
      <xsl:if test="not(/server/vm[position()=$position and @type='console'])">
        <TD width="1%"><SMALL><TT>
          <xsl:choose>
            <xsl:when test="/server/vm[position()=$position]/capabilities/write">w</xsl:when>
            <xsl:otherwise>-</xsl:otherwise>
          </xsl:choose>
        </TT></SMALL></TD>
        <TD width="1%"><SMALL><TT>
          <xsl:choose>
            <xsl:when test="/server/vm[position()=$position]/capabilities/execute">x</xsl:when>
            <xsl:otherwise>-</xsl:otherwise>
          </xsl:choose>
        </TT></SMALL></TD>
      </xsl:if>
      <xsl:if test="$stats/heartbeat">
        <xsl:variable name="hb">
          <xsl:choose>
            <xsl:when test="/server/vm[position()=$position]/stat[@name='heartbeat']/usage[@type='sum']">
              <xsl:value-of select="/server/vm[position()=$position]/stat[@name='heartbeat']/usage[@type='sum']/sample[@interval='1']"/>
            </xsl:when>
            <xsl:otherwise>
              <xsl:value-of select="/server/vm[position()=$position]/stat[@name='heartbeat']/usage[@type='avg']/sample[@interval='1']"/>
            </xsl:otherwise>
          </xsl:choose>
        </xsl:variable>
        <TD width="1%" align="right"><SMALL><TT>
          <xsl:choose>
            <xsl:when test="not(/server/vm[position()=$position]/guest/state = 'running')">
              &nbsp;&nbsp;<FONT color="#999999">0</FONT>
            </xsl:when>
            <xsl:otherwise>
              <xsl:if test="$hb&lt;10">&nbsp;&nbsp;</xsl:if>
              <xsl:if test="$hb&lt;100">&nbsp;</xsl:if>
              <xsl:value-of select="$hb"/>
            </xsl:otherwise>
          </xsl:choose>
        </TT></SMALL></TD>
        <TD width="1%" align="center">
          <xsl:choose>
            <xsl:when test="$softable='1'">
              <xsl:call-template name="usage_bar">
                <xsl:with-param name="sample" select="$hb"/>
                <xsl:with-param name="denominator" select="5"/>
              </xsl:call-template>
            </xsl:when>
            <xsl:otherwise>
              <xsl:call-template name="disabled_bar">
                <xsl:with-param name="denominator" select="5"/>
              </xsl:call-template>
            </xsl:otherwise>
          </xsl:choose>
        </TD>
      </xsl:if>
      <xsl:if test="$stats/uptime">
        <TD width="1%" nowrap="true"><NOBR><SMALL><TT>
<!--          <xsl:value-of select="/server/vm[position()=$position]/uptime/days"/>d-->
<!--          <xsl:value-of select="/server/vm[position()=$position]/uptime/hours"/>h-->
<!--          <xsl:value-of select="/server/vm[position()=$position]/uptime/minutes"/>m-->
          <xsl:choose>
            <xsl:when test="/server/vm[position()=$position]/uptime and number(/server/vm[position()=$position]/uptime/days)&lt;10"><FONT color="#FFFFE6">&nbsp;&nbsp;</FONT><xsl:value-of select="/server/vm[position()=$position]/uptime/days"/>d&nbsp;</xsl:when>
            <xsl:when test="/server/vm[position()=$position]/uptime and number(/server/vm[position()=$position]/uptime/days)&lt;100"><FONT color="#FFFFE6">&nbsp;</FONT><xsl:value-of select="/server/vm[position()=$position]/uptime/days"/>d&nbsp;</xsl:when>
            <xsl:when test="/server/vm[position()=$position]/uptime and number(/server/vm[position()=$position]/uptime/days)&gt;99"><xsl:value-of select="/server/vm[position()=$position]/uptime/days"/>d&nbsp;</xsl:when>
            <xsl:otherwise>&nbsp;&nbsp;<FONT color="#999999">0d&nbsp;</FONT></xsl:otherwise>
          </xsl:choose>
          <xsl:choose>
            <xsl:when test="/server/vm[position()=$position]/uptime and number(/server/vm[position()=$position]/uptime/hours)&lt;10"><FONT color="#FFFFE6">&nbsp;</FONT><xsl:value-of select="/server/vm[position()=$position]/uptime/hours"/>h&nbsp;</xsl:when>
            <xsl:when test="/server/vm[position()=$position]/uptime and number(/server/vm[position()=$position]/uptime/hours)&gt;9"><xsl:value-of select="/server/vm[position()=$position]/uptime/hours"/>h&nbsp;</xsl:when>
            <xsl:otherwise><FONT color="#999999">&nbsp;0h&nbsp;</FONT></xsl:otherwise>
          </xsl:choose>
          <xsl:choose>
            <xsl:when test="/server/vm[position()=$position]/uptime and number(/server/vm[position()=$position]/uptime/minutes)&lt;10">&nbsp;<xsl:value-of select="/server/vm[position()=$position]/uptime/minutes"/>m</xsl:when>
            <xsl:when test="/server/vm[position()=$position]/uptime and number(/server/vm[position()=$position]/uptime/minutes)&gt;9"><xsl:value-of select="/server/vm[position()=$position]/uptime/minutes"/>m</xsl:when>
            <xsl:otherwise><FONT color="#999999">&nbsp;0m</FONT></xsl:otherwise>
          </xsl:choose>
        </TT></SMALL></NOBR></TD>
      </xsl:if>
      <xsl:if test="$stats/cpu">
        <xsl:variable name="cpu"><xsl:value-of select="/server/vm[position()=$position]/stat[@name='cpu']/usage[@type='avg']/sample[@interval='1']"/></xsl:variable>
        <TD width="1%" align="right"><SMALL><TT>
<!--          <xsl:value-of select="$cpu"/>-->
          <xsl:choose>
            <xsl:when test="not(/server/vm[position()=$position]/stat[@name='cpu'])">
              &nbsp;<FONT color="#999999">0</FONT>
            </xsl:when>
            <xsl:otherwise>
              <xsl:if test="$cpu&lt;10">&nbsp;</xsl:if>
              <xsl:value-of select="$cpu"/>
            </xsl:otherwise>
          </xsl:choose>
        </TT></SMALL></TD>
        <TD width="1%">
          <xsl:choose>
            <xsl:when test="/server/vm[position()=$position]/stat[@name='cpu']">
              <xsl:call-template name="usage_bar">
                <xsl:with-param name="sample" select="$cpu"/>
                <xsl:with-param name="denominator">
                  <xsl:choose>
                    <xsl:when test="$stats/cpu-active">3</xsl:when>
                    <xsl:otherwise>2</xsl:otherwise>
                  </xsl:choose>
                </xsl:with-param>
              </xsl:call-template>
            </xsl:when>
            <xsl:otherwise>
              <xsl:call-template name="disabled_bar">
                <xsl:with-param name="denominator">
                  <xsl:choose>
                    <xsl:when test="$stats/cpu-active">3</xsl:when>
                    <xsl:otherwise>2</xsl:otherwise>
                  </xsl:choose>
                </xsl:with-param>
              </xsl:call-template>
            </xsl:otherwise>
          </xsl:choose>
        </TD>
      </xsl:if>
      <xsl:if test="$stats/cpu-active">
        <xsl:variable name="cpu"><xsl:value-of select="/server/vm[position()=$position]/stat[@name='cpu-active' and @units='shares']/usage[@type='avg']/sample[@interval='1']"/></xsl:variable>
        <xsl:variable name="percent_cpu"><xsl:value-of select="/server/vm[position()=$position]/stat[@name='cpu-active' and @units='percent']/usage[@type='avg']/sample[@interval='1']"/></xsl:variable>
        <TD width="1%" align="right"><SMALL><TT>
          <xsl:choose>
            <xsl:when test="/server/vm[position()=$position]/cpu/shares">
              <xsl:value-of select="/server/vm[position()=$position]/cpu/shares"/>
            </xsl:when>
            <xsl:otherwise>
              &nbsp;<FONT color="#999999">0</FONT>
            </xsl:otherwise>
          </xsl:choose>
        </TT></SMALL></TD>
      </xsl:if>
      <xsl:if test="$stats/ram">
        <xsl:variable name="ram"><xsl:value-of select="/server/vm[position()=$position]/stat[@name='ram' and @units='MB']/usage[@type='avg']/sample[@interval='1']"/></xsl:variable>
        <xsl:variable name="percent_ram"><xsl:value-of select="/server/vm[position()=$position]/stat[@name='ram' and @units='percent']/usage[@type='avg']/sample[@interval='1']"/></xsl:variable>
        <TD width="1%" align="right"><SMALL><TT>
<!--          <xsl:value-of select="ram"/>-->
          <xsl:choose>
            <xsl:when test="not(/server/vm[position()=$position]/stat[@name='ram'])">
              &nbsp;<FONT color="#999999">0</FONT>
            </xsl:when>
            <xsl:otherwise>
              <xsl:choose>
                <xsl:when test="not(/server/vm[position()=$position]/stat[@name='ram' and @units='MB'])">
                  <xsl:if test="$percent_ram&lt;10">&nbsp;</xsl:if>
                  <xsl:value-of select="$percent_ram"/>
                </xsl:when>
                <xsl:otherwise>
                  <xsl:if test="$ram&lt;10">&nbsp;</xsl:if>
                  <xsl:value-of select="$ram"/>
                </xsl:otherwise>
              </xsl:choose>
            </xsl:otherwise>
          </xsl:choose>
        </TT></SMALL></TD>
        <xsl:if test="$stats/ram-active">
          <TD align="center" width="1%">
            <TABLE border="0" cellpadding="0" cellspacing="1" width="5" height="13">
              <TR>
                <TD width="5" height="5"><IMG width="5" height="5">
                  <xsl:attribute name="src">
                    <xsl:choose>
                      <xsl:when test="/server/vm[position()=$position]/memory/wait_status='yes'"><xsl:value-of select="$imx"/>CC0000.png</xsl:when>
                      <xsl:otherwise><xsl:value-of select="$imx"/>spacer.gif</xsl:otherwise>
                    </xsl:choose>
                  </xsl:attribute>
                </IMG></TD>
              </TR>
              <TR>
                <TD width="5" height="5"><IMG width="5" height="5">
                  <xsl:attribute name="src">
                    <xsl:choose>
                      <xsl:when test="/server/vm[position()=$position]/memory/status='dynamic'">
                        <xsl:choose>
                          <xsl:when test="/server/vm[position()=$position]/memory/wait_status='yes'"><xsl:value-of select="$imx"/>CCCCCC.png</xsl:when>
                          <xsl:otherwise><xsl:value-of select="$imx"/>000000.png</xsl:otherwise>
                        </xsl:choose>
                      </xsl:when>
                      <xsl:otherwise><xsl:value-of select="$imx"/>spacer.gif</xsl:otherwise>
                    </xsl:choose>
                  </xsl:attribute>
                </IMG></TD>
              </TR>
            </TABLE>
          </TD>
        </xsl:if>
        <TD width="1%">
          <xsl:choose>
            <xsl:when test="/server/vm[position()=$position]/stat[@name='ram' and @units='percent']">
              <xsl:call-template name="usage_bar">
                <xsl:with-param name="sample" select="$percent_ram"/>
                <xsl:with-param name="denominator">
                  <xsl:choose>
                    <xsl:when test="$stats/ram-active">3</xsl:when>
                    <xsl:otherwise>2</xsl:otherwise>
                  </xsl:choose>
                </xsl:with-param>
              </xsl:call-template>
            </xsl:when>
            <xsl:otherwise>
              <xsl:call-template name="disabled_bar">
                <xsl:with-param name="denominator">
                  <xsl:choose>
                    <xsl:when test="$stats/ram-active">3</xsl:when>
                    <xsl:otherwise>2</xsl:otherwise>
                  </xsl:choose>
                </xsl:with-param>
              </xsl:call-template>
            </xsl:otherwise>
          </xsl:choose>
        </TD>
      </xsl:if>
      <xsl:if test="$stats/ram-active">
        <xsl:variable name="ram"><xsl:value-of select="/server/vm[position()=$position]/stat[@name='ram-active' and @units='MB']/usage[@type='avg']/sample[@interval='1']"/></xsl:variable>
        <xsl:variable name="percent_ram"><xsl:value-of select="/server/vm[position()=$position]/stat[@name='ram-active' and @units='percent']/usage[@type='avg']/sample[@interval='1']"/></xsl:variable>
        <TD width="1%" align="right"><SMALL><TT>
          <xsl:choose>
            <xsl:when test="/server/vm[position()=$position and @type='console']">
              <TT><FONT color="#999999">N/A</FONT></TT>
            </xsl:when>
            <xsl:when test="not(/server/vm[position()=$position]/stat[@name='ram-active'])">
              &nbsp;<FONT color="#999999">0</FONT>
            </xsl:when>
            <xsl:otherwise>
              <xsl:if test="$ram&lt;10">&nbsp;</xsl:if>
              <xsl:value-of select="$ram"/>
              <xsl:if test="/server/vm[position()=$position]/stat[@name='ram' and @units='MB']">/<TT><xsl:value-of select="/server/vm[position()=$position]/stat[@name='ram' and @units='MB']/usage[@type='avg']/sample[@interval='1']"/></TT></xsl:if>
            </xsl:otherwise>
          </xsl:choose>
        </TT></SMALL></TD>
        <TD width="1%">
          <xsl:choose>
            <xsl:when test="/server/vm[position()=$position and @type='console']">
              <xsl:call-template name="disabled_bar">
                <xsl:with-param name="denominator" select="3"/>
              </xsl:call-template>
            </xsl:when>
            <xsl:when test="/server/vm[position()=$position]/stat[@name='ram']">
              <xsl:call-template name="usage_bar">
                <xsl:with-param name="sample" select="$percent_ram"/>
                <xsl:with-param name="denominator" select="3"/>
              </xsl:call-template>
            </xsl:when>
            <xsl:otherwise>
              <xsl:call-template name="disabled_bar">
                <xsl:with-param name="denominator" select="3"/>
              </xsl:call-template>
            </xsl:otherwise>
          </xsl:choose>
        </TD>
      </xsl:if>
      <xsl:if test="$stats/net">
        <xsl:variable name="net"><xsl:value-of select="/server/vm[position()=$position]/stat[@name='net' and @units='kbps']/usage[@type='avg']/sample[@interval='1']"/></xsl:variable>
        <xsl:variable name="percent_net"><xsl:value-of select="/server/vm[position()=$position]/stat[@name='net' and @units='percent']/usage[@type='avg']/sample[@interval='1']"/></xsl:variable>
        <TD width="1%" align="right" nowrap="1"><NOBR><SMALL><TT>
          <xsl:choose>
            <xsl:when test="not(/server/vm[position()=$position]/network/filter)">
              <FONT color="#999999"><TT>N/A</TT></FONT>
            </xsl:when>
            <xsl:otherwise>
              <xsl:variable name="net_mb" select="string($net div 1000)"></xsl:variable>
              <xsl:variable name="avg_bps" select="/server/vm[position()=$position]/network/filter/avg_bandwidth"/>
              <!-- The following line is very long for formatting purposes. -->
              <xsl:choose><xsl:when test="$net&lt;1000"><xsl:if test="$net&lt;10">&nbsp;</xsl:if><xsl:value-of select="$net"/>K/</xsl:when><xsl:otherwise><xsl:choose><xsl:when test="not(($net mod 1000)=0)"><xsl:value-of select="substring-before($net_mb, '.')"/>.<xsl:value-of select="substring(substring-after($net_mb, '.'), 1, 2)"/></xsl:when><xsl:otherwise><xsl:value-of select="$net_mb"/></xsl:otherwise></xsl:choose>M/</xsl:otherwise></xsl:choose><TT><xsl:choose><xsl:when test="$avg_bps&lt;1000"><xsl:value-of select="$avg_bps"/></xsl:when><xsl:when test="$avg_bps&lt;(1000*1000)"><xsl:variable name="avg_kbps" select="string($avg_bps div 1000)"/><xsl:choose><xsl:when test="not(($avg_bps mod 1000)=0)"><xsl:value-of select="substring-before($avg_kbps, '.')"/>.<xsl:value-of select="substring(substring-after($avg_kbps, '.'), 1, 2)"/></xsl:when><xsl:otherwise><xsl:value-of select="$avg_kbps"/></xsl:otherwise></xsl:choose>K</xsl:when><xsl:otherwise><xsl:variable name="avg_mbps" select="string($avg_bps div (1000*1000))"/><xsl:choose><xsl:when test="not(($avg_bps mod (1000*1000))=0)"><xsl:value-of select="substring-before($avg_mbps, '.')"/>.<xsl:value-of select="substring(substring-after($avg_mbps, '.'), 1, 2)"/></xsl:when><xsl:otherwise><xsl:value-of select="$avg_mbps"/></xsl:otherwise></xsl:choose>M</xsl:otherwise></xsl:choose></TT>
            </xsl:otherwise>
          </xsl:choose>
        </TT></SMALL></NOBR></TD>
        <TD width="1%">
          <xsl:choose>
            <xsl:when test="/server/vm[position()=$position]/stat[@name='net' and @units='percent'] and /server/vm[position()=$position]/network/filter">
              <xsl:call-template name="usage_bar">
                <xsl:with-param name="sample" select="$percent_net"/>
                <xsl:with-param name="denominator" select="3"/>
              </xsl:call-template>
            </xsl:when>
            <xsl:otherwise>
              <xsl:call-template name="disabled_bar">
                <xsl:with-param name="denominator" select="3"/>
              </xsl:call-template>
            </xsl:otherwise>
          </xsl:choose>
        </TD>
      </xsl:if>
      <xsl:if test="$config/ip">
        <TD width="1%"><SMALL><TT><xsl:value-of select="/server/vm[position()=$position]/ip"/></TT></SMALL></TD>
      </xsl:if>
      <xsl:if test="$config/os">
        <TD width="1%"><SMALL><TT><xsl:value-of select="/server/vm[position()=$position]/os"/></TT></SMALL></TD>
      </xsl:if>
      <xsl:if test="$config/memsize">
        <TD width="1%" align="right"><SMALL><TT><xsl:value-of select="/server/vm[position()=$position]/device[@id='RAM']/param[@name='memSize']"/>&nbsp;MB</TT></SMALL></TD>
      </xsl:if>
      <xsl:if test="$stats/mem-chart">
        <xsl:choose>
          <xsl:when test="/server/vm[position()=$position]/state=1">
            <xsl:call-template name="vm-mem-chart">
              <xsl:with-param name="vm" select="/server/vm[position()=$position]"/>
            </xsl:call-template>
          </xsl:when>
          <xsl:otherwise>
            <TD align="left" colspan="2" nowrap="1"><SMALL>&nbsp;</SMALL></TD>
          </xsl:otherwise>
        </xsl:choose>
      </xsl:if>
    </TR>
  </xsl:template>

  <xsl:template name="vm-mem-chart">
    <xsl:param name="vm"/>
    <xsl:variable name="mem" select="$vm/memory"/>

    <xsl:variable name="active" select="number($mem/active)"/>
    <xsl:variable name="actual" select="number($mem/actual)"/>
    <xsl:variable name="memctl" select="number($mem/memctl/actual)"/>
    <xsl:variable name="swapped" select="number($mem/swap/actual)"/>
    <xsl:variable name="max" select="number($mem/max)"/>
    <xsl:variable name="idle" select="$actual - $active"/>
    <xsl:variable name="unused" select="$max - $actual - $memctl - $swapped"/>
    <!-- 400 pixels wide, scale to fit largest value -->
    <xsl:variable name="scale" select="/server/memory/vm_max div 400"/>

    <TD width="1%" align="right"><SMALL>
      <xsl:value-of select="$max"/>MB
    </SMALL></TD>

    <TD align="left" nowrap="1"><table border="0" cellpadding="0" cellspacing="0"><tr>
      <xsl:variable name="aw" select="round($active div $scale)"/>
      <xsl:variable name="aa">Active: <xsl:value-of select="round($active)"/>MB</xsl:variable>
      <xsl:if test="$aw &gt; 0">
        <td bgcolor="#6699ff">
          <img src="{$imx}spacer.gif" width="{$aw}" height="12" alt="{$aa}"/>
        </td>
      </xsl:if>
           <xsl:variable name="iw" select="round($idle div $scale)"/>
      <xsl:variable name="ia">Idle: <xsl:value-of select="round($idle)"/>MB</xsl:variable>
      <xsl:if test="$iw &gt; 0">
        <td bgcolor="#99ccff">
          <img src="{$imx}spacer.gif" width="{$iw}" height="12" alt="{$ia}"/>
        </td>
      </xsl:if>
           <xsl:variable name="sw" select="round($swapped div $scale)"/>
      <xsl:variable name="sa">Swapped: <xsl:value-of select="round($swapped)"/>MB</xsl:variable>
      <xsl:if test="$sw &gt; 0">
        <td bgcolor="#ff3333" background="{$imx}stripe.gif">
          <img src="{$imx}spacer.gif" width="{$sw}" height="12" alt="{$sa}"/>
        </td>
      </xsl:if>
           <xsl:variable name="mw" select="round($memctl div $scale)"/>
      <xsl:variable name="ma">VMMemCtl: <xsl:value-of select="round($memctl)"/>MB</xsl:variable>
      <xsl:if test="$mw &gt; 0">
        <td bgcolor="#ff9999" background="{$imx}stripe.gif">
          <img src="{$imx}spacer.gif" width="{$mw}" height="12" alt="{$ma}"/>
        </td>
      </xsl:if>
           <xsl:variable name="uw" select="round($unused div $scale)"/>
      <xsl:variable name="ua">Unused: <xsl:value-of select="round($unused)"/>MB</xsl:variable>
      <xsl:if test="$uw &gt; 0">
        <td bgcolor="#cccccc" background="{$imx}stripe.gif">
          <img src="{$imx}spacer.gif" width="{$uw}" height="12" alt="{$ua}"/>
        </td>
      </xsl:if>
    </tr></table></TD>

  </xsl:template>

  <xsl:template name="pageFooter">
    <xsl:param name="disable">
      <none/>
    </xsl:param>
    <xsl:param name="edit" select="0"/>
    <xsl:param name="disable_edit" select="0"/>
    <xsl:param name="delete" select="0"/>
    <xsl:param name="disable_delete" select="0"/>
    <xsl:variable name="win32suffix">
      <xsl:if test="/server/host@os = 'MSWin32'">/index.pl</xsl:if>
    </xsl:variable>

    <TABLE width="100%" border="0" cellpadding="1" cellspacing="0">
      <TR><TD bgcolor="#999980">
        <TABLE width="100%" border="0" cellpadding="3" cellspacing="0">
          <TR bgcolor="#CCCCB3">
            <xsl:if test="not($disable) or not($disable/newvm) and not(/server/mui@layout='new')">
              <TD>
                <xsl:if test="(not($delete='0'))">
                  <xsl:attribute name="width">1%</xsl:attribute>
                </xsl:if>
                <xsl:call-template name="button">
                  <xsl:with-param name="label">
                    <xsl:choose>
                      <xsl:when test="not($edit='0') and not(/server/product@id='GSX')">Edit VM Configuration</xsl:when>
                      <xsl:otherwise>Create VM</xsl:otherwise>
                    </xsl:choose>
                  </xsl:with-param>
                  <xsl:with-param name="action">
                    <xsl:choose>
                      <xsl:when test="(/server/product@id='GSX')">/newvm<xsl:value-of select="$win32suffix"/></xsl:when>
                      <xsl:when test="not($disable_edit='0')"/>
                      <xsl:when test="not($edit='0') and not(/server/product@id='GSX')">/newvm?c=<xsl:value-of select="$edit"/></xsl:when>
                      <xsl:otherwise>/newvm<xsl:value-of select="$win32suffix"/></xsl:otherwise>
                    </xsl:choose>
                  </xsl:with-param>
                  <xsl:with-param name="small">1</xsl:with-param>
                  <xsl:with-param name="gutter-shadow">999980</xsl:with-param>
                  <xsl:with-param name="gutter-hilite">FFFFE6</xsl:with-param>
                  <xsl:with-param name="edge-shadow">999980</xsl:with-param>
                  <xsl:with-param name="edge-hilite">FFFFE6</xsl:with-param>
                  <xsl:with-param name="base">CCCCB3</xsl:with-param>
                  <xsl:with-param name="text">
                    <xsl:choose>
                      <xsl:when test="not($disable_edit='0') and not(/server/product@id='GSX')">999999</xsl:when>
                      <xsl:otherwise/>
                    </xsl:choose>
                  </xsl:with-param>
                </xsl:call-template>
              </TD>
            </xsl:if>
	    <xsl:if test="(not($delete='0')) and not(/server/product@id='GSX')">
	      <TD width="1%">
	        <xsl:call-template name="button">
	          <xsl:with-param name="label">
	            Edit VM Resources
	          </xsl:with-param>
		  <xsl:with-param name="action">
		    /resources/editor?c=<xsl:value-of select="$edit"/>
		  </xsl:with-param>
		  <xsl:with-param name="small">1</xsl:with-param>
		  <xsl:with-param name="gutter-shadow">999980</xsl:with-param>
		  <xsl:with-param name="gutter-hilite">FFFFE6</xsl:with-param>
		  <xsl:with-param name="edge-shadow">999980</xsl:with-param>
		  <xsl:with-param name="edge-hilite">FFFFE6</xsl:with-param>
		  <xsl:with-param name="base">CCCCB3</xsl:with-param>
	        </xsl:call-template>
              </TD>
            </xsl:if>

	    <xsl:if test="(not($delete='0'))">
              <TD>
                <SCRIPT language="JavaScript">
            <xsl:variable name="win32_suffix">
              <xsl:if test="/server/host@os = 'MSWin32'">/index.pl</xsl:if>
            </xsl:variable>
                  function DeleteVMConfirm()
                  {
                     var vmID;
                     var winSuffix;

                     vmID = '<xsl:value-of select="$delete"/>';
		     winSuffix = '<xsl:value-of select="$win32_suffix"/>';
                     browseWin = window.open('/deletevm'+winSuffix+'?c='+vmID, 'DeleteVM', 'width=600,height=400,resizable,scrollbars');
                     browseWin.clientData = vmID;
                  }
                </SCRIPT>
                <xsl:call-template name="button">
                  <xsl:with-param name="label">
                    Delete VM
                  </xsl:with-param>
                  <xsl:with-param name="action">
                    <xsl:if test="$disable_delete='0'">Javascript:DeleteVMConfirm()</xsl:if>
                  </xsl:with-param>
                  <xsl:with-param name="small">1</xsl:with-param>
                  <xsl:with-param name="gutter-shadow">999980</xsl:with-param>
                  <xsl:with-param name="gutter-hilite">FFFFE6</xsl:with-param>
                  <xsl:with-param name="edge-shadow">999980</xsl:with-param>
                  <xsl:with-param name="edge-hilite">FFFFE6</xsl:with-param>
                  <xsl:with-param name="base">CCCCB3</xsl:with-param>
                  <xsl:with-param name="text">
                    <xsl:choose>
                      <xsl:when test="not($disable_delete='0')">999999</xsl:when>
                      <xsl:otherwise/>
                    </xsl:choose>
                  </xsl:with-param>
                </xsl:call-template>
              </TD>
            </xsl:if>
            <xsl:if test="not(/server/mui@layout='new') and (not($disable) or not($disable/update))">
              <TD width="1%" align="right" nowrap="true">
               <NOBR>
                 <SMALL><SMALL>
                   <SCRIPT>document.write("Last Updated: " + new Date().toString());</SCRIPT>
                 </SMALL></SMALL>
               </NOBR>
              </TD>
              <TD width="1%" align="right">
                <xsl:call-template name="button">
                  <xsl:with-param name="label">Refresh</xsl:with-param>
                  <xsl:with-param name="action">javascript:update();</xsl:with-param>
                  <xsl:with-param name="small">1</xsl:with-param>
                  <xsl:with-param name="gutter-shadow">999980</xsl:with-param>
                  <xsl:with-param name="gutter-hilite">FFFFE6</xsl:with-param>
                  <xsl:with-param name="edge-shadow">999980</xsl:with-param>
                  <xsl:with-param name="edge-hilite">FFFFE6</xsl:with-param>
                  <xsl:with-param name="base">CCCCB3</xsl:with-param>
                </xsl:call-template>
              </TD>
            </xsl:if>
          </TR>
        </TABLE>
      </TD></TR>
    </TABLE>
  </xsl:template>

  <xsl:template name="labelFooter">
    <TABLE width="100%" border="0" cellpadding="0" cellspacing="0">
      <TR>
        <TD align="right" nowrap="true" background="{$theme.imx}footer-bg.gif">
          <NOBR><SMALL><SMALL>&nbsp;</SMALL></SMALL></NOBR>
        </TD>
        <TD width="1%" nowrap="true"><IMG src="{$theme.imx}footer.gif" width="451" height="49"/></TD>
      </TR>
    </TABLE>

    <p align="center"><small><small>&copy; 1998-2006 VMware, Inc. All rights reserved. U.S.<br />
    Protected by one or more of U.S. Patent Nos. 6,397,242, 6,496,847, 6,704,925, 6,711,672, 6,725,289, 6,735,601, 6,785,886, 6,789,156, 6,795,966, 6,880,022 6,961,941, 6,961,806 and 6,944,699; patents pending.
    </small></small></p>
  </xsl:template>

  <xsl:template name="fileUtils">
    <SCRIPT>
      function escapeFileName(dir) {
         var safeDir = escape(dir);
	 safeDir = safeDir.replace(/\+/g, "%2B");
	 safeDir = safeDir.replace(/@/g, "%40");
	 return safeDir;
      }
   </SCRIPT>
  </xsl:template>

  <xsl:template name="usage_bar">
    <xsl:param name="sample"/>
    <xsl:param name="denominator" select="2"/>

    <NOBR>
      <IMG src="{$common.imx}trough-fartail.png" width="1" height="13"/>
      <xsl:if test="number($sample) &gt;= 1">
        <IMG src="{$common.imx}bar-tail.png" width="2" height="13"/>
        <IMG src="{$common.imx}bar-strut.png" width="{ceiling($sample div $denominator)}" height="13"/>
        <IMG src="{$common.imx}bar-head.png" width="2" height="13"/>
        <xsl:if test="not(number($sample) &gt;= 100)">
          <IMG src="{$common.imx}trough-strut.png" width="{ceiling(100 div $denominator) - ceiling(number($sample) div $denominator) - 2}" height="13"/>
        </xsl:if>
      </xsl:if>
      <xsl:if test="not(number($sample) &gt;= 1)">
        <IMG src="{$common.imx}trough-tail.png" width="2" height="13"/>
        <IMG src="{$common.imx}trough-strut.png" width="{ceiling((100 - number($sample)) div $denominator)}" height="13"/>
      </xsl:if>
      <xsl:if test="not(number($sample) &gt;= 100)">
        <IMG src="{$common.imx}trough-head.png" width="2" height="13"/>
      </xsl:if>
      <IMG src="{$common.imx}trough-farhead.png" width="1" height="13"/>
    </NOBR>
  </xsl:template>

  <xsl:template name="disabled_bar">
    <xsl:param name="denominator" select="2"/>

    <NOBR>
      <IMG src="{$common.imx}disabled-tail.gif" width="3" height="13"/>
      <IMG src="{$common.imx}disabled-strut.gif" width="{ceiling(100 div $denominator)}" height="13"/>
      <IMG src="{$common.imx}disabled-head.gif" width="3" height="13"/>
    </NOBR>
  </xsl:template>

  <xsl:template name="error">
    <TABLE border="0" cellpadding="5" cellspacing="0">
      <TR>
        <xsl:variable name="icon">error.gif</xsl:variable>
        <TD rowspan="2" valign="top"><IMG src="{$common.imx}{$icon}" width="32" height="32"/></TD>
        <TD><small><B>Error</B></small></TD>
      </TR>
      <TR>
        <xsl:choose>
          <xsl:when test="/server/error@code='-8' and contains(string(/server/vm/event/body/p),'Failed to allocate memory for VM.')">
            <TD>
              <P><SMALL><xsl:value-of select="/server/vm/event/body/p"/></SMALL></P>
            </TD>
          </xsl:when>
          <xsl:when test='/server/error@code="-8" and /server/error="Invalid operation for virtual machine&apos;s current state"'>
            <TD>
              <P><SMALL>An error occurred while attempting to execute the requested command. Please read the virtual machine's <A href="/eventlog?c={/server/vm@cfg}">Event Log</A> for details.</SMALL></P>
            </TD>
          </xsl:when>
          <xsl:when test="contains(string(/server/error),'-----------')">
            <TD>
              <P><PRE class="xs"><xsl:value-of select="/server/error"/></PRE></P>
            </TD>
          </xsl:when>
          <xsl:otherwise>
            <TD>
              <xsl:for-each select="/server/error">
                <P><SMALL><xsl:value-of select="."/></SMALL></P>
              </xsl:for-each>
              <xsl:for-each select="/server/messages/msg[@severity='error']">
                <P><SMALL><xsl:value-of select="."/></SMALL></P>
              </xsl:for-each>
            </TD>
          </xsl:otherwise>
        </xsl:choose>
      </TR>
    </TABLE>
  </xsl:template>
</xsl:stylesheet>
