<?xml version="1.0" encoding="iso-8859-1"?>
<!-- Todo:
  
     [!DOCTYPE] Put common enitity declarations into a DTD. But DTDs don't seem
     to be working correctly. Hmmm.

  -->
<!DOCTYPE html [
<!ENTITY nbsp "<xsl:text disable-output-escaping='yes'>&amp;nbsp;</xsl:text>">
<!ENTITY ampersand "<xsl:text disable-output-escaping='yes'>&amp;</xsl:text>">
]>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
  <!-- [ ! ] --><xsl:include href="common.xsl"/>
  <xsl:include href="../../js-import.xsl"/>
  <xsl:include href="pageHelp.xsl"/>
  <xsl:include href="controlmenu.xsl"/>

  <xsl:variable name="vm_colspan">12</xsl:variable>

  <xsl:template match="/">
    <xsl:variable name="win32_suffix">
      <xsl:if test="/server/host@os = 'MSWin32'">/index.pl</xsl:if>
    </xsl:variable>
    <HTML>
      <HEAD>
        <TITLE><xsl:value-of select="/server/vm/displayName"/> Details - <xsl:value-of select="/server/host"/>.<xsl:value-of select="/server/host@domain"/></TITLE>
        <META http-equiv="Refresh" content="180; url=/details{$win32_suffix}?c={/server/vm/safe_cfg}&amp;auto-refresh=1"/>
        <SCRIPT>
          <xsl:choose>
            <xsl:when test="/server/product@id='ESX'">
              var product = "ESX";
            </xsl:when>
            <xsl:otherwise>
              var product = "GSX";
            </xsl:otherwise>
          </xsl:choose>
          var noRefresh = true;
          //var refreshRate = new Array( );
          //refreshRate['minutes'] = '3';
          //refreshRate['seconds'] = '0';
          var hostOS = "<xsl:value-of select="/server/host@os"/>";
          <xsl:call-template name="js-src">
            <xsl:with-param name="src">../../util-js.xml</xsl:with-param>
            <xsl:with-param name="use">
              <obj use-recommended="1">Is</obj>
            </xsl:with-param>
          </xsl:call-template>
          <xsl:call-template name="js-src">
            <xsl:with-param name="src">controlmenu-js.xml</xsl:with-param>
          </xsl:call-template>
        </SCRIPT>
        <SCRIPT src="{$common}server.js"></SCRIPT>
        <LINK rel="stylesheet" href="{$common}style.css" type="text/css" />
      </HEAD>

      <BODY bgcolor="#FFFFFF" link="#000000" vlink="#000000" topmargin="6" leftmargin="6" marginwidth="6" marginheight="6" onload="setup();ctrlMenuSetup();">
        <xsl:call-template name="poweroffMenu"/>
        <xsl:call-template name="poweronMenu"/>
        <xsl:call-template name="suspendMenu"/>
        <xsl:call-template name="softableMenu"/>
        <xsl:call-template name="readonlyMenu"/>
        <xsl:call-template name="unreachableMenu"/>

        <xsl:call-template name="operationForm"/>
      
        <FORM name="form" method="post" action="javascript:noop();" onSubmit="javascript:handleSubmit();">
          <xsl:call-template name="pageHeader">
            <xsl:with-param name="uiPath">
              <location href="/overview">VMs on <xsl:value-of select="/server/host"/><xsl:if test="/server/host@domain">.<xsl:value-of select="/server/host@domain"/></xsl:if></location>
              <current><xsl:value-of select="/server/vm/displayName"/></current>
            </xsl:with-param>
          </xsl:call-template>
          
          <xsl:if test="/server/error">
            <P>
              <TABLE><TR>
                <TD><IMG src="{$imx}spacer.gif" width="128" height="1"/></TD>
                <TD>
                  <xsl:call-template name="error"/>
                </TD>
                <TD><IMG src="{$imx}spacer.gif" width="128" height="1"/></TD>
              </TR></TABLE>
            </P>
          </xsl:if>

          <xsl:if test="/server/vm">
            <TABLE width="100%" border="0" cellpadding="1" cellspacing="0">
              <TR><TD><IMG src="{$imx}spacer.gif" width="1" height="6"/></TD></TR>
              <TR><TD bgcolor="#999980">
                <TABLE width="100%" border="0" cellpadding="0" cellspacing="0">
                  <TR><TD bgcolor="#FFFFE6">
                    <xsl:attribute name="colspan">
                      <xsl:choose>
                        <xsl:when test="/server/vm/stat[@name='cpu'] and /server/vm/stat[@name='ram']">2</xsl:when>
                        <xsl:otherwise>1</xsl:otherwise>
                      </xsl:choose>
                    </xsl:attribute>
                    <TABLE width="100%" border="0" cellpadding="3" cellspacing="1">
                      <xsl:call-template name="vmHeader">
                        <xsl:with-param name="stats">
                          <heartbeat/>
                          <uptime/>
                        </xsl:with-param>
                        <xsl:with-param name="config">
                          <os/>
                          <ip/>
                          <memsize/>
                        </xsl:with-param>
                      </xsl:call-template>
                      <xsl:call-template name="vmRow">
                        <xsl:with-param name="position"><xsl:value-of select="1"/></xsl:with-param>
                        <xsl:with-param name="stats">
                          <heartbeat/>
                          <uptime/>
                        </xsl:with-param>
                        <xsl:with-param name="config">
                          <os/>
                          <ip/>
                          <memsize/>
                        </xsl:with-param>
                      </xsl:call-template>
                      <tr>
                        <td colspan="5" align="right"><nobr><small><small>&nbsp;</small></small></nobr></td>
                        <td><small><small>
                          <xsl:variable name="persist_vmss"><xsl:value-of select="/server/vm/resume.repeatable"/></xsl:variable>
                          Repeatable Resume:
                          <xsl:choose>
                            <xsl:when test="$persist_vmss='true'">
                              <b>On</b>
                              <xsl:if test="/server/vm/capabilities/write and /server/vm/capabilities/execute and /server/vm/state&gt;1">
                                | <span style="color:#999999; text-decoration: underline;">Off</span>
                              </xsl:if>
                              <xsl:if test="/server/vm/capabilities/write and /server/vm/capabilities/execute and /server/vm/state&lt;2">
                                | <a href="javascript:persistVmss(0,false);">Off</a>
                              </xsl:if>
                            </xsl:when>
                            <xsl:otherwise>
                              <xsl:if test="/server/vm/capabilities/write and /server/vm/capabilities/execute and (not(/server/vm/state='0') or not(/server/vm/nonpersistent))">
                                <span style="color:#999999; text-decoration: underline;">On</span> | 
                              </xsl:if>
                              <xsl:if test="/server/vm/capabilities/write and /server/vm/capabilities/execute and /server/vm/state='0' and /server/vm/nonpersistent">
                                <a href="javascript:persistVmss(0,true);">On</a> | 
                              </xsl:if>
                              <b>Off</b>
                            </xsl:otherwise>
                          </xsl:choose>
                        </small></small></td>
                      </tr>
                    </TABLE>
                  </TD></TR></TABLE>
                  <TR><TD><IMG src="{$imx}spacer.gif" width="1" height="6"/></TD></TR>
              </TD></TR></TABLE>

              <xsl:if test="/server/vm/stat[@name='cpu'] and /server/vm/stat[@name='ram']">
                <TABLE width="100%" border="0" cellpadding="1" cellspacing="0">
                  <TR><TD bgcolor="#999980">
                    <TABLE width="100%" border="0" cellpadding="0" cellspacing="0">
                      <TR>
                        <xsl:if test="/server/vm/stat[@name='cpu']">
                          <TD bgcolor="#FFFFE6">
                            <xsl:attribute name="width">
                              <xsl:if test="/server/vm/stat[@name='cpu'] and /server/vm/stat[@name='ram']">50%</xsl:if>
                            </xsl:attribute>
                            <TABLE width="100%" border="0" cellpadding="0" cellspacing="0"><TR><TD bgcolor="#FFFFE6"><TABLE width="100%" border="0" cellpadding="3" cellspacing="1">
                              <xsl:call-template name="stats">
                                <xsl:with-param name="stat">cpu</xsl:with-param>
                              </xsl:call-template>
                            </TABLE></TD></TR></TABLE>
                          </TD>
                        </xsl:if>
                        <xsl:if test="/server/vm/stat[@name='ram']">
                          <TD bgcolor="#999980">
                            <xsl:attribute name="width">
                              <xsl:if test="/server/vm/stat[@name='cpu'] and /server/vm/stat[@name='ram']">50%</xsl:if>
                            </xsl:attribute>
                            <TABLE width="100%" border="0" cellpadding="0" cellspacing="0"><TR><TD bgcolor="#FFFFE6"><TABLE width="100%" border="0" cellpadding="3" cellspacing="1">
                              <xsl:call-template name="stats">
                                <xsl:with-param name="stat">ram</xsl:with-param>
                              </xsl:call-template>
                            </TABLE></TD></TR></TABLE>
                          </TD>
                        </xsl:if>
                      </TR>
                    </TABLE>
                  </TD></TR>
                  <TR><TD><IMG src="{$imx}spacer.gif" width="1" height="6" vspace="1"/></TD></TR>
                </TABLE>
              </xsl:if>
          </xsl:if>

          <xsl:call-template name="pageFooter">
            <xsl:with-param name="edit"><xsl:value-of select="/server/vm/safe_cfg"/></xsl:with-param>
            <xsl:with-param name="disable_edit">
              <xsl:choose>
                <xsl:when test="not(/server/vm/state='0') or not(/server/vm/capabilities/write)">
                  <xsl:value-of select="/server/vm/safe_cfg"/>
                </xsl:when>
                <xsl:otherwise>0</xsl:otherwise>
              </xsl:choose>
            </xsl:with-param>
            <xsl:with-param name="delete">
              <xsl:value-of select="/server/vm/safe_cfg"/>
            </xsl:with-param>
            <xsl:with-param name="disable_delete">
              <xsl:choose>
                <xsl:when test="not(/server/vm/state='0') or not(/server/vm/capabilities/execute) or not(/server/vm/capabilities/write)">1</xsl:when>
                <xsl:otherwise>0</xsl:otherwise>
              </xsl:choose>
            </xsl:with-param>
          </xsl:call-template>

          <TABLE width="100%" border="0" cellpadding="0" cellspacing="0">
            <TR><TD><IMG src="{$imx}spacer.gif" width="1" height="4" vspace="1"/></TD></TR>
            <TR bgcolor="#999980"><TD>
              <TABLE width="100%" border="0" cellpadding="5" cellspacing="1"><TR>
                <TD width="30%" valign="top" bgcolor="#CCCCB3">
                  <xsl:call-template name="devices"/>
                  <xsl:call-template name="users"/>
                </TD>
                <TD width="70%" valign="top" bgcolor="#CCCCB3">
                  <xsl:call-template name="events"/>
                </TD>
              </TR></TABLE>
            </TD></TR>
          </TABLE>

          <P>
            <xsl:call-template name="help-src">
              <xsl:with-param name="src">en/details.xml</xsl:with-param>
            </xsl:call-template>
          </P>

          <xsl:call-template name="labelFooter"/>
        </FORM>
      </BODY>
    </HTML>
  </xsl:template>

  <xsl:template name="stats">
    <xsl:param name="stat"/>
    <TR bgcolor="#E6E6CC">
      <TD align="right" nowrap="true">
        <xsl:if test="/server/vm/stat[@name=$stat]"><xsl:attribute name="colspan">3</xsl:attribute></xsl:if>
        <NOBR><SMALL>
        <xsl:choose>
          <xsl:when test="$stat='cpu'">
            Percent CPU
          </xsl:when>
          <xsl:when test="$stat='ram'">
            Percent RAM
          </xsl:when>
        </xsl:choose>
      </SMALL></NOBR></TD>
      <TD width="1%" align="center" nowrap="true">
        <xsl:if test="/server/vm/stat[@name=$stat]"><xsl:attribute name="colspan">2</xsl:attribute></xsl:if>
        <NOBR><SMALL>Minimum</SMALL></NOBR></TD>
      <TD width="1%" align="center" nowrap="true">
        <xsl:if test="/server/vm/stat[@name=$stat]"><xsl:attribute name="colspan">2</xsl:attribute></xsl:if>
        <NOBR><SMALL>Average</SMALL></NOBR></TD>
      <TD width="1%" align="center" nowrap="true">
        <xsl:if test="/server/vm/stat[@name=$stat]"><xsl:attribute name="colspan">2</xsl:attribute></xsl:if>
        <NOBR><SMALL>Maximum</SMALL></NOBR></TD>
    </TR>
    <xsl:for-each select="/server/vm/stat[@name=$stat]/usage[@type='avg']/sample">
      <xsl:variable name="i" select="@interval"/>
      <TR bgcolor="#FFFFE6">
        <TD align="right" nowrap="true"><NOBR>
          <SMALL>Last:</SMALL>
        </NOBR></TD>
        <TD width="1%" align="right" nowrap="true"><NOBR>
          <SMALL><xsl:value-of select="$i"/></SMALL>
        </NOBR></TD>
        <TD width="1%" nowrap="true"><NOBR>
          <SMALL>Min.</SMALL>
        </NOBR></TD>
        <xsl:for-each select="../../usage">
          <TD width="1%" align="right"><SMALL>
            <xsl:choose>
              <xsl:when test="not(/server/vm/stat[@name=$stat])">
                <FONT color="#CCCCB3">0</FONT><FONT color="#999980">0</FONT>
              </xsl:when>
              <xsl:otherwise>
                <xsl:if test="./sample[@interval=$i]&lt;10"><FONT color="#FFFFE6">0</FONT></xsl:if>
                <xsl:value-of select="./sample[@interval=$i]"/>
              </xsl:otherwise>
            </xsl:choose>
          </SMALL></TD>
          <TD width="1%">
            <xsl:call-template name="usage_bar">
              <xsl:with-param name="sample" select="./sample[@interval=$i]"/>
              <xsl:with-param name="denominator" select="2"/>
            </xsl:call-template>
          </TD>
          <!-- TD width="1%" align="right" nowrap="true"><NOBR><SMALL><xsl:value-of select="./sample[@interval=$i]"/>&nbsp;</SMALL></NOBR></TD>
          <TD width="1%">
            <xsl:call-template name="usage_bar">
              <xsl:with-param name="sample" select="./sample[@interval=$i]"/>
              <xsl:with-param name="denominator" select="2"/>
            </xsl:call-template>
          </TD -->
        </xsl:for-each>
      </TR>
    </xsl:for-each>
  </xsl:template>

  <xsl:template name="events">
    <TABLE width="100%" border="0" cellpadding="1" cellspacing="3">
      <xsl:variable name="win32_suffix">
        <xsl:if test="/server/host@os = 'MSWin32'">/index.pl</xsl:if>
      </xsl:variable>
      <xsl:variable name="cfg"><xsl:value-of select="/server/vm/safe_cfg"/></xsl:variable>
      <TR><TD><SMALL><A href="/eventlog{$win32_suffix}?c={$cfg}">Event Log</A></SMALL></TD></TR>
      <TR><TD bgcolor="#66664D"><TABLE width="100%" border="0" cellpadding="3" cellspacing="0">
        <xsl:choose>
          <xsl:when test="/server/vm/event">
            <xsl:for-each select="/server/vm/event">
              <xsl:if test="position()&lt;=15"><!-- display the last 15 events -->
                <xsl:variable name="type" select="@type"/>
                <xsl:variable name="clr">
                  <xsl:choose>
                    <xsl:when test="position() mod 2=0">E6E6CC</xsl:when>
                    <xsl:otherwise>FFFFE6</xsl:otherwise>
                  </xsl:choose>
                </xsl:variable>
                <TR valign="baseline" bgcolor="#{$clr}">
                  <TD width="1%" align="right" nowrap="true"><NOBR><SMALL><xsl:value-of select="./time"/></SMALL></NOBR></TD>

                  <TD width="1%" align="right" nowrap="true"><SMALL>
                    <xsl:choose>
                      <xsl:when test="./user">
                        <xsl:value-of select="./user"/>
                      </xsl:when>
                      <xsl:otherwise>&nbsp;</xsl:otherwise>
                    </xsl:choose>
                  </SMALL></TD>

                  <xsl:variable name="icon">
                    <xsl:choose>
                      <xsl:when test="$type='error'"><xsl:value-of select="$common.imx"/>error-10.gif</xsl:when>
                      <xsl:when test="$type='question'"><xsl:value-of select="$common.imx"/>question-10.gif</xsl:when>
                      <xsl:when test="$type='answer'"><xsl:value-of select="$common.imx"/>info-10.gif</xsl:when>
                      <xsl:when test="$type='info' and ./choice"><xsl:value-of select="$common.imx"/>question-10.gif</xsl:when>
                      <xsl:otherwise><xsl:value-of select="$common.imx"/>info-10.gif</xsl:otherwise>
                    </xsl:choose>
                  </xsl:variable>
                  <TD width="1%" align="center" nowrap="true"><IMG src="{$icon}" width="10" height="10"/></TD>

                  <TD>
                    <P><SMALL><xsl:value-of select="./subject"/></SMALL></P>
                    <xsl:if test="not($type='answer') and ./body/p">
                      <xsl:for-each select="./body/p">
                        <P><SMALL><SMALL><xsl:value-of select="."/></SMALL></SMALL></P>
                      </xsl:for-each>
                    </xsl:if>
                  </TD>
                </TR>
              </xsl:if>
            </xsl:for-each>
          </xsl:when>
          <xsl:otherwise>
            <TR valign="top" bgcolor="#FFFFE6">
              <TD align="center"><SMALL style="color:000000;">There are no entries in the event log for <xsl:value-of select="/server/vm/displayName"/>.</SMALL></TD>
            </TR>
          </xsl:otherwise>
        </xsl:choose>
      </TABLE></TD></TR>
    </TABLE>
  </xsl:template>

  <xsl:template name="events_header">
    <xsl:choose>
      <xsl:when test="/server/vm/event">
        <TR bgcolor="#CCCCB3">
          <TD width="1%" align="right" nowrap="true"><NOBR><SMALL>Date and Time</SMALL></NOBR></TD>
          <TD width="1%" align="right" nowrap="true"><NOBR><SMALL>Username</SMALL></NOBR></TD>
          <TD width="1%" nowrap="true"><NOBR><SMALL>&nbsp;</SMALL></NOBR></TD>
          <TD nowrap="true"><NOBR><SMALL>Virtual Machine Event</SMALL></NOBR></TD>
        </TR>
      </xsl:when>
      <xsl:otherwise>
        <TR bgcolor="#CCCCB3">
          <TD><IMG src="{$imx}spacer.gif" width="1" height="1"/></TD>
        </TR>
      </xsl:otherwise>
    </xsl:choose>
  </xsl:template>

  <xsl:template name="events_footer"><xsl:call-template name="events_header"/></xsl:template>

  <xsl:template name="users">
    <TABLE width="100%" border="0" cellspacing="3" cellpadding="1">
      <TR>
        <TD><SMALL>Connected Users</SMALL></TD>
      </TR>
      <TR><TD bgcolor="#66664D"><TABLE width="100%" border="0" cellpadding="3" cellspacing="0">
        <xsl:for-each select="/server/vm/connection">
          <xsl:variable name="clr">
            <xsl:choose>
              <xsl:when test="position() mod 2=0">E6E6CC</xsl:when>
              <xsl:otherwise>FFFFE6</xsl:otherwise>
            </xsl:choose>
          </xsl:variable>
          <TR>
            <TD colspan="2" bgcolor="#{$clr}"><SMALL><xsl:value-of select="username"/></SMALL></TD>
          </TR>
          <TR>
            <TD valign="baseline" bgcolor="{$clr}" nowrap="true"><NOBR><SMALL><SMALL>Type:</SMALL></SMALL></NOBR></TD>
            <TD bgcolor="#{$clr}" nowrap="true"><NOBR><SMALL><SMALL>
              <xsl:variable name="type" select="@type"/>
              <xsl:choose>
                <xsl:when test="$type='control'">
                  Management Interface
                </xsl:when>
                <xsl:when test="$type='ui'">
                  <xsl:choose>
                    <xsl:when test="ip">Remote Console</xsl:when>
                    <xsl:otherwise>Local</xsl:otherwise>
                  </xsl:choose>
                </xsl:when>
                <xsl:otherwise><xsl:value-of select="$type"/></xsl:otherwise>
              </xsl:choose>
            </SMALL></SMALL></NOBR></TD>
          </TR>
          <xsl:if test="ip">
            <TR>
              <TD valign="baseline" bgcolor="{$clr}" nowrap="true"><NOBR><SMALL><SMALL>IP:</SMALL></SMALL></NOBR></TD>
              <TD bgcolor="#{$clr}" nowrap="true"><NOBR><SMALL><SMALL><xsl:value-of select="ip"/></SMALL></SMALL></NOBR></TD>
            </TR>
          </xsl:if>
          <TR>
            <TD valign="baseline" bgcolor="{$clr}" nowrap="true"><NOBR><SMALL><SMALL>Since:</SMALL></SMALL></NOBR></TD>
            <TD bgcolor="#{$clr}" nowrap="true"><SMALL><SMALL><xsl:value-of select="connect"/></SMALL></SMALL></TD>
          </TR>
          <TR>
            <TD valign="baseline" bgcolor="{$clr}" nowrap="true"><NOBR><SMALL><SMALL>Idle Since:</SMALL></SMALL></NOBR></TD>
            <TD bgcolor="#{$clr}" nowrap="true"><NOBR><SMALL><SMALL><xsl:value-of select="idle"/></SMALL></SMALL></NOBR></TD>
          </TR>
        </xsl:for-each>
      </TABLE></TD></TR>
    </TABLE>
  </xsl:template>

  <xsl:template name="devices">
    <TABLE width="100%" border="0" cellspacing="3" cellpadding="1">
      <TR>
        <TD><SMALL>Configured Devices</SMALL></TD>
      </TR>
      <TR><TD bgcolor="#66664D"><TABLE width="100%" border="0" cellpadding="3" cellspacing="0">
        <xsl:for-each select="/server/vm/device">
          <xsl:variable name="clr">
            <xsl:choose>
              <xsl:when test="position() mod 2=0">E6E6CC</xsl:when>
              <xsl:otherwise>FFFFE6</xsl:otherwise>
            </xsl:choose>
          </xsl:variable>
          <TR>
            <TD colspan="2" valign="baseline" bgcolor="#{$clr}" nowrap="true"><NOBR><SMALL><xsl:value-of select="@id"/></SMALL></NOBR></TD>
          </TR>
          <xsl:for-each select="./param">
            <TR>
              <TD valign="baseline" bgcolor="{$clr}" nowrap="true"><NOBR><SMALL><SMALL><xsl:value-of select="@name"/>:</SMALL></SMALL></NOBR></TD>
              <TD bgcolor="#{$clr}"><SMALL><SMALL><xsl:value-of select="."/></SMALL></SMALL></TD>
            </TR>
          </xsl:for-each>
        </xsl:for-each>
      </TABLE></TD></TR>
    </TABLE>
  </xsl:template>

</xsl:stylesheet>
