<?xml version="1.0" encoding="iso-8859-1"?>

<!DOCTYPE html [
<!ENTITY nbsp "<xsl:text disable-output-escaping='yes'>&amp;nbsp;</xsl:text>">
]>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
  
  <xsl:include href="common.xsl"/>

  <xsl:variable name="file_count" select="count(/exec/out/file)"/>
  <xsl:variable name="cwd" select="/exec/out/cwd"/>

  <xsl:template match="/">
    <html>
      <head>
        <title>VMware MUI File Manager</title>
        <style>
          td, p, blockquote, li {font-family: Verdana, sans-serif; font-size: 11px; }
        </style>
	<xsl:call-template name="fileUtils"/>
        <script>
          function ok() {
            document.form.submit();
          }
          function cancel() {
            window.location.replace('/showdir?op=ls' + 
              unescape("%26") + 'dir=' + escapeFileName('<xsl:value-of select="$cwd"/>'));
          }
          function setup() {
            if (parent.lock_buttons) parent.lock_buttons(true);
          }
        </script>
      </head>
      <body bgcolor="#FFFFFF" onload="setup();">
        <br />
        <br />
        <form name="form" method="POST" action="/fm-properties">
          <input type="hidden" name="op" value="edit_properties"/>
          <input type="hidden" name="cwd" value="{$cwd}"/>
          <table align="center" border="0" cellpadding="0" cellspacing="0">
            <tr>
              <td><img src="{$common.imx}fm/field-tl.gif" width="7" height="7"/></td>
              <td background="{$common.imx}fm/field-t.gif"><img src="{$common.imx}fm/field-t.gif" width="1" height="7"/></td>
              <td><img src="{$common.imx}fm/field-tr.gif" width="7" height="7"/></td>
            </tr>
            <tr>
              <td background="{$common.imx}fm/field-l.gif"><img src="{$common.imx}fm/field-l.gif" width="7" height="1"/></td>
              <td bgcolor="#E6E6CC" align="center">
                <xsl:choose>
                  <xsl:when test="not(/exec/messages)">
                    <table width="360" border="0" cellpadding="4" cellspacing="0">
                      <xsl:if test="$file_count=1">
                        <tr>
                          <td align="right" nowrap="1"><nobr><b>File Name</b></nobr></td>
                          <td colspan="4"><font face="monospace" size="2"><input name="name" type="text" size="40" style="font-family:monospace; font-size:12px">
                            <xsl:attribute name="value"><xsl:value-of select="/exec/out/file/name"/></xsl:attribute>
                          </input></font></td>
                        </tr>
                        <tr><td colspan="5"><img src="{$imx}999980-hr.png" width="100%" height="1" vspace="2"/></td></tr>
                      </xsl:if>
                      <tr>
                        <td>&nbsp;</td>
                        <td align="center"><b>r</b></td>
                        <td align="center"><b>w</b></td>
                        <td align="center"><b>x</b></td>
                        <td>&nbsp;</td>
                      </tr>
                      <tr>
                        <td align="right"><b>User</b></td>
                        <td align="center"><xsl:call-template name="mode_control">
                          <xsl:with-param name="user">u</xsl:with-param>
                          <xsl:with-param name="mode">r</xsl:with-param>
                        </xsl:call-template></td>
                        <td align="center"><xsl:call-template name="mode_control">
                          <xsl:with-param name="user">u</xsl:with-param>
                          <xsl:with-param name="mode">w</xsl:with-param>
                        </xsl:call-template></td>
                        <td align="center"><xsl:call-template name="mode_control">
                          <xsl:with-param name="user">u</xsl:with-param>
                          <xsl:with-param name="mode">x</xsl:with-param>
                        </xsl:call-template></td>
                        <td><font face="monospace" size="2"><input name="user" type="text" size="16" style="font-family:monospace; font-size:12px">
                          <xsl:attribute name="value"><xsl:value-of select="/exec/out/user"/></xsl:attribute>
                        </input></font></td>
                      </tr>
                      <tr>
                        <td align="right"><b>Group</b></td>
                        <td align="center"><xsl:call-template name="mode_control">
                          <xsl:with-param name="user">g</xsl:with-param>
                          <xsl:with-param name="mode">r</xsl:with-param>
                        </xsl:call-template></td>
                        <td align="center"><xsl:call-template name="mode_control">
                          <xsl:with-param name="user">g</xsl:with-param>
                          <xsl:with-param name="mode">w</xsl:with-param>
                        </xsl:call-template></td>
                        <td align="center"><xsl:call-template name="mode_control">
                          <xsl:with-param name="user">g</xsl:with-param>
                          <xsl:with-param name="mode">x</xsl:with-param>
                        </xsl:call-template></td>
                        <td><font face="monospace" size="2"><input name="group" type="text" size="16" style="font-family:monospace; font-size:12px">
                          <xsl:attribute name="value"><xsl:value-of select="/exec/out/group"/></xsl:attribute>
                        </input></font></td>
                      </tr>
                      <tr>
                        <td align="right"><b>Others</b></td>
                        <td align="center"><xsl:call-template name="mode_control">
                          <xsl:with-param name="user">o</xsl:with-param>
                          <xsl:with-param name="mode">r</xsl:with-param>
                        </xsl:call-template></td>
                        <td align="center"><xsl:call-template name="mode_control">
                          <xsl:with-param name="user">o</xsl:with-param>
                          <xsl:with-param name="mode">w</xsl:with-param>
                        </xsl:call-template></td>
                        <td align="center"><xsl:call-template name="mode_control">
                          <xsl:with-param name="user">o</xsl:with-param>
                          <xsl:with-param name="mode">x</xsl:with-param>
                        </xsl:call-template></td>
                        <td>&nbsp;</td>
                      </tr>
                    </table>
                  </xsl:when>
                  <xsl:otherwise>
                    <table width="380" border="0" cellpadding="0" cellspacing="0">
                      <tr>
                        <td valign="top"><img src="{$common.imx}error.gif" width="32" height="32"/></td>
                        <td>&nbsp; &nbsp; &nbsp;</td>
                        <td>
                          <p><b>Error</b></p>

                          <p>
                            One or more errors were encountered while committing the specified file properties.
                          </p>

                          <xsl:for-each select="/exec/messages/msg">
                            <ul><li><xsl:value-of select="."/></li></ul>
                          </xsl:for-each>
                        </td>
                      </tr>
                    </table>  
                  </xsl:otherwise>
                </xsl:choose>
              </td>
              <td background="{$common.imx}fm/field-r.gif"><img src="{$common.imx}fm/field-r.gif" width="7" height="1"/></td>
            </tr>
            <tr>
              <td background="{$common.imx}fm/field-l.gif"><img src="{$common.imx}fm/field-l.gif" width="7" height="1"/></td>
              <td bgcolor="#E6E6CC"><img src="{$imx}spacer.gif" width="1" height="7"/></td>
              <td background="{$common.imx}fm/field-r.gif"><img src="{$common.imx}fm/field-r.gif" width="7" height="1"/></td>
            </tr>
            <tr>
              <td background="{$common.imx}fm/field-l.gif"><img src="{$common.imx}fm/field-l.gif" width="7" height="1"/></td>
              <td align="right" bgcolor="#E6E6CC"><xsl:choose>
                <xsl:when test="not(/exec/messages)">
                  <a href="javascript:ok();"><img src="{$common.imx}fm/ok.gif" width="27" height="14" border="0" hspace="4"/></a><a href="javascript:cancel();"><img src="{$common.imx}fm/cancel.gif" width="41" height="14" border="0"/></a>
                </xsl:when>
                <xsl:otherwise>
                  <a href="javascript:cancel();"><img src="{$common.imx}fm/ok.gif" width="27" height="14" border="0"/></a>
                </xsl:otherwise>
              </xsl:choose></td>
              <td background="{$common.imx}fm/field-r.gif"><img src="{$common.imx}fm/field-r.gif" width="7" height="1"/></td>
            </tr>
            <xsl:if test="$file_count &gt; 1 and not(/exec/messages)">
              <tr>
                <td background="{$common.imx}fm/field-l.gif"><img src="{$common.imx}fm/field-l.gif" width="7" height="1"/></td>
                <td bgcolor="#E6E6CC"><img src="{$imx}spacer.gif" width="1" height="7"/></td>
                <td background="{$common.imx}fm/field-r.gif"><img src="{$common.imx}fm/field-r.gif" width="7" height="1"/></td>
              </tr>
              <tr>
                <td background="{$common.imx}fm/field-l.gif"><img src="{$common.imx}fm/field-l.gif" width="7" height="1"/></td>
                <td bgcolor="#E6E6CC" align="center">
                  <table border="0" cellpadding="4" cellspacing="0">
                    <tr><td><img src="{$imx}999980-hr.png" width="360" height="1" vspace="2"/></td></tr>
                    <tr><td><b>Selected Files</b></td></tr>
                    <tr><td><ul>
                      <xsl:for-each select="/exec/out/file">
                        <li><xsl:value-of select="./name"/></li>
                      </xsl:for-each>
                    </ul></td></tr>
                  </table>
                </td>
                <td background="{$common.imx}fm/field-r.gif"><img src="{$common.imx}fm/field-r.gif" width="7" height="1"/></td>
              </tr>
            </xsl:if>
            <tr>
              <td><img src="{$common.imx}fm/field-bl.gif" width="7" height="7"/></td>
              <td background="{$common.imx}fm/field-b.gif"><img src="{$common.imx}fm/field-b.gif" width="1" height="7"/></td>
              <td><img src="{$common.imx}fm/field-br.gif" width="7" height="7"/></td>
            </tr>
          </table>
          <input type="hidden" name="files">
            <xsl:attribute name="value">
              <xsl:for-each select="/exec/out/file"><xsl:value-of select="./name"/><xsl:if test="position()!=last()">|</xsl:if></xsl:for-each>
            </xsl:attribute>
          </input>
        </form>
      </body>
    </html>
  </xsl:template>

  <xsl:template name="mode_control">
    <xsl:param name="user"/>
    <xsl:param name="mode"/>
    <xsl:variable name="mode_node">
      <xsl:choose>
        <xsl:when test="$user='u' and $mode='r'">
          <xsl:value-of select="/exec/out/ur"/>
        </xsl:when>
        <xsl:when test="$user='u' and $mode='w'">
          <xsl:value-of select="/exec/out/uw"/>
        </xsl:when>
        <xsl:when test="$user='u' and $mode='x'">
          <xsl:value-of select="/exec/out/ux"/>
        </xsl:when>
        <xsl:when test="$user='g' and $mode='r'">
          <xsl:value-of select="/exec/out/gr"/>
        </xsl:when>
        <xsl:when test="$user='g' and $mode='w'">
          <xsl:value-of select="/exec/out/gw"/>
        </xsl:when>
        <xsl:when test="$user='g' and $mode='x'">
          <xsl:value-of select="/exec/out/gx"/>
        </xsl:when>
        <xsl:when test="$user='o' and $mode='r'">
          <xsl:value-of select="/exec/out/or"/>
        </xsl:when>
        <xsl:when test="$user='o' and $mode='w'">
          <xsl:value-of select="/exec/out/ow"/>
        </xsl:when>
        <xsl:when test="$user='o' and $mode='x'">
          <xsl:value-of select="/exec/out/ox"/>
        </xsl:when>
      </xsl:choose>
    </xsl:variable>
    <xsl:choose>
      <xsl:when test="$file_count=1">
        <input type="checkbox" name="{$user}{$mode}" value="1">
          <xsl:if test="$mode_node=1">
            <xsl:attribute name="checked">1</xsl:attribute>
          </xsl:if>
        </input>
      </xsl:when>
      <xsl:otherwise>
        <font face="monospace" size="2">
          <select name="{$user}{$mode}" style="font-family:monospace; font-size:12px">
            <xsl:if test="$mode_node=-1"><option value="-1" selected="1"></option></xsl:if>
            <option value="0"><xsl:if test="$mode_node=0"><xsl:attribute name="selected">1</xsl:attribute></xsl:if>-</option>
            <option value="1"><xsl:if test="$mode_node=1"><xsl:attribute name="selected">1</xsl:attribute></xsl:if><xsl:value-of select="$mode"/></option>
          </select>
        </font>
      </xsl:otherwise>
    </xsl:choose>
  </xsl:template>
</xsl:stylesheet>