<?xml version="1.0" encoding="iso-8859-1"?>
<!-- Todo:
  
     [!DOCTYPE] Put common enitity declarations into a DTD. But DTDs don't seem
     to be working correctly. Hmmm.

  -->
<!DOCTYPE html [
<!ENTITY nbsp "<xsl:text disable-output-escaping='yes'>&amp;nbsp;</xsl:text>">
<!ENTITY ampersand "<xsl:text disable-output-escaping='yes'>&amp;</xsl:text>">
]>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
  <!-- [ ! ] --><xsl:include href="common.xsl"/>
  <xsl:include href="../../js-import.xsl"/>
  <xsl:include href="pageHelp.xsl"/>
  <xsl:include href="controlmenu.xsl"/>

  <xsl:template match="/">
    <xsl:variable name="win32_suffix">
      <xsl:if test="/server/host@os = 'MSWin32'">/index.pl</xsl:if>
    </xsl:variable>
    <HTML>
      <HEAD>
        <TITLE><xsl:value-of select="/server/vm/displayName"/> Event Log - <xsl:value-of select="/server/host"/>.<xsl:value-of select="/server/host@domain"/></TITLE>
        <xsl:choose>
          <xsl:when test="/server/vm/question">
            <META http-equiv="Refresh" content="60; url=/eventlog{$win32_suffix}?c={/server/vm/safe_cfg}&amp;auto-refresh=1"/>
          </xsl:when>
          <xsl:otherwise>
            <META http-equiv="Refresh" content="30; url=/eventlog{$win32_suffix}?c={/server/vm/safe_cfg}&amp;auto-refresh=1"/>
          </xsl:otherwise>
        </xsl:choose>
        <SCRIPT>
          <xsl:choose>
            <xsl:when test="/server/product@id='ESX'">
              var product = "ESX";
            </xsl:when>
            <xsl:otherwise>
              var product = "GSX";
            </xsl:otherwise>
          </xsl:choose>
          var noRefresh = true;
          var hostOS = "<xsl:value-of select="/server/host@os"/>";
          //var refreshRate = new Array( );
          <xsl:choose>
            <xsl:when test="/server/vm/question">
              //refreshRate['minutes'] = '0';
              //refreshRate['seconds'] = '45';
            </xsl:when>
            <xsl:otherwise>
              //refreshRate['minutes'] = '0';
              //refreshRate['seconds'] = '15';
            </xsl:otherwise>
          </xsl:choose>
          <xsl:call-template name="js-src">
            <xsl:with-param name="src">../../util-js.xml</xsl:with-param>
            <xsl:with-param name="use">
              <obj use-recommended="1">Is</obj>
            </xsl:with-param>
          </xsl:call-template>
          <xsl:call-template name="js-src">
            <xsl:with-param name="src">controlmenu-js.xml</xsl:with-param>
          </xsl:call-template>
        </SCRIPT>
        <SCRIPT src="{$common}server.js"></SCRIPT>
        <LINK rel="stylesheet" href="{$common}style.css" type="text/css" />
      </HEAD>

      <BODY bgcolor="#FFFFFF" link="#000000" vlink="#000000" topmargin="6" leftmargin="6" marginwidth="6" marginheight="6" onload="setup();ctrlMenuSetup();">
        <xsl:call-template name="poweroffMenu"/>
        <xsl:call-template name="poweronMenu"/>
        <xsl:call-template name="suspendMenu"/>
        <xsl:call-template name="softableMenu"/>
        <xsl:call-template name="readonlyMenu"/>
        <xsl:call-template name="unreachableMenu"/>

        <xsl:call-template name="operationForm"/>
      
        <FORM name="form" method="post" action="javascript:noop();" onSubmit="javascript:handleSubmit();">
          <xsl:call-template name="pageHeader">
            <xsl:with-param name="uiPath">
              <location href="/overview">VMs on <xsl:value-of select="/server/host"/><xsl:if test="/server/host@domain">.<xsl:value-of select="/server/host@domain"/></xsl:if></location>
              <location href="/details?c={/server/vm/safe_cfg}"><xsl:value-of select="/server/vm/displayName"/></location>
              <current>Event Log</current>
            </xsl:with-param>
          </xsl:call-template>

          <xsl:if test="/server/error">
            <P>
              <TABLE><TR>
                <TD><IMG src="{$imx}spacer.gif" width="128" height="1"/></TD>
                <TD>
                  <xsl:call-template name="error"/>
                </TD>
                <TD><IMG src="{$imx}spacer.gif" width="128" height="1"/></TD>
              </TR></TABLE>
            </P>
          </xsl:if>

          <xsl:if test="/server/vm">
            <TABLE width="100%" border="0" cellpadding="1" cellspacing="0">
              <TR><TD><IMG src="{$imx}spacer.gif" width="1" height="6"/></TD></TR>
              <TR><TD bgcolor="#999980">
                <TABLE width="100%" border="0" cellpadding="0" cellspacing="0"><TR><TD bgcolor="#FFFFE6"><TABLE width="100%" border="0" cellpadding="3" cellspacing="1">
                  <xsl:call-template name="vmHeader">
                    <xsl:with-param name="stats">
                      <heartbeat/>
                      <uptime/>
                    </xsl:with-param>
                  </xsl:call-template>
                  <xsl:call-template name="vmRow">
                    <xsl:with-param name="position"><xsl:value-of select="1"/></xsl:with-param>
                    <xsl:with-param name="stats">
                      <heartbeat/>
                      <uptime/>
                    </xsl:with-param>
                    <xsl:with-param name="disable">
                      <needinput/>
                    </xsl:with-param>
                  </xsl:call-template>
                </TABLE></TD></TR></TABLE>
              </TD></TR>
              <TR><TD><IMG src="{$imx}spacer.gif" width="1" height="6"/></TD></TR>
            </TABLE>
          </xsl:if>

          <xsl:call-template name="pageFooter">
            <xsl:with-param name="edit"><xsl:value-of select="/server/vm/safe_cfg"/></xsl:with-param>
            <xsl:with-param name="disable_edit">
              <xsl:choose>
                <xsl:when test="not(/server/vm/state='0') or not(/server/vm/capabilities/write)">
                  <xsl:value-of select="/server/vm/safe_cfg"/>
                </xsl:when>
                <xsl:otherwise>0</xsl:otherwise>
              </xsl:choose>
            </xsl:with-param>
            <xsl:with-param name="delete">
              <xsl:value-of select="/server/vm/safe_cfg"/>
            </xsl:with-param>
            <xsl:with-param name="disable_delete">
              <xsl:choose>
                <xsl:when test="not(/server/vm/state='0') or not(/server/vm/capabilities/execute) or not(/server/vm/capabilities/write)">1</xsl:when>
                <xsl:otherwise>0</xsl:otherwise>
              </xsl:choose>
            </xsl:with-param>
          </xsl:call-template>
        
          <TABLE width="100%" border="0" cellpadding="0" cellspacing="0">
            <TR><TD><IMG src="{$imx}spacer.gif" width="1" height="4" vspace="1"/></TD></TR>
            <TR><TD bgcolor="#999980">
              <TABLE width="100%" border="0" cellpadding="3" cellspacing="1">
                <xsl:call-template name="events_header"/>
                <xsl:call-template name="events"/>
                <xsl:call-template name="events_footer"/>
              </TABLE>
            </TD></TR>
          </TABLE>

          <P>
            <xsl:call-template name="help-src">
              <xsl:with-param name="src">en/eventlog.xml</xsl:with-param>
            </xsl:call-template>
          </P>

          <xsl:call-template name="labelFooter"/>
        </FORM>
      </BODY>
    </HTML>
  </xsl:template>

  <xsl:template name="events">
    <xsl:choose>
      <xsl:when test="/server/vm/event">
        <xsl:for-each select="/server/vm/event">
          <xsl:if test="position()&lt;=15"><!-- display the last 15 events -->
            <xsl:variable name="type" select="@type"/>
            <xsl:variable name="clr">
              <xsl:choose>
                <xsl:when test="position() mod 2=0">E6E6CC</xsl:when>
                <xsl:otherwise>FFFFE6</xsl:otherwise>
              </xsl:choose>
            </xsl:variable>
            <TR valign="baseline" bgcolor="#{$clr}">
              <TD width="1%" align="right" nowrap="true"><NOBR><SMALL><xsl:value-of select="./time"/></SMALL></NOBR></TD>

              <TD width="1%" align="right" nowrap="true"><SMALL>
                <xsl:choose>
                  <xsl:when test="./user">
                    <xsl:value-of select="./user"/>
                  </xsl:when>
                  <xsl:otherwise>&nbsp;</xsl:otherwise>
                </xsl:choose>
              </SMALL></TD>

              <xsl:variable name="icon">
                <xsl:choose>
                  <xsl:when test="$type='error'"><xsl:value-of select="$common.imx"/>error-10.gif</xsl:when>
                  <xsl:when test="$type='question'"><xsl:value-of select="$common.imx"/>question-10.gif</xsl:when>
                  <xsl:when test="$type='answer'"><xsl:value-of select="$common.imx"/>info-10.gif</xsl:when>
                  <xsl:when test="$type='info' and ./choice"><xsl:value-of select="$common.imx"/>question-10.gif</xsl:when>
                  <xsl:otherwise><xsl:value-of select="$common.imx"/>info-10.gif</xsl:otherwise>
                </xsl:choose>
              </xsl:variable>
              <TD width="1%" align="center" nowrap="true"><IMG src="{$icon}" width="10" height="10"/></TD>

              <TD>
                <P><SMALL><xsl:value-of select="./subject"/></SMALL></P>
                <xsl:if test="not($type='answer') and ./body/p">
                  <xsl:for-each select="./body/p">
                    <P><SMALL><xsl:value-of select="."/></SMALL></P>
                  </xsl:for-each>
                </xsl:if>
              </TD>
            </TR>
            <xsl:if test="./choice">
              <xsl:if test="($type='question' or $type='info' or $type='error') and position()=1">
                <xsl:variable name="ref" select="@id"/>
                <TR>
                  <TD colspan="3" align="right" bgcolor="#FFFFFF"><SMALL><B>Waiting for input:</B></SMALL></TD>
                  <TD bgcolor="#FFFFE6"><TABLE border="0" cellpadding="0" cellspacing="0"><TR>
                    <xsl:for-each select="choice">
                      <xsl:variable name="label" select="."/>
                      <xsl:variable name="action"><text disable-output-escaping="yes">/answer?c=</text><xsl:value-of select="/server/vm/safe_cfg"/><text disable-output-escaping="yes">&amp;question-id=</text><xsl:value-of select="$ref"/><text disable-output-escaping="yes">&amp;answer-id=</text><xsl:value-of select="@id"/></xsl:variable>
                      <TD>
                        <xsl:call-template name="button">
                          <xsl:with-param name="label"><xsl:value-of select="$label"/></xsl:with-param>
                          <xsl:with-param name="action"><xsl:value-of select="$action"/></xsl:with-param>
                          <xsl:with-param name="gutter-shadow">999980</xsl:with-param>
                          <xsl:with-param name="gutter-hilite">FFFFE6</xsl:with-param>
                          <xsl:with-param name="edge-shadow">999980</xsl:with-param>
                          <xsl:with-param name="edge-hilite">FFFFE6</xsl:with-param>
                          <xsl:with-param name="base">CCCCB3</xsl:with-param>
                        </xsl:call-template>
                      </TD>
                      <xsl:if test="not(position()=last())">
                        <TD><SMALL>&nbsp;</SMALL></TD>
                      </xsl:if>
                    </xsl:for-each>
                  </TR></TABLE></TD>
                </TR>
              </xsl:if>
            </xsl:if>
          </xsl:if>
        </xsl:for-each>
      </xsl:when>
      <xsl:otherwise>
        <TR valign="top" bgcolor="#FFFFE6">
          <TD align="center"><SMALL style="color:000000;">There are no entries in the event log for <xsl:value-of select="/server/vm/displayName"/>.</SMALL></TD>
        </TR>
      </xsl:otherwise>
    </xsl:choose>
  </xsl:template>

  <xsl:template name="events_header">
    <xsl:choose>
      <xsl:when test="/server/vm/event">
        <TR bgcolor="#CCCCB3">
          <TD width="1%" align="right" nowrap="true"><NOBR><SMALL>Date and Time</SMALL></NOBR></TD>
          <TD width="1%" align="right" nowrap="true"><NOBR><SMALL>Username</SMALL></NOBR></TD>
          <TD width="1%" nowrap="true"><NOBR><SMALL>&nbsp;</SMALL></NOBR></TD>
          <TD nowrap="true"><NOBR><SMALL>Virtual Machine Event</SMALL></NOBR></TD>
        </TR>
      </xsl:when>
      <xsl:otherwise>
        <TR bgcolor="#CCCCB3">
          <TD><IMG src="{$imx}spacer.gif" width="1" height="1"/></TD>
        </TR>
      </xsl:otherwise>
    </xsl:choose>
  </xsl:template>

  <xsl:template name="events_footer"><xsl:call-template name="events_header"/></xsl:template>

</xsl:stylesheet>
