/* f ... form object
 * n ... element name
 * v ... element value
 */
function element_index(f, n, v) {
  if (!f) f = showdir.document.ls;

  if (f.elements) {
    n = f.elements[n];
    if (!n) return -1;
  } else {
    return -1;
  }

  if (n[1]) {
    for (var i = 0; i < n.length; i++) { 
      if (v == n[i].value) return i;
    }
  } else {
    if (v == n.value) return 0;
  }
  
  return -1;
}

/* f ... form object
 * n ... element name
 * i ... element index
 */
function index_element(f, n, i) {
  if (i < 0) return;

  if (!f) f = showdir.document.ls;

  if (f.elements) {
    n = f.elements[n]; if (!n) return;
  } else return;

  if (n[1]) return n[i];

  return n;
}

function element(f, n, v) {
  return index_element(f, n, element_index(f, n, v));
}

/* e ... form element object
 */
function value(e, v) {
  if (!e) return;
  if (v != null) e.value = v;
  return e.value;
}

/* e ... form element object
*/
function checked(e,b) {
  if (!e) return;
  if (b != null) e.checked = b;
  return e.checked;
}

/* e ... form element object
*/
function elename(e) {
  if (!e) return;
  return e.name;
}

// --------------------------------------------------------------------------
var bCheckAll = false;
var bCurDirVmfsMountPoint = false;
var bInitHidden = false;

function initHiddenData() 
{
  if (bInitHidden) { 
    var f = hidden.document.hiddenform;
    if (!f) return;
    bInitHidden = false;

    f.src_fs.value = "";
    f.files.value = "";
    f.dirs.value = "";
    f.op.value = "ls";
    f.newdir.value = "";
  }
}

// toggles all checkboxes on/off
function toggleCheckAll() {
  if (selected_files < 1) bCheckAll = false;
  bCheckAll = !bCheckAll;
  selected_files = 0;
  var formObj = showdir.document.ls;
  for (var i = 0; i < formObj.length; i++) {
    if (formObj[i].type == "checkbox") { 
      formObj[i].checked = bCheckAll;
      selected_files += bCheckAll ? 1 : 0;
    }
  }
  if (!bCheckAll) selected_files = 0;
  update_glob_buttons();
}

function recheckItems()
{
  if (! cut_copy_buf || cut_copy_buf.length < 1) return;
  var f = showdir.document.ls;

  var t = new Array("file", "dir");
  for (var n in t) {
    if (!f.elements[t[n]]) continue;
    if (f.elements[t[n]][1]) {
      for (var i = 0; i < f.elements[t[n]].length; i++) {
        checked(index_element(f, t[n], i), false);
      }
    } else {
      checked(index_element(f, t[n], 0), false);
    }
  }

  for (var i = 0; i < cut_copy_buf.length; i++) {
    type = cut_copy_buf.items[i].props["type"] == "dir" ? "dir" : "file";
    if (!f.elements[type]) continue;

    checked(element(f, type, cut_copy_buf.items[i].name), true);
  }

  updateIcons(f, cut_copy_buf.op);

  for (var i = 0; i < cut_copy_buf.length; i++) {
    type = cut_copy_buf.items[i].props["type"] == "dir" ? "dir" : "file";
    if (!f.elements[type]) continue;

    checked(element(f, type, cut_copy_buf.items[i].name), false);
  }

  selected_files = 0;
  update_glob_buttons();
}

function updateIcon(f, n, i, op) 
{
  var imgs = showdir.document.images;
  var img = null;
  var e = index_element(f, n, i);

  img = imgs[(n == 'file' ? 'f_' : 'd_')+i];

  var type = (n == 'file' ? 'f_' : 'd_');
  type = value(index_element(f, type + 'type', i));

  if (op == 'delete') op = 'cut';
  if (op == 'convert') op = 'copy';
  if (op == 'init_properties') op = false;
  if (checked(e) && op) {
    img.src = "/vmware/themes/default/imx/fm/" + type + "-" + op + ".gif";
  } else {
    img.src = "/vmware/themes/default/imx/fm/" + type + ".gif";      
  }
}

function updateIcons(f, op)
{
  var t = new Array("file", "dir");
  for (var n in t) {
    if (!f.elements[t[n]]) continue;
    if (f.elements[t[n]][1]) {
      for (var i = 0; i < f.elements[t[n]].length; i++) {
        updateIcon(f, t[n], i, op);
      }
    } else {
      updateIcon(f, t[n], 0, op);
    }
  }
}

function submitNewDir() 
{
  if (!showdir.document.ls) return; 
  
  var f = hidden.document.hiddenform;
  f.newdir.value = pwd.document.mkdir.dir.value;
  f.op.value = "newdir";
  bInitHidden = true;
  f.submit();
}

function submitDelete() 
{ 
  var f = hidden.document.hiddenform;
  var dele_buf = new SelectionBuffer('delete', f.destdir.value, f.dest_fs.value);
  if (!showdir.document.ls) return;

  dele_buf.fill(showdir.document.ls);
  if (dele_buf.length < 1) return;

  if (confirm("Are you sure you want to permanently remove the selected item(s)?")) {
    dele_buf.commit(f);
  } else {
    updateIcons(showdir.document.ls);
    initHiddenData();
    recheckItems();
  }
}

function convert(i) {
  var n = 'file';
  if (bCheckAll) toggleCheckAll();

  var h = hidden.document.hiddenform;
  var conv_buf = new SelectionBuffer('convert', h.destdir.value, h.dest_fs.value);
  
  var f = showdir.document.ls;
  checked(index_element(f, n, i), true);
  conv_buf.fill(f);

  conv_buf.commit(h);
}

function init_properties() {
  if (!showdir.document.ls) return;

  var f = hidden.document.hiddenform;
  var edit_buf = new SelectionBuffer('init_properties', f.destdir.value, f.dest_fs.value);
  edit_buf.fill(showdir.document.ls);

  var tmp_action = f.action;

  f.action = "fm-properties";
  selected_files = 0;
  update_glob_buttons();
  edit_buf.commit(f);
  f.action = tmp_action;
}

function LRO (taskid, status, percent, exitstatus) {
  this.id = taskid;
  this.status = status;
  this.percent = percent;
  this.exitstatus = exitstatus;
}

function Hash() {
  var kvp;

  if (arguments.length == 1) {
    kvp = arguments[0].split(',');
  } else {
    kvp = arguments;
  }

  if (kvp.length % 2) return;
  
  for (var i = 0; i < kvp.length; i += 2) {
    this[kvp[i]] = kvp[i+1];
  }
}

function FsItem(name) {
  this.name = name;
  this.props = '';
  for (var i = 1; i < arguments.length; i++) {
    this.props += (this.props ? ',' : '') + arguments[i];
  }
  this.props = new Hash(this.props);
  this.toString = function() {
    var str = this.name + '';
    for (var n in this.props) {
      str += ';' + n + '=' + this.props[n]
    }
    return str;
  }
}

function SelectionBuffer(op, cwd, cwd_fs) {
  this.op = op;
  this.src = cwd;
  this.srcFs = cwd_fs;

  this.items = new Array();
  this.length = 0;

  this.push = function(item) {
    this.items[this.items.length] = item;
    this.length = this.items.length;
  };

  this.pop = function() {
    var tmp = this.items[this.items.length - 1];
    this.items.length--;
    this.length = this.items.length;
    return tmp;
  }

  this.fill = function(f) {
    var msg = "There are no files or directories selected.";
    if (!showdir.document.ls) {
      alert(msg);
      return;
    }
    var t = new Array("file", "dir");

    updateIcons(f, this.op);

    for (var n in t) {
      if (!f.elements[t[n]]) continue;

      var type = (t[n] == 'file' ? 'f_' : 'd_');

      if (f.elements[t[n]][1]) {
        for (var i = 0; i < f.elements[t[n]].length; i++) {
          if (checked(index_element(f, t[n], i))) {
            this.push(new FsItem(value(index_element(f, t[n], i)),
                      "type", value(index_element(f, type+'type', i))));
            checked(index_element(f, t[n], i), false);
          }
        }
      } else {
        if (checked(index_element(f, t[n], 0))) {
          this.push(new FsItem(value(index_element(f, t[n], 0)),
                    "type", value(index_element(f, type+'type', 0))));
          checked(index_element(f, t[n], 0), false);
        }
      }
    }

    selected_files = 0;

    if (this.length < 1) {
      alert(msg);
      return;
    }
  }

  this.commit = function(f) {
    if (this.length < 1) return;

    var str = '';
    for (var i = 0; i < this.items.length; i++) {
      str += (str ? '|' : '') + this.items[i].toString();
    }

    f.op.value = this.op;
    f.files.value = str;
    f.src_fs.value = this.srcFs;
    if (this.op == 'cut') {
      this.items = new Array();
      this.length = 0;
    }
    bInitHidden = true;
    selected_files = 0;
    f.submit();
  }
}

var selected_files = 0;

function setup_file_checkboxes(f) {
  selected_files = 0;

  if (!f) f = showdir.document.ls;
  if (!f) return;

  var t = new Array("file", "dir");
  for (var n in t) {
    if (!f.elements[t[n]]) continue;
    if (f.elements[t[n]][1]) {
      for (var i = 0; i < f.elements[t[n]].length; i++) {
        index_element(f, t[n], i).onclick = toggle_cut_copy;
      }
    } else {
      index_element(f, t[n], 0).onclick = toggle_cut_copy;
    }
  }
}

var dele_imx = new Array(new Image(), new Image());
dele_imx[0].src = "/vmware/themes/default/imx/fm/rm-disabled.gif";
dele_imx[1].src = "/vmware/themes/default/imx/fm/rm.gif";

var edit_imx = new Array(new Image(), new Image());
edit_imx[0].src = "/vmware/themes/default/imx/fm/properties-disabled.gif";
edit_imx[1].src = "/vmware/themes/default/imx/fm/properties.gif";

var cut_imx = new Array(new Image(), new Image());
cut_imx[0].src = "/vmware/themes/default/imx/fm/cut-disabled.gif";
cut_imx[1].src = "/vmware/themes/default/imx/fm/cut.gif";

var copy_imx = new Array(new Image(), new Image());
copy_imx[0].src = "/vmware/themes/default/imx/fm/copy-disabled.gif";
copy_imx[1].src = "/vmware/themes/default/imx/fm/copy.gif";

var paste_imx = new Array(new Image(), new Image());
paste_imx[0].src = "/vmware/themes/default/imx/fm/paste-disabled.gif";
paste_imx[1].src = "/vmware/themes/default/imx/fm/paste.gif";

var mkdir_imx = new Array(new Image(), new Image());
mkdir_imx[0].src = "/vmware/themes/default/imx/fm/new-disabled.gif";
mkdir_imx[1].src = "/vmware/themes/default/imx/fm/new.gif";

var home_imx = new Array(new Image(), new Image());
home_imx[0].src = "/vmware/themes/default/imx/fm/home-disabled.gif";
home_imx[1].src = "/vmware/themes/default/imx/fm/home.gif";

var parent_imx = new Array(new Image(), new Image());
parent_imx[0].src = "/vmware/themes/default/imx/fm/parent-disabled.gif";
parent_imx[1].src = "/vmware/themes/default/imx/fm/parent.gif";

var cd_imx = new Array(new Image(), new Image());
cd_imx[0].src = "/vmware/themes/default/imx/fm/cd-disabled.gif";
cd_imx[1].src = "/vmware/themes/default/imx/fm/cd.gif";


function toggle_cut_copy(e) {
  if (document.all) { 
    e = showdir.event.srcElement;
  } else {
    e = e.target;
  }

  if (checked(e)) {
    selected_files++;
  } else {
    selected_files--;
  }

  update_glob_buttons();
}

function update_pwd_buttons() {
  var imx = pwd.document.images;
  if (!buttons_locked) {
    imx["mkdir"].src = mkdir_imx[1].src;
    imx["home"].src = home_imx[1].src;
    imx["parent"].src = parent_imx[1].src;
    imx["cd"].src = cd_imx[1].src;
  } else {
    imx["mkdir"].src = mkdir_imx[0].src;
    imx["home"].src = home_imx[0].src;
    imx["parent"].src = parent_imx[0].src;
    imx["cd"].src = cd_imx[0].src;
  }
}

function update_glob_buttons() {
  var imx = glob.document.images;

  if (selected_files > 0 && !buttons_locked) {
    imx["dele"].src = dele_imx[1].src;
    imx["edit"].src = edit_imx[1].src;
    imx["cut"].src = cut_imx[1].src;
    imx["copy"].src = copy_imx[1].src;
  } else {
    imx["dele"].src = dele_imx[0].src;
    imx["edit"].src = edit_imx[0].src;
    imx["cut"].src = cut_imx[0].src;
    imx["copy"].src = copy_imx[0].src;
  }

  if (cut_copy_buf && cut_copy_buf.length > 0 && !buttons_locked) {
    imx["paste"].src = paste_imx[1].src;
  } else {
    imx["paste"].src = paste_imx[0].src;
  }
}

var cut_copy_buf;

function cut() { cut_copy('cut'); }
function copy() { cut_copy('copy'); }
function cut_copy(op) {
  var h = hidden.document.hiddenform;
  cut_copy_buf = new SelectionBuffer(op, h.destdir.value, h.dest_fs.value);
  cut_copy_buf.fill(parent.showdir.document.ls);

  update_glob_buttons();
}

function paste() {
  if (!cut_copy_buf) return;

  if (!showdir.document.ls) {
    alert("There is no destination to paste to.");
    return;
  }

  if (cut_copy_buf.length < 1) {
    alert("There are no files or directories to paste.");
    return;
  }
 
  if (bCurDirVmfsMountPoint) {
    for (var i = 0; i < cut_copy_buf.length; i++) {
      if (cut_copy_buf.items[i].props["type"] == "dir") {
        alert("A VMFS file system cannot contain directories. The paste operation cannot be completed because the clipboard contains one or more directories.");
        return;
      }
    }
  }

  cut_copy_buf.commit(parent.hidden.document.hiddenform);

  update_glob_buttons();
}

var buttons_locked = false;

function lock_buttons(b) {
  buttons_locked = b;
  update_glob_buttons();
  update_pwd_buttons();
}

var unframing = false;

function unframe(w) {
  if (unframing) return;
  unframing = true;

  var loc = '';
  if (w != hidden && hidden.document && 
    hidden.document.hiddenform && hidden.document.hiddenform.destdir)
    loc = hidden.document.hiddenform.destdir.value;
  
  var cloc = '';
  var clocs = window.location.search.substring(1).split('&');
  for (var i = 0; i < clocs.length; i++) {
    if (clocs[i].indexOf("dir=") == 0) {
      cloc = clocs[i].split('=')[1];
    }
  }

  if (loc != cloc && loc.indexOf('/') == 0) {
    window.location.replace("/showdir?dir=" + loc);
  } else {
    window.location.reload(true);
  }
}