<?xml version="1.0" encoding="iso-8859-1"?>

<!DOCTYPE html [
<!ENTITY nbsp "<xsl:text disable-output-escaping='yes'>&amp;nbsp;</xsl:text>">
]>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
  
  <xsl:include href="common.xsl"/>

  <xsl:variable name="lro" select="/exec/out/lro"/>
  <xsl:variable name="dir" select="/exec/out/dir"/>
  <xsl:variable name="err" select="/exec/out/err"/>
  <xsl:variable name="execerror" select="/exec/out/execerror"/>
  <xsl:variable name="initexecerror" select="/exec/out/initexecerror"/>

  <xsl:template match="/">
    <html>
      <head>
        <title>VMware MUI File Manager</title>
        <style>
          td, p, blockquote, li {font-family: Verdana, sans-serif; font-size: 11px; }
        </style>
	<xsl:call-template name="fileUtils"/>
        <script>
          var pb_imx = new Array();
          pb_imx[pb_imx.length] = new Image(10,16);
          pb_imx[pb_imx.length - 1].src = '<xsl:value-of select="$imx"/>FFFFFF.png';
          pb_imx[pb_imx.length] = new Image(10,16);
          pb_imx[pb_imx.length - 1].src = '<xsl:value-of select="$imx"/>CCCCCC.png';
          pb_imx[pb_imx.length] = new Image(10,16);
          pb_imx[pb_imx.length - 1].src = '<xsl:value-of select="$imx"/>999999.png';
          pb_imx[pb_imx.length] = new Image(10,16);
          pb_imx[pb_imx.length - 1].src = '<xsl:value-of select="$imx"/>666666.png';
          pb_imx[pb_imx.length] = new Image(10,16);
          pb_imx[pb_imx.length - 1].src = '<xsl:value-of select="$imx"/>333333.png';
          pb_imx[pb_imx.length] = new Image(10,16);
          pb_imx[pb_imx.length - 1].src = '<xsl:value-of select="$imx"/>000000.png';

          var w = parent.hidden;
          var lro = '<xsl:value-of select="$lro"/>';
          var dir = escapeFileName('<xsl:value-of select="$dir"/>');
          var taskid = '<xsl:for-each select="/exec/out/task"><xsl:value-of select="@id"/><xsl:if test="not(position()=last())">,</xsl:if></xsl:for-each>';
          var errors = 0;

          function stat_cb(tasks, execerror) {
            var percent = tasks.length ? 0 : 100;
            var i = 0;

            while (tasks.length) {
              if (i == tasks.length) { break };
              
              if (tasks[i].status == 'aborted' ||
                  tasks[i].status == 'interrupted' ||
                  tasks[i].status == 'start_failed') {
                errors++;
                percent += 100;
              } else if (tasks[i].status == 'cleanup') {
                percent += 100;
              } else if (tasks[i].status == 'exited') {
                if (tasks[i].exitstatus != 0) {
                  errors++;
                }
                percent += 100;
              } else {
                percent += tasks[i].percent;
              }

              i++;
            }

            percent = parseInt(percent / tasks.length);

            var slop = percent % 10;
            var blocks = (percent - slop) / 10;
            
            i = 0;
            while (true) {
              if (i == blocks) { break; }
              if(!window.document.images['per_'+i]) { break; }
              window.document.images['per_'+i].src = pb_imx[5].src;
              i++;
            }

            if (slop > 1) {
              if (window.document.images['per_'+i])
                window.document.images['per_'+i].src = pb_imx[parseInt(slop/2)].src;
            }

            if (percent == 100) {
              w.location.replace('/showdir?op=hide');

              var execerrorstring = "";
              if (execerror) {
                errors++;
                execerrorstring = unescape("%26") + 'execerror=1';
              }
         
              if (errors > 0) {
                window.location.replace('/lro?op=init_task_errors' +
                  unescape("%26") + 'taskid=' + taskid +
                  unescape("%26") + 'lro=' + lro + execerrorstring +
                  unescape("%26") + 'dir=' + dir);
              } else {
                window.location.replace('/lro?op=dele_task' +
                  unescape("%26") + 'taskid=' + taskid +
                  unescape("%26") + 'dir=' + dir);
              }
            } else {
              window.setTimeout("stat_task("+execerror+")", 1000);
            }
          }

          function stat_task(execerror) {
            var execerrorstring = "";
            if (execerror) {
              execerrorstring =  unescape("%26") + 'execerror=1';
            }
            w.location.replace("/lro?op=stat_task" +
              unescape("%26") + 'lro=' + lro + execerrorstring + 
              unescape("%26") + 'taskid=' + taskid + 
              unescape("%26") + 'dir=' + dir);
          }

          function cancel() {
            w.location.replace("/showdir?op=hide");
            window.location.replace('/lro?op=stop_task' +
              unescape("%26") + 'taskid=' + taskid +
              unescape("%26") + 'dir=' + dir);
          }

          function setup() {
            if (parent.lock_buttons) parent.lock_buttons(true);
          }
        </script>
      </head>
      <body bgcolor="#FFFFFF">
        <xsl:if test="not($err=1)">
          <xsl:choose>
            <xsl:when test="$initexecerror">
               <xsl:attribute name="onLoad">setup(); window.setTimeout('stat_task(true)', 1000);</xsl:attribute>
            </xsl:when>
            <xsl:otherwise>
               <xsl:attribute name="onLoad">setup(); window.setTimeout('stat_task(false)', 1000);</xsl:attribute>
            </xsl:otherwise>
          </xsl:choose>
        </xsl:if>

        <br />
        <br />
        <table align="center" border="0" cellpadding="0" cellspacing="0">
          <tr>
            <td><img src="{$common.imx}fm/field-tl.gif" width="7" height="7"/></td>
            <td background="{$common.imx}fm/field-t.gif"><img src="{$common.imx}fm/field-t.gif" width="1" height="7"/></td>
            <td><img src="{$common.imx}fm/field-tr.gif" width="7" height="7"/></td>
          </tr>
          <tr>
            <td background="{$common.imx}fm/field-l.gif"><img src="{$common.imx}fm/field-l.gif" width="7" height="1"/></td>
            <td bgcolor="#E6E6CC" align="right">
              <xsl:choose>
                <xsl:when test="not($err='1') and not($execerror)">
                  <table border="0" cellpadding="0" cellspacing="0">
                    <tr>
                      <td>
                        <b>
                          <xsl:choose>
                            <xsl:when test="$lro='cp'">Copy Progress:</xsl:when>
                            <xsl:when test="$lro='mv'">Move Progress:</xsl:when>
                            <xsl:when test="$lro='convert'">Conversion Progress:</xsl:when>
                            <xsl:otherwise>Operation Progress:</xsl:otherwise>
                          </xsl:choose>
                          &nbsp;
                        </b>
                      </td>
                      <td style="color:999980;"><font color="#999980"><img name="per_0" src="{$imx}FFFFFF.png" width="8" height="11" vspace="2" hspace="1" border="1"/><img name="per_1" src="{$imx}FFFFFF.png" width="8" height="11" vspace="2" hspace="1" border="1"/><img name="per_2" src="{$imx}FFFFFF.png" width="8" height="11" vspace="2" hspace="1" border="1"/><img name="per_3" src="{$imx}FFFFFF.png" width="8" height="11" vspace="2" hspace="1" border="1"/><img name="per_4" src="{$imx}FFFFFF.png" width="8" height="11" vspace="2" hspace="1" border="1"/><img name="per_5" src="{$imx}FFFFFF.png" width="8" height="11" vspace="2" hspace="1" border="1"/><img name="per_6" src="{$imx}FFFFFF.png" width="8" height="11" vspace="2" hspace="1" border="1"/><img name="per_7" src="{$imx}FFFFFF.png" width="8" height="11" vspace="2" hspace="1" border="1"/><img name="per_8" src="{$imx}FFFFFF.png" width="8" height="11" vspace="2" hspace="1" border="1"/><img name="per_9" src="{$imx}FFFFFF.png" width="8" height="11" vspace="2" hspace="1" border="1"/></font></td>
                    </tr>
                  </table>  
                </xsl:when>
                <xsl:otherwise>
                  <table width="380" border="0" cellpadding="0" cellspacing="0">
                    <tr>
                      <td valign="top"><img src="{$common.imx}error.gif" width="32" height="32"/></td>
                      <td>&nbsp; &nbsp; &nbsp;</td>
                      <td>
                        <p><b>Error</b></p>

                        <p>
                          One or more errors were encountered while completing the
                          <xsl:choose>
                            <xsl:when test="$lro='cp'">copy operation.</xsl:when>
                            <xsl:when test="$lro='mv'">move operation.</xsl:when>
                            <xsl:otherwise>requested operation.</xsl:otherwise>
                          </xsl:choose>
                        </p>

                        <xsl:for-each select="/exec/out/task">
                          <xsl:variable name="interruptsignal" select="./interruptsignal"/>
                          <xsl:variable name="error" select="./error"/>
                          <xsl:variable name="taskStderr" select="./taskStderr"/>
                          <xsl:variable name="msg" select="./msg"/>
                          <xsl:if test="$interruptsignal">
                            <ul>
                              <li>The operation was interrupted by signal <xsl:value-of select="$interruptsignal"/>.</li>
                            </ul>
                          </xsl:if>
                          <xsl:if test="$error">
                            <ul>
                              <li><xsl:value-of select="$error"/></li>
                            </ul>
                          </xsl:if>
                          <xsl:if test="$taskStderr">
                            <ul>
                              <li><xsl:value-of select="$taskStderr"/></li>
                            </ul>
                          </xsl:if>
                          <xsl:if test="$msg">
                            <ul>
                              <li><xsl:value-of select="$msg"/></li>
                            </ul>
                          </xsl:if>
                        </xsl:for-each>
                        <xsl:if test="$execerror">
                            <ul>
                              <li>One or more operations did not start successfully. More information may be available in the Apache error log.</li>
                            </ul>
                        </xsl:if>
                      </td>
                    </tr>
                  </table>  
                </xsl:otherwise>
              </xsl:choose>
            </td>
            <td background="{$common.imx}fm/field-r.gif"><img src="{$common.imx}fm/field-r.gif" width="7" height="1"/></td>
          </tr>
          <tr>
            <td background="{$common.imx}fm/field-l.gif"><img src="{$common.imx}fm/field-l.gif" width="7" height="1"/></td>
            <td bgcolor="#E6E6CC"><img src="{$imx}spacer.gif" width="1" height="7"/></td>
            <td background="{$common.imx}fm/field-r.gif"><img src="{$common.imx}fm/field-r.gif" width="7" height="1"/></td>
          </tr>
          <tr>
            <td background="{$common.imx}fm/field-l.gif"><img src="{$common.imx}fm/field-l.gif" width="7" height="1"/></td>
            <td align="right" bgcolor="#E6E6CC"><a href="javascript:cancel();">
              <xsl:choose>
                <xsl:when test="not($err='1')">
                  <img src="{$common.imx}fm/cancel.gif" width="41" height="14" border="0"/>
                </xsl:when>
                <xsl:otherwise>
                  <img src="{$common.imx}fm/ok.gif" width="27" height="14" border="0"/>
                </xsl:otherwise>
              </xsl:choose>
            </a></td>
            <td background="{$common.imx}fm/field-r.gif"><img src="{$common.imx}fm/field-r.gif" width="7" height="1"/></td>
          </tr>
          <tr>
            <td><img src="{$common.imx}fm/field-bl.gif" width="7" height="7"/></td>
            <td background="{$common.imx}fm/field-b.gif"><img src="{$common.imx}fm/field-b.gif" width="1" height="7"/></td>
            <td><img src="{$common.imx}fm/field-br.gif" width="7" height="7"/></td>
          </tr>
        </table>
      </body>
    </html>
  </xsl:template>

</xsl:stylesheet>