<?xml version="1.0" encoding="iso-8859-1"?>
<!-- Todo:
  
     [!DOCTYPE] Put common enitity declarations into a DTD. But DTDs don't seem
     to be working correctly. Hmmm.

  -->
<!DOCTYPE html [
<!ENTITY nbsp "<xsl:text disable-output-escaping='yes'>&amp;nbsp;</xsl:text>">
<!ENTITY ampersand "<xsl:text disable-output-escaping='yes'>&amp;</xsl:text>">
]>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
  <!-- [ ! ] --><xsl:include href="common.xsl"/>
  <xsl:include href="../../js-import.xsl"/>
  <xsl:include href="controlmenu.xsl"/>

  <xsl:variable name="vm_colspan">12</xsl:variable>

  <xsl:template match="/">
    <HTML>
      <HEAD>
        <TITLE><xsl:value-of select="/server/vm/displayName"/> Error - <xsl:value-of select="/server/host"/>.<xsl:value-of select="/server/host@domain"/></TITLE>
        <SCRIPT>
          <xsl:choose>
            <xsl:when test="/server/product@id='ESX'">
              var product = "ESX";
            </xsl:when>
            <xsl:otherwise>
              var product = "GSX";
            </xsl:otherwise>
          </xsl:choose>
          var noRefresh = true;
          var hostOS = "<xsl:value-of select="/server/host@os"/>";
          <xsl:call-template name="js-src">
            <xsl:with-param name="src">../../util-js.xml</xsl:with-param>
            <xsl:with-param name="use">
              <obj use-recommended="1">Is</obj>
            </xsl:with-param>
          </xsl:call-template>
          <xsl:call-template name="js-src">
            <xsl:with-param name="src">controlmenu-js.xml</xsl:with-param>
          </xsl:call-template>
        </SCRIPT>
        <SCRIPT src="{$common}server.js"></SCRIPT>
        <LINK rel="stylesheet" href="{$common}style.css" type="text/css" />
      </HEAD>

      <BODY background="{$imx}FFFFFF.png" bgcolor="#FFFFFF" link="#000000" vlink="#000000" topmargin="6" leftmargin="6" marginwidth="6" marginheight="6" onload="setup();ctrlMenuSetup();">
        <xsl:call-template name="poweroffMenu"/>
        <xsl:call-template name="poweronMenu"/>
        <xsl:call-template name="suspendMenu"/>
        <xsl:call-template name="softableMenu"/>
        <xsl:call-template name="readonlyMenu"/>
        <xsl:call-template name="unreachableMenu"/>

        <xsl:call-template name="operationForm"/>
      
        <FORM name="form" method="post" action="javascript:noop();" onSubmit="javascript:handleSubmit();">
          <xsl:call-template name="pageHeader">
            <xsl:with-param name="uiPath">
              <location href="/overview">VMs on <xsl:value-of select="/server/host"/><xsl:if test="/server/host@domain">.<xsl:value-of select="/server/host@domain"/></xsl:if></location>
              <location href="/details?c={/server/vm/safe_cfg}"><xsl:value-of select="/server/vm/displayName"/></location>
              <current>Error</current>
            </xsl:with-param>
          </xsl:call-template>

          <xsl:if test="/server/error">
            <P>
              <TABLE><TR>
                <TD><IMG src="{$imx}spacer.gif" width="128" height="1"/></TD>
                <TD>
                  <xsl:call-template name="error"/>
                </TD>
                <TD><IMG src="{$imx}spacer.gif" width="128" height="1"/></TD>
              </TR></TABLE>
            </P>
          </xsl:if>

          <xsl:if test="/server/vm">
            <TABLE width="100%" border="0" cellpadding="1" cellspacing="0">
              <TR><TD><IMG src="{$imx}spacer.gif" width="1" height="6"/></TD></TR>
              <TR><TD background="{$imx}999980.png" bgcolor="#999980">
                <TABLE width="100%" border="0" cellpadding="0" cellspacing="0"><TR><TD background="{$imx}FFFFE6.png" bgcolor="#FFFFE6"><TABLE width="100%" border="0" cellpadding="3" cellspacing="1">
                  <xsl:call-template name="vmHeader">
                    <xsl:with-param name="stats">
                      <heartbeat/>
                      <uptime/>
                    </xsl:with-param>
                  </xsl:call-template>
                  <xsl:call-template name="vmRow">
                    <xsl:with-param name="position"><xsl:value-of select="1"/></xsl:with-param>
                    <xsl:with-param name="stats">
                      <heartbeat/>
                      <uptime/>
                    </xsl:with-param>
                  </xsl:call-template>
                </TABLE></TD></TR></TABLE>
              </TD></TR>
              <TR><TD><IMG src="{$imx}spacer.gif" width="1" height="6"/></TD></TR>
            </TABLE>
          </xsl:if>

          <xsl:call-template name="pageFooter">
            <xsl:with-param name="disable">
              <newvm/>
              <update/>
            </xsl:with-param>
          </xsl:call-template>

          <P>
            <xsl:call-template name="labelFooter"/>
          </P>
        </FORM>
      </BODY>
    </HTML>
  </xsl:template>
</xsl:stylesheet>