<?xml version="1.0" encoding="iso-8859-1"?>
<!-- Todo:
  
     [!DOCTYPE] Put common enitity declarations into a DTD. But DTDs don't seem
     to be working correctly. Hmmm.

  -->
<!DOCTYPE html [
<!ENTITY nbsp "<xsl:text disable-output-escaping='yes'>&amp;nbsp;</xsl:text>">
<!ENTITY ampersand "<xsl:text disable-output-escaping='yes'>&amp;</xsl:text>">
]>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
  <!-- [ ! ] --><xsl:include href="common.xsl"/>
  <xsl:include href="../../js-import.xsl"/>
  <xsl:include href="pageHelp.xsl"/>
  <xsl:include href="controlmenu.xsl"/>

  <xsl:variable name="vm_colspan">17</xsl:variable>

  <xsl:template match="/">
    <xsl:variable name="win32_suffix">
      <xsl:if test="/server/host@os = 'MSWin32'">/index.pl</xsl:if>
    </xsl:variable>
    <HTML>
      <HEAD>
        <TITLE><xsl:value-of select="/server/host"/>.<xsl:value-of select="/server/host@domain"/> - VMware Management Interface</TITLE>
        <META http-equiv="Refresh" content="180; url=/overview{$win32_suffix}?auto-refresh=1"/>
        <SCRIPT>
          <xsl:choose>
            <xsl:when test="/server/product@id='ESX'">
              var product = "ESX";
            </xsl:when>
            <xsl:otherwise>
              var product = "GSX";
            </xsl:otherwise>
          </xsl:choose>
          var noRefresh = true;
          //var refreshRate = new Array( );
          //refreshRate['minutes'] = '3';
          //refreshRate['seconds'] = '0';
          var hostOS = "<xsl:value-of select="/server/host@os"/>";
          <xsl:call-template name="js-src">
            <xsl:with-param name="src">../../util-js.xml</xsl:with-param>
            <xsl:with-param name="use">
              <obj use-recommended="1">Is</obj>
            </xsl:with-param>
          </xsl:call-template>
          <xsl:call-template name="js-src">
            <xsl:with-param name="src">controlmenu-js.xml</xsl:with-param>
          </xsl:call-template>
        </SCRIPT>
        <SCRIPT src="{$common}server.js"></SCRIPT>
        <LINK rel="stylesheet" href="{$common}style.css" type="text/css" />
      </HEAD>

      <BODY bgcolor="#FFFFFF" link="#000000" vlink="#000000" topmargin="6" leftmargin="6" marginwidth="6" marginheight="6" onload="setup();ctrlMenuSetup();">
        <xsl:call-template name="poweroffMenu"/>
        <xsl:call-template name="poweronMenu"/>
        <xsl:call-template name="suspendMenu"/>
        <xsl:call-template name="softableMenu"/>
        <xsl:call-template name="readonlyMenu"/>
        <xsl:call-template name="unreachableMenu"/>
             
        <xsl:call-template name="operationForm"/>
        
          <xsl:call-template name="pageHeader">
            <xsl:with-param name="xtra_ctrl">
              <xsl:choose>
                <xsl:when test="/server/product@id='ESX'">
                  <ctrl>
                    <label>
                      <xsl:choose>
                        <xsl:when test="/server/username='root'">Manage Resources</xsl:when>
                        <xsl:otherwise>Monitor Resources</xsl:otherwise>
                      </xsl:choose>
                    </label>
                    <action>/resources</action>
                  </ctrl>
                </xsl:when>
                <xsl:otherwise><none/></xsl:otherwise>
              </xsl:choose>
            </xsl:with-param>
          </xsl:call-template>

          <xsl:if test="/server/error">
            <P>
              <TABLE><TR>
                <TD><IMG src="{$imx}spacer.gif" width="128" height="1"/></TD>
                <TD>
                  <xsl:call-template name="error"/>
                </TD>
                <TD><IMG src="{$imx}spacer.gif" width="128" height="1"/></TD>
              </TR></TABLE>
            </P>
          </xsl:if>

          <TABLE width="100%" border="0" cellpadding="1" cellspacing="0">
            <TR><TD><IMG src="{$imx}spacer.gif" width="1" height="6"/></TD></TR>
            <TR><TD bgcolor="#999980">
              <TABLE width="100%" border="0" cellpadding="0" cellspacing="0"><TR><TD bgcolor="#FFFFE6"><TABLE width="100%" border="0" cellpadding="3" cellspacing="1">
                <xsl:call-template name="vmHeader">
                  <xsl:with-param name="stats">
                    <heartbeat/>
                    <uptime/>
                    <cpu/>
                    <ram/>
                  </xsl:with-param>
                </xsl:call-template>
                <FORM name="form" method="POST" action="javascript:noop();" onSubmit="javascript:handleSubmit();">
                  <xsl:call-template name="VMs"/>
                </FORM>
                <TR bgcolor="#CCCCB3">
                  <TD width="1%" nowrap="true"><NOBR><IMG name="ALL.6" src="{$imx}spacer.gif" width="15" height="15" border="0"/></NOBR></TD>
                  <TD width="1%" nowrap="true"><NOBR><IMG name="ALL.0" src="{$imx}spacer.gif" width="15" height="15" border="0"/></NOBR></TD>
                  <TD width="1%" nowrap="true"><NOBR><IMG name="ALL.2" src="{$imx}spacer.gif" width="15" height="15" border="0"/></NOBR></TD>
                  <TD width="1%" nowrap="true"><NOBR><IMG name="ALL.1" src="{$imx}spacer.gif" width="15" height="15" border="0"/></NOBR></TD>
                  <TD width="1%" nowrap="true"><NOBR><IMG name="ALL.3" src="{$imx}spacer.gif" width="15" height="15" border="0"/></NOBR></TD>
                  <TD colspan="6" align="right" nowrap="true"><NOBR><SMALL>System Summary:</SMALL></NOBR></TD>
                  <TD width="1%" nowrap="true"><NOBR><SMALL><TT>
<!--                    <xsl:value-of select="/server/uptime/days"/>d-->
<!--                    <xsl:value-of select="/server/uptime/hours"/>h-->
<!--                    <xsl:value-of select="/server/uptime/minutes"/>m-->
                    <xsl:choose>
                      <xsl:when test="/server/uptime and number(/server/uptime/days)&lt;10">&nbsp;&nbsp;<xsl:value-of select="/server/uptime/days"/>d&nbsp;</xsl:when>
                      <xsl:when test="/server/uptime and number(/server/uptime/days)&lt;100">&nbsp;<xsl:value-of select="/server/uptime/days"/>d&nbsp;</xsl:when>
                      <xsl:when test="/server/uptime and number(/server/uptime/days)&gt;99"><xsl:value-of select="/server/uptime/days"/>d&nbsp;</xsl:when>
                      <xsl:otherwise>&nbsp;&nbsp;<FONT color="#999980">0d&nbsp;</FONT></xsl:otherwise>
                    </xsl:choose>
                    <xsl:choose>
                      <xsl:when test="/server/uptime and number(/server/uptime/hours)&lt;10">&nbsp;<xsl:value-of select="/server/uptime/hours"/>h&nbsp;</xsl:when>
                      <xsl:when test="/server/uptime and number(/server/uptime/hours)&gt;9"><xsl:value-of select="/server/uptime/hours"/>h&nbsp;</xsl:when>
                      <xsl:otherwise><FONT color="#999980">&nbsp;0h&nbsp;</FONT></xsl:otherwise>
                    </xsl:choose>
                    <xsl:choose>
                      <xsl:when test="/server/uptime and number(/server/uptime/minutes)&lt;10">&nbsp;<xsl:value-of select="/server/uptime/minutes"/>m</xsl:when>
                      <xsl:when test="/server/uptime and number(/server/uptime/minutes)&gt;9"><xsl:value-of select="/server/uptime/minutes"/>m</xsl:when>
                      <xsl:otherwise><FONT color="#999980">&nbsp;0m</FONT></xsl:otherwise></xsl:choose>
                  </TT></SMALL></NOBR></TD>
                  <xsl:variable name="cpu"><xsl:value-of select="/server/stat[@name='cpu']/usage[@type='avg']/sample[@interval='1']"/></xsl:variable>
                  <TD width="1%" align="right"><SMALL><TT>
<!--                    <xsl:value-of select="$cpu"/>-->
                    <xsl:choose>
                      <xsl:when test="not(/server/stat[@name='cpu'])">
                        &nbsp;<FONT color="#999980">0</FONT>
                      </xsl:when>
                      <xsl:otherwise>
                        <xsl:if test="$cpu&lt;10">&nbsp;</xsl:if>
                        <xsl:value-of select="$cpu"/>
                      </xsl:otherwise>
                    </xsl:choose>
                  </TT></SMALL></TD>
                  <TD width="1%">
                    <xsl:call-template name="usage_bar">
                      <xsl:with-param name="sample" select="$cpu"/>
                      <xsl:with-param name="denominator" select="2"/>
                    </xsl:call-template>
                  </TD>
                  <xsl:variable name="ram"><xsl:value-of select="/server/stat[@name='ram']/usage[@type='avg']/sample[@interval='1']"/></xsl:variable>
                  <TD width="1%" align="right"><SMALL><TT>
<!--                    <xsl:value-of select="$ram"/>-->
                    <xsl:choose>
                      <xsl:when test="not(/server/stat[@name='ram'])">
                        <FONT color="#CCCCB#">0</FONT><FONT color="#999980">0</FONT>
                      </xsl:when>
                      <xsl:otherwise>
                        <xsl:if test="$ram&lt;10">&nbsp;</xsl:if>
                        <xsl:value-of select="$ram"/>
                      </xsl:otherwise>
                    </xsl:choose>
                  </TT></SMALL></TD>
                  <TD width="1%">
                    <xsl:call-template name="usage_bar">
                      <xsl:with-param name="sample" select="$ram"/>
                      <xsl:with-param name="denominator" select="2"/>
                    </xsl:call-template>
                  </TD>
                </TR>
              </TABLE></TD></TR></TABLE>
            </TD></TR>
            <TR><TD><IMG src="{$imx}spacer.gif" width="1" height="6"/></TD></TR>
          </TABLE>

          <xsl:call-template name="pageFooter"/>

          <P>
            <xsl:call-template name="help-src">
              <xsl:with-param name="src">en/overview.xml</xsl:with-param>
            </xsl:call-template>
          </P>
          
          <xsl:call-template name="labelFooter"/>
      </BODY>
    </HTML>
  </xsl:template>

  <xsl:template name="VMs">
    <xsl:choose>
      <xsl:when test="/server/vm">
        <xsl:for-each select="/server/vm">
          <xsl:call-template name="vmRow">
            <xsl:with-param name="position"><xsl:value-of select="position()"/></xsl:with-param>
            <xsl:with-param name="stats">
              <heartbeat/>
              <uptime/>
              <cpu/>
              <ram/>
            </xsl:with-param>
          </xsl:call-template>
          <!-- Try to chunk the table every 3 rows of VMs so Navigator doesn't barf on long lists. -->
          <xsl:choose>
            <xsl:when test="not(position()=last()) and (position() mod 9=0)">
              <xsl:variable name="new_table"><![CDATA[</TABLE></TD></TR></TABLE></TD></TR></TABLE><TABLE width="100%" border="0" cellpadding="1" cellspacing="0"><TR><TD><IMG src="]]><xsl:value-of select="$imx"/><![CDATA[spacer.gif" width="1" height="1"/></TD></TR><TR><TD bgcolor="#999980"><TABLE width="100%" border="0" cellpadding="0" cellspacing="0"><TR><TD bgcolor="#FFFFE6"><TABLE width="100%" border="0" cellpadding="3" cellspacing="1">]]></xsl:variable>
              <xsl:text disable-output-escaping="yes"><xsl:value-of select="$new_table"/></xsl:text>
            </xsl:when>
            <xsl:when test="not(position()=last()) and (position() mod 3=0)">
              <TR bgcolor="#E6E6CC">
                <TD><IMG src="{$imx}spacer.gif" width="1" height="1"/></TD>
                <TD><IMG src="{$imx}spacer.gif" width="1" height="1"/></TD>
                <TD><IMG src="{$imx}spacer.gif" width="1" height="1"/></TD>
                <TD><IMG src="{$imx}spacer.gif" width="1" height="1"/></TD>
                <TD><IMG src="{$imx}spacer.gif" width="1" height="1"/></TD>
                <TD><IMG src="{$imx}spacer.gif" width="1" height="1"/></TD>
                <TD><IMG src="{$imx}spacer.gif" width="1" height="1"/></TD>
                <TD><IMG src="{$imx}spacer.gif" width="1" height="1"/></TD>
                <TD><IMG src="{$imx}spacer.gif" width="1" height="1"/></TD>
                <TD><IMG src="{$imx}spacer.gif" width="1" height="1"/></TD>
                <TD><IMG src="{$imx}spacer.gif" width="1" height="1"/></TD>
                <TD><IMG src="{$imx}spacer.gif" width="1" height="1"/></TD>
                <TD><IMG src="{$imx}spacer.gif" width="1" height="1"/></TD>
                <TD><IMG src="{$imx}spacer.gif" width="1" height="1"/></TD>
                <TD><IMG src="{$imx}spacer.gif" width="1" height="1"/></TD>
                <TD><IMG src="{$imx}spacer.gif" width="1" height="1"/></TD>
              </TR>
            </xsl:when>
          </xsl:choose>
        </xsl:for-each>
      </xsl:when>
      <xsl:otherwise>
        <TR bgcolor="#FFFFE6">
          <TD colspan="{$vm_colspan}" align="center"><SMALL>There are no registered virtual machines.</SMALL></TD>
        </TR>
      </xsl:otherwise>
    </xsl:choose>
  </xsl:template>
</xsl:stylesheet>
