<?xml version="1.0" encoding="iso-8859-1"?>
<!-- Todo:

     [!DOCTYPE] Put common enitity declarations into a DTD. But DTDs don't seem
     to be working correctly. Hmmm.

  -->
<!DOCTYPE html [
<!ENTITY nbsp "<xsl:text disable-output-escaping='yes'>&amp;nbsp;</xsl:text>">
<!ENTITY ampersand "<xsl:text disable-output-escaping='yes'>&amp;</xsl:text>">
]>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
  <!-- [ ! ] --><xsl:include href="common.xsl"/>
  <xsl:include href="../../js-import.xsl"/>
  <xsl:include href="pageHelp.xsl"/>
  <xsl:include href="controlmenu.xsl"/>

  <xsl:variable name="vm_colspan">16</xsl:variable>

  <xsl:template match="/">
    <HTML>
      <HEAD>
        <TITLE><xsl:value-of select="/server/host"/>.<xsl:value-of select="/server/host@domain"/> - Resource Monitor</TITLE>
        <xsl:choose>
          <xsl:when test="/server/mui@layout='new'">
            <script>
              setTimeout("this.location='/resources?mui=new'", 180000);
              function initPage () {
               setup();
               ctrlMenuSetup();
              }
            </script>
            <script src="/vmware/src/init.js"></script>
            <script src="/vmware/src/xuaLib.js"></script>
          </xsl:when>
          <xsl:otherwise>
            <META http-equiv="Refresh" content="180; url=/resources?auto-refresh=1"></META>
          </xsl:otherwise>
        </xsl:choose>
        <SCRIPT>
          <xsl:choose>
            <xsl:when test="/server/product@id='ESX'">
              var product = "ESX";
            </xsl:when>
            <xsl:otherwise>
              var product = "GSX";
            </xsl:otherwise>
          </xsl:choose>
          var noRefresh = true;
          //var refreshRate = new Array( );
          //refreshRate['minutes'] = '3';
          //refreshRate['seconds'] = '0';
          var hostOS = "<xsl:value-of select="/server/host@os"/>";
          <xsl:call-template name="js-src">
            <xsl:with-param name="src">../../util-js.xml</xsl:with-param>
            <xsl:with-param name="use">
              <obj use-recommended="1">Is</obj>
            </xsl:with-param>
          </xsl:call-template>
          <xsl:call-template name="js-src">
            <xsl:with-param name="src">controlmenu-js.xml</xsl:with-param>
          </xsl:call-template>
        </SCRIPT>
        <SCRIPT src="{$common}server.js"></SCRIPT>
        <LINK rel="stylesheet" href="{$common}style.css" type="text/css" />
      </HEAD>

      <xsl:param name="jsInit">setup();ctrlMenuSetup();</xsl:param>
      <BODY bgcolor="#FFFFFF" link="#000000" vlink="#000000" topmargin="6" leftmargin="6" marginwidth="6" marginheight="6">
      <xsl:choose>
        <xsl:when test="not(/server/mui@layout='new')">
          <xsl:attribute name="onLoad"><xsl:value-of select="$jsInit"/></xsl:attribute>
        </xsl:when>
        <xsl:otherwise><none/></xsl:otherwise>
      </xsl:choose>

        <xsl:call-template name="poweroffMenu"/>
        <xsl:call-template name="poweronMenu"/>
        <xsl:call-template name="suspendMenu"/>
        <xsl:call-template name="softableMenu"/>
        <xsl:call-template name="readonlyMenu"/>
        <xsl:call-template name="unreachableMenu"/>

        <xsl:call-template name="operationForm"/>

        <FORM name="form" method="POST" action="javascript:noop();" onSubmit="javascript:handleSubmit();">
          <xsl:call-template name="pageHeader">
            <xsl:with-param name="uiPath">
              <location href="/overview">VMs on <xsl:value-of select="/server/host"/><xsl:if test="/server/host@domain">.<xsl:value-of select="/server/host@domain"/></xsl:if></location>
              <current>Resource Monitor</current>
            </xsl:with-param>
            <xsl:with-param name="xtra_ctrl">
              <xsl:choose>
                <xsl:when test="/server/product@id='ESX'">
                  <xsl:if test="/server/username='root' and /server/mui@layout='new'">
                    <ctrl>
                      <label>View Memory Utilization</label>
                      <action>/stats/memory?mui=new</action>
                    </ctrl>
                  </xsl:if>
                  <xsl:if test="/server/username='root' and not(/server/mui@layout='new')">
                    <ctrl>
                      <label>View Memory Utilization</label>
                      <action>/stats/memory</action>
                    </ctrl>
                  </xsl:if>
                </xsl:when>
                <xsl:otherwise><none/></xsl:otherwise>
              </xsl:choose>
            </xsl:with-param>
          </xsl:call-template>

          <xsl:if test="/server/error">
            <P>
              <TABLE><TR>
                <TD><IMG src="{$imx}spacer.gif" width="128" height="1"/></TD>
                <TD>
                  <xsl:call-template name="error"/>
                </TD>
                <TD><IMG src="{$imx}spacer.gif" width="128" height="1"/></TD>
              </TR></TABLE>
            </P>
          </xsl:if>

          <TABLE width="100%" border="0" cellpadding="1" cellspacing="0">
            <TR><TD><IMG src="{$imx}spacer.gif" width="1" height="6"/></TD></TR>
            <TR><TD bgcolor="#999980">
              <TABLE width="100%" border="0" cellpadding="0" cellspacing="0"><TR><TD bgcolor="#FFFFE6"><TABLE width="100%" border="0" cellpadding="3" cellspacing="1">
                <xsl:call-template name="vmHeader">
                  <xsl:with-param name="states"><none/></xsl:with-param>
                  <xsl:with-param name="stats">
                    <cpu/>
                    <cpu-active/>
                    <ram/>
                    <ram-active/>
                    <xsl:if test="/server/system/nfshaper = '1'"><net/></xsl:if>
                  </xsl:with-param>
                </xsl:call-template>
                <xsl:call-template name="VMs"/>
                <TR bgcolor="#CCCCB3">
                  <TD width="1%" nowrap="true"><NOBR><IMG name="ALL.6" src="{$imx}spacer.gif" width="15" height="15" border="0"/></NOBR></TD>
                  <TD colspan="4" align="right" nowrap="true"><NOBR><SMALL>System Summary:</SMALL></NOBR></TD>
                  <xsl:variable name="cpu"><xsl:value-of select="/server/stat[@name='cpu']/usage[@type='avg']/sample[@interval='1']"/></xsl:variable>
                  <TD width="1%" align="right"><SMALL><TT>
                    <xsl:choose>
                      <xsl:when test="not(/server/stat[@name='cpu'])">
                        &nbsp;<FONT color="#999980">0</FONT>
                      </xsl:when>
                      <xsl:otherwise>
                        <xsl:if test="$cpu&lt;10">&nbsp;</xsl:if>
                        <xsl:value-of select="$cpu"/>
                      </xsl:otherwise>
                    </xsl:choose>
                  </TT></SMALL></TD>
                  <TD width="1%">
                    <xsl:call-template name="usage_bar">
                      <xsl:with-param name="sample" select="$cpu"/>
                      <xsl:with-param name="denominator" select="3"/>
                    </xsl:call-template>
                  </TD>
                  <xsl:variable name="active_cpu"><xsl:value-of select="sum(/server/vm/stat[@name='cpu-active' and @units='shares']/usage[@type='avg']/sample[@interval='1'])"/></xsl:variable>
                  <xsl:variable name="percent_cpu">
                    <xsl:value-of select="round((sum(/server/vm/stat[@name='cpu-active' and @units='shares']/usage[@type='avg']/sample[@interval='1']) div sum(/server/vm/cpu/shares)) * 100)"/>
                  </xsl:variable>
                  <TD width="1%" align="right"><SMALL><TT>
                    <xsl:value-of select="sum(/server/vm/cpu/shares)"/>
                  </TT></SMALL></TD>
                  <xsl:variable name="ram"><xsl:value-of select="/server/stat[@name='ram']/usage[@type='avg']/sample[@interval='1']"/></xsl:variable>
                  <xsl:variable name="mb_ram"><xsl:value-of select="sum(/server/vm/stat[@name='ram' and @units='MB']/usage[@type='avg']/sample[@interval='1'])"/></xsl:variable>
                  <TD width="1%" align="right"><SMALL><TT>
                    <xsl:choose>
                      <xsl:when test="not(/server/stat[@name='ram'])">
                        <FONT color="#CCCCB#">0</FONT><FONT color="#999980">0</FONT>
                      </xsl:when>
                      <xsl:otherwise>
                        <xsl:if test="$mb_ram&lt;10">&nbsp;</xsl:if>
                        <xsl:value-of select="$mb_ram"/>
                      </xsl:otherwise>
                    </xsl:choose>
                  </TT></SMALL></TD>
                  <TD><IMG src="{$imx}spacer.gif" width="1" height="1"/></TD>
                  <TD width="1%">
                    <xsl:call-template name="usage_bar">
                      <xsl:with-param name="sample" select="$ram"/>
                      <xsl:with-param name="denominator" select="3"/>
                    </xsl:call-template>
                  </TD>
                  <xsl:variable name="active_ram"><xsl:value-of select="sum(/server/vm/stat[@name='ram-active' and @units='MB']/usage[@type='avg']/sample[@interval='1'])"/></xsl:variable>
                  <xsl:variable name="percent_ram">
                    <xsl:value-of select="round((sum(/server/vm/stat[@name='ram-active' and @units='MB']/usage[@type='avg']/sample[@interval='1']) div /server/system/numRAM) * 100)"/>
                  </xsl:variable>
                  <TD width="1%" align="right"><SMALL><TT>
                    <xsl:choose>
                      <xsl:when test="not(/server/stat[@name='ram'])">
                        &nbsp;<FONT color="#999980">0</FONT>
                      </xsl:when>
                      <xsl:otherwise>
                        <xsl:if test="$active_ram&lt;10">&nbsp;</xsl:if>
                        <xsl:value-of select="$active_ram"/>/<TT><xsl:value-of select="/server/system/numRAM"/></TT>
                      </xsl:otherwise>
                    </xsl:choose>
                  </TT></SMALL></TD>
                  <TD width="1%">
                    <xsl:call-template name="usage_bar">
                      <xsl:with-param name="sample" select="$percent_ram"/>
                      <xsl:with-param name="denominator" select="3"/>
                    </xsl:call-template>
                  </TD>
                  <xsl:if test="/server/system/nfshaper = '1'">
                    <TD colspan="2" width="1%"><SMALL>&nbsp;</SMALL></TD>
                  </xsl:if>
                </TR>
              </TABLE></TD></TR></TABLE>
              <TR><TD><IMG src="{$imx}spacer.gif" width="1" height="6"/></TD></TR>
            </TD></TR>
          </TABLE>

          <xsl:call-template name="pageFooter"/>

          <P>
            <xsl:call-template name="help-src">
              <xsl:with-param name="src">en/resources-overview.xml</xsl:with-param>
            </xsl:call-template>
          </P>

          <xsl:call-template name="labelFooter"/>
        </FORM>
      </BODY>
    </HTML>
  </xsl:template>

  <xsl:template name="VMs">
    <xsl:choose>
      <xsl:when test="/server/vm">
        <xsl:for-each select="/server/vm">
          <xsl:if test="@type='vmm' or @type='console'">
            <xsl:call-template name="vmRow">
              <xsl:with-param name="position"><xsl:value-of select="position()"/></xsl:with-param>
              <xsl:with-param name="states"><none/></xsl:with-param>
              <xsl:with-param name="stats">
                <cpu/>
                <cpu-active/>
                <ram/>
                <ram-active/>
                <xsl:if test="/server/system/nfshaper = '1'"><net/></xsl:if>
              </xsl:with-param>
              <xsl:with-param name="vm_script_name">/resources/editor</xsl:with-param>
            </xsl:call-template>
            <!-- Try to chunk the table every 9 rows of VMs so Navigator doesn't barf on long lists. -->
            <xsl:choose>
              <xsl:when test="not(position()=last()) and (position() mod 9=0)">
               <xsl:variable name="new_table"><![CDATA[</TABLE></TD></TR></TABLE></TD></TR></TABLE><TABLE width="100%" border="0" cellpadding="1" cellspacing="0"><TR><TD><IMG src="]]><xsl:value-of select="$imx"/><![CDATA[spacer.gif" width="1" height="1"></TD></TR><TR><TD bgcolor="#999980"><TABLE width="100%" border="0" cellpadding="0" cellspacing="0"><TR><TD bgcolor="#FFFFE6"><TABLE width="100%" border="0" cellpadding="3" cellspacing="1">]]></xsl:variable>
                <xsl:text disable-output-escaping="yes"><xsl:value-of select="$new_table"/></xsl:text>
              </xsl:when>
              <xsl:when test="not(position()=last()) and (position() mod 3=0)">
                <TR bgcolor="#E6E6CC">
                  <TD><IMG src="{$imx}spacer.gif" width="1" height="1"/></TD>
                  <TD><IMG src="{$imx}spacer.gif" width="1" height="1"/></TD>
                  <TD><IMG src="{$imx}spacer.gif" width="1" height="1"/></TD>
                  <TD><IMG src="{$imx}spacer.gif" width="1" height="1"/></TD>
                  <TD><IMG src="{$imx}spacer.gif" width="1" height="1"/></TD>
                  <TD><IMG src="{$imx}spacer.gif" width="1" height="1"/></TD>
                  <TD><IMG src="{$imx}spacer.gif" width="1" height="1"/></TD>
                  <TD><IMG src="{$imx}spacer.gif" width="1" height="1"/></TD>
                  <TD><IMG src="{$imx}spacer.gif" width="1" height="1"/></TD>
                  <TD><IMG src="{$imx}spacer.gif" width="1" height="1"/></TD>
                  <TD><IMG src="{$imx}spacer.gif" width="1" height="1"/></TD>
                  <TD><IMG src="{$imx}spacer.gif" width="1" height="1"/></TD>
                  <TD><IMG src="{$imx}spacer.gif" width="1" height="1"/></TD>
                  <xsl:if test="/server/system/nfshaper = '1'">
                    <TD><IMG src="{$imx}spacer.gif" width="1" height="1"/></TD>
                    <TD><IMG src="{$imx}spacer.gif" width="1" height="1"/></TD>
                  </xsl:if>
                </TR>
              </xsl:when>
            </xsl:choose>
          </xsl:if>
        </xsl:for-each>
      </xsl:when>
      <xsl:otherwise>
        <TR bgcolor="#FFFFE6">
          <TD colspan="{$vm_colspan}" align="center"><SMALL>There are no registered virtual machines.</SMALL></TD>
        </TR>
      </xsl:otherwise>
    </xsl:choose>
  </xsl:template>
</xsl:stylesheet>