<?xml version="1.0" encoding="iso-8859-1"?>
<!DOCTYPE html [
<!ENTITY nbsp "<xsl:text disable-output-escaping='yes'>&amp;nbsp;</xsl:text>">
]>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
  <xsl:include href="common.xsl"/>

  <xsl:template match="/">
   <xsl:choose>
     <xsl:when test="/exec/out/confirmImport='1'">
       <xsl:variable name="cwd" select="/exec/out/relativeRootDir"/>
       <HTML>
         <HEAD>
           <TITLE>VMware MUI File Manager</TITLE>
           <STYLE>
             td, p, blockquote {font-family: Verdana, sans-serif; font-size: 11px; }
           </STYLE>
	   <xsl:call-template name="fileUtils"/>
           <script>
             function ok() {
               var f = document.form;

               for (var i = 0; i != f.elements.length; i++) {
                 if (f[i].name == "confirmed") {
                   if (f[i].checked) {
                     f.confirmed_files.value += (f.confirmed_files.value ? "|" : "") +
                       f[i].value;
                   }
                 }
               }

               f.submit();
             }

             function cancel() {
               window.location.replace('/showdir?op=ls' +
                 unescape("%26") + 'dir=' + escapeFileName('<xsl:value-of select="$cwd"/>'));
             }
             function setup() {
               if (parent.lock_buttons) parent.lock_buttons(true);
             }
           </script>
         </HEAD>
         <body bgcolor="#FFFFFF" onload="setup();">
           <form method="post" name="form" action="/showdir">
             <input type="hidden" name="import_confirmed" value="1"/>
             <input type="hidden" name="destdir"><xsl:attribute name="value"><xsl:value-of select="$cwd"/></xsl:attribute></input>
             <input type="hidden" name="dest_fs"><xsl:attribute name="value"><xsl:value-of select="/exec/out/destinationFileSystem"/></xsl:attribute></input>
             <input type="hidden" name="src_fs"><xsl:attribute name="value"><xsl:value-of select="/exec/out/sourceFileSystem"/></xsl:attribute></input>
             <input type="hidden" name="files">
               <xsl:attribute name="value">
                 <xsl:for-each select="/exec/out/files/file"><xsl:value-of select="./path"/>;type=<xsl:value-of select="./type"/><xsl:if test="position()!=last()">|</xsl:if></xsl:for-each>
               </xsl:attribute>
             </input>
             <input type="hidden" name="dirs">
               <xsl:attribute name="value">
                 <xsl:for-each select="/exec/out/directories/directory"><xsl:value-of select="./path"/><xsl:if test="position()!=last()">|</xsl:if></xsl:for-each>
               </xsl:attribute>
             </input>
             <input type="hidden" name="confirmed_files" value=""></input>
             <input type="hidden" name="op"><xsl:attribute name="value"><xsl:value-of select="/exec/op"/></xsl:attribute></input>
             <br />
             <br />
             <table align="center" border="0" cellpadding="0" cellspacing="0">
               <tr>
                 <td><img src="{$common.imx}fm/field-tl.gif" width="7" height="7"/></td>
                 <td background="{$common.imx}fm/field-t.gif"><img src="{$common.imx}fm/field-t.gif" width="1" height="7"/></td>
                 <td><img src="{$common.imx}fm/field-tr.gif" width="7" height="7"/></td>
               </tr>
               <tr>
                 <td background="{$common.imx}fm/field-l.gif"><img src="{$common.imx}fm/field-l.gif" width="7" height="1"/></td>
                 <td bgcolor="#E6E6CC" align="right">
                   <table width="380" border="0" cellpadding="0" cellspacing="0">
                     <tr>
                       <td valign="top"><img src="{$common.imx}question.gif" width="32" height="32"/></td>
                       <td>&nbsp; &nbsp; &nbsp;</td>
                       <td>
                         <p><b>Transferring Virtual Disks to a VMFS Mount Point</b></p>

                         <p>
                           You are transferring one or more console virtual
                           disks to a VMFS partition. In order for virtual
                           machines to access these disks, they must be
                           converted to the VMFS format. Although you can
                           convert console disks at any time, it is
                           recommended that you do so now.
                         </p>

                         <p>
                           The following selected disks will be converted:
                         </p>

                         <blockquote>
                           <table border="0" cellpadding="4" cellspacing="0">
                             <xsl:for-each select="/exec/out/files/file">
                               <xsl:if test="./type='vmdk'"> <!-- We only get confirmImport if there are files to import so we only care about vmdk -->
                                 <xsl:variable name="pos" select="position()-1"/>
                                 <tr>
                                   <td><input type="checkbox" name="confirmed" checked="1">
                                     <xsl:attribute name="value"><xsl:value-of select="./path"/></xsl:attribute>
                                   </input></td>
                                   <td><xsl:value-of select="./name"/></td>
                                 </tr>
                               </xsl:if>
                             </xsl:for-each>
                           </table>
                         </blockquote>
                       </td>
                     </tr>
                   </table>
                 </td>
                 <td background="{$common.imx}fm/field-r.gif"><img src="{$common.imx}fm/field-r.gif" width="7" height="1"/></td>
               </tr>
               <tr>
                 <td background="{$common.imx}fm/field-l.gif"><img src="{$common.imx}fm/field-l.gif" width="7" height="1"/></td>
                 <td bgcolor="#E6E6CC"><img src="{$imx}spacer.gif" width="1" height="7"/></td>
                 <td background="{$common.imx}fm/field-r.gif"><img src="{$common.imx}fm/field-r.gif" width="7" height="1"/></td>
               </tr>
               <tr>
                 <td background="{$common.imx}fm/field-l.gif"><img src="{$common.imx}fm/field-l.gif" width="7" height="1"/></td>
                 <td align="right" bgcolor="#E6E6CC"><a href="javascript:ok();"><img src="{$common.imx}fm/ok.gif" width="27" height="14" border="0" hspace="4"/></a><a href="javascript:cancel();"><img src="{$common.imx}fm/cancel.gif" width="41" height="14" border="0"/></a></td>
                 <td background="{$common.imx}fm/field-r.gif"><img src="{$common.imx}fm/field-r.gif" width="7" height="1"/></td>
               </tr>
               <tr>
                 <td><img src="{$common.imx}fm/field-bl.gif" width="7" height="7"/></td>
                 <td background="{$common.imx}fm/field-b.gif"><img src="{$common.imx}fm/field-b.gif" width="1" height="7"/></td>
                 <td><img src="{$common.imx}fm/field-br.gif" width="7" height="7"/></td>
               </tr>
             </table>
           </form>
         </body>
       </HTML>
     </xsl:when>
     <xsl:when test="/exec/returncode='0'">
       <html>
         <head>
           <title>VMware MUI File Manager</title>
           <style>
             td, p, blockquote, li {font-family: Verdana, sans-serif; font-size: 11px; }
           </style>
           <xsl:variable name="cwd" select="/exec/out/relativeRootDir"/>
	   <xsl:call-template name="fileUtils"/>
           <script>
             function cancel() {
               var lwd = '';
               if (parent.hidden.document.hiddenform) {
                 lwd = parent.hidden.document.hiddenform.lastdir.value;
               }
               window.location.replace('/showdir?op=ls' +
                 unescape("%26") + 'dir=' + escapeFileName(lwd));
             }
             function setup() {
               if (parent.lock_buttons) parent.lock_buttons(true);
             }
           </script>
         </head>
         <body bgcolor="#FFFFFF" onload="setup();">
           <br />
           <br />
           <table align="center" border="0" cellpadding="0" cellspacing="0">
             <tr>
               <td><img src="{$common.imx}fm/field-tl.gif" width="7" height="7"/></td>
               <td background="{$common.imx}fm/field-t.gif"><img src="{$common.imx}fm/field-t.gif" width="1" height="7"/></td>
               <td><img src="{$common.imx}fm/field-tr.gif" width="7" height="7"/></td>
             </tr>
             <tr>
               <td background="{$common.imx}fm/field-l.gif"><img src="{$common.imx}fm/field-l.gif" width="7" height="1"/></td>
               <td bgcolor="#E6E6CC" align="right">
                 <table width="380" border="0" cellpadding="0" cellspacing="0">
                   <tr>
                     <td valign="top"><img src="{$common.imx}error.gif" width="32" height="32"/></td>
                     <td>&nbsp; &nbsp; &nbsp;</td>
                     <td>
                       <p><b>Error</b></p>

                       <p>
                         One or more errors were encountered while completing the requested operation.
                       </p>

                       <xsl:for-each select="/exec/messages/msg[@severity='error']">
                         <ul>
                           <li><xsl:value-of select="."/></li>
                         </ul>
                       </xsl:for-each>
                     </td>
                   </tr>
                 </table>
               </td>
               <td background="{$common.imx}fm/field-r.gif"><img src="{$common.imx}fm/field-r.gif" width="7" height="1"/></td>
             </tr>
             <tr>
               <td background="{$common.imx}fm/field-l.gif"><img src="{$common.imx}fm/field-l.gif" width="7" height="1"/></td>
               <td bgcolor="#E6E6CC"><img src="{$imx}spacer.gif" width="1" height="7"/></td>
               <td background="{$common.imx}fm/field-r.gif"><img src="{$common.imx}fm/field-r.gif" width="7" height="1"/></td>
             </tr>
             <tr>
               <td background="{$common.imx}fm/field-l.gif"><img src="{$common.imx}fm/field-l.gif" width="7" height="1"/></td>
               <td align="right" bgcolor="#E6E6CC"><a href="javascript: cancel();"><img src="{$common.imx}fm/ok.gif" width="27" height="14" border="0"/></a></td>
               <td background="{$common.imx}fm/field-r.gif"><img src="{$common.imx}fm/field-r.gif" width="7" height="1"/></td>
             </tr>
             <tr>
               <td><img src="{$common.imx}fm/field-bl.gif" width="7" height="7"/></td>
               <td background="{$common.imx}fm/field-b.gif"><img src="{$common.imx}fm/field-b.gif" width="1" height="7"/></td>
               <td><img src="{$common.imx}fm/field-br.gif" width="7" height="7"/></td>
             </tr>
           </table>
         </body>
       </html>
     </xsl:when>
     <xsl:otherwise>
      <HTML>
      <HEAD>
      <TITLE>VMware MUI File Manager</TITLE>
      <STYLE>
      td {font-family: Verdana, sans-serif; font-size: 11px; }
      </STYLE>
      <xsl:call-template name="fileUtils"/>
      <SCRIPT src="/vmware/src/util.js"></SCRIPT>
      <SCRIPT>
        function doOnLoad()
        {
          if (parent.lock_buttons) parent.lock_buttons(false);
          if (!parent.hidden.document.hiddenform) {
            parent.hidden.location.replace('/showdir?op=hide');
          } else {

            updateCwd();

            parent.initHiddenData();

            if (parent.recheckItems) {
              // update ls icons and checkboxes
              parent.recheckItems();
            }
            if (parent.bCheckAll != null) {
              // reset checkall toggle
              parent.bCheckAll = false;
            }
          }

          parent.setup_file_checkboxes(document.ls);
        }

        function updateCwd()
        {
        <xsl:choose>
          <xsl:when test="//dirInfo/vmfsMountPoint">
            parent.pwd.setVmfsDirIcon(true);
            parent.bCurDirVmfsMountPoint = true;
            parent.hidden.document.hiddenform.dest_fs.value = 'vmfs';
          </xsl:when>
          <xsl:otherwise>
            parent.pwd.setVmfsDirIcon(false);
            parent.bCurDirVmfsMountPoint = false;
            parent.hidden.document.hiddenform.dest_fs.value = 'cons';
          </xsl:otherwise>
        </xsl:choose>

          if (parent.pwd.document.pwdform) {
            parent.pwd.document.pwdform.dir.value = '<xsl:value-of select="//relativeRootDir"/>';
          }
          if (parent.hidden.document.hiddenform) {
            parent.hidden.document.hiddenform.lastdir.value = '<xsl:value-of select="//relativeRootDir"/>';
            parent.hidden.document.hiddenform.destdir.value = '<xsl:value-of select="//relativeRootDir"/>';
            parent.hidden.onload = null;
<!--            parent.hidden.document.hiddenform.dest_fs.value = '<xsl:choose><xsl:when test="//dirInfo/vmfsMountPoint">vmfs</xsl:when><xsl:otherwise>cons</xsl:otherwise></xsl:choose>';-->
          }
          var l = parent.parent.tree.location;
          var u = l.protocol + "//" + l.host + "/showdirtree?cwd=" + escapeFileName('<xsl:value-of select="//relativeRootDir"/>') +
	                "#" + escapeFileName('<xsl:value-of select="//relativeRootDir"/>');
          if (l.href != u)
            l.replace(u);
          else
            l.reload();
        }

        function newDir()
        {
          parent.submitNewDirFromLS();
        }

        function changeDir(dir)
        {
	  var fullDir = escapeFileName("<xsl:value-of select="//relativeRootDir"/>"+'/'+dir);
          parent.hidden.document.hiddenform.lastdir.value = parent.hidden.document.hiddenform.destdir.value;
          parent.hidden.document.hiddenform.destdir.value = fullDir;
          var url = "/showdir?op=ls" + unescape("%26") + "dir="+fullDir;
          location.href=url;
          parent.parent.tree.location.replace("/showdirtree?cwd=" + fullDir + "#" + fullDir);
        }

        function regWndw(vmcfg) {
          var u = "/vmware/en/vmCfgContainer.html?unit=sxRegisterVirtualMachine" +
            unescape("%26") + "vmcfg=" + esc(vmcfg);
          var n = escJs(parent.opener.main.user + "@" +
            parent.opener.main.sx._name + ":sxRegisterVirtualMachine" +
            vmcfg);
          var w = parent.opener.main.getRgWndw(n);

          if (w != null) {
            if (! w.closed) {
              w.focus();
            }
          }

          if (w == null || w.closed) {
            w = window.open(u, n, "width=560,height=320,resizable");
            parent.opener.main.addRgWndw(w);
          }
        }

      </SCRIPT>
      </HEAD>
      <BODY bgcolor="#FFFFFF" onLoad="doOnLoad();">
        <form name="ls" action=""
          onSubmit="newDir();"
        >
        <xsl:call-template name="directories"/>
        <table border="0" cellpadding="4" cellspacing="0">
          <tr>
            <td><font color="#999999">directories shown <xsl:value-of select="count(.//directories/directory)"/>
                 (of <xsl:value-of select="/exec/out/numTotalDir"/>)</font></td>
          </tr>
        </table>
        <table width="100%" align="center" border="0" cellpadding="0" cellspacing="4">
          <tr><td bgcolor="#CCCCCC"><img src="{$imx}spacer.gif" width="1" height="1"/></td></tr>
        </table>

        <xsl:call-template name="files"/>
        <table border="0" cellpadding="4" cellspacing="0">
          <tr>
            <td><font color="#999999">files shown <xsl:value-of select="count(.//files/file)"/>
		                     (of <xsl:value-of select="/exec/out/numTotalFiles"/>)</font></td>
          </tr>
        </table>
        <table width="100%" align="center" border="0" cellpadding="0" cellspacing="4">
          <tr><td bgcolor="#CCCCCC"><img src="{$imx}spacer.gif" width="1" height="1"/></td></tr>
        </table>
        <table border="0" cellpadding="4" cellspacing="0">
          <tr>
            <td><font color="#999999">available space <xsl:call-template name="diskAvailSpace"/></font></td>
          </tr>
        </table>
        <table width="100%" align="center" border="0" cellpadding="0" cellspacing="4">
          <tr><td bgcolor="#CCCCCC"><img src="{$imx}spacer.gif" width="1" height="1"/></td></tr>
        </table>
        <!-- debug only  <INPUT TYPE="BUTTON" VALUE="html" onClick="showHTML();"/> -->
        </form>
      </BODY>
      </HTML>
     </xsl:otherwise>
    </xsl:choose>
  </xsl:template>

  <xsl:template name="directories">
    <xsl:for-each select="exec/out/directories">
      <table width="100%" align="center" border="0" cellpadding="2" cellspacing="0">
        <tr>
          <xsl:for-each select="./directory">
            <xsl:variable name="pos" select="position() - 1"/>
            <xsl:variable name="dir"><xsl:value-of select="./name"/></xsl:variable>
            <xsl:variable name="cwd">
              <xsl:choose>
                <xsl:when test="not(//relativeRootDir='/')"><xsl:value-of select="//relativeRootDir"/></xsl:when>
                <xsl:otherwise></xsl:otherwise>
              </xsl:choose>
            </xsl:variable>
            <xsl:variable name="dtype">
              <xsl:choose>
                <xsl:when test="./vmfsMountPoint">vmfs</xsl:when>
                <xsl:otherwise>dir</xsl:otherwise>
              </xsl:choose>
            </xsl:variable>

            <td width="50%">
              <table border="0" cellpadding="3" cellspacing="0">
                <tr>
                  <input type="hidden" name="d_type" value="{$dtype}"/>
                  <td><input type="checkbox" name="dir" value="{$cwd}/{$dir}"/></td>
                  <td><A href="javascript: changeDir('{$dir}')"><img src="{$common.imx}fm/{$dtype}.gif" name='d_{$pos}' width="32" height="32" border="0"/></A></td>
                  <td>
                    <b><A href="javascript: changeDir('{$dir}')">
                      <font color="#000000"><xsl:value-of select="./name"/>/</font></A></b><br/>
                      <font face="monospace">
                        <xsl:apply-templates select="./permissions"/>
                      </font> : directory : <xsl:value-of select="./mtime"/>
                  </td>
                </tr>
              </table>
            </td>
            <xsl:if test="not(position()=last()) and (position() mod 2=0)">
              <xsl:variable name="open_table"><![CDATA[</tr></table><table width="100%" align="center" border="0" cellpadding="1" cellspacing="0"><tr>]]></xsl:variable>
              <xsl:text disable-output-escaping="yes"><xsl:value-of select="$open_table"/></xsl:text>
            </xsl:if>
          </xsl:for-each>
        </tr>
      </table>
    </xsl:for-each>
  </xsl:template>

  <xsl:template name="files">
      <xsl:for-each select="exec/out/files">
        <table width="100%" align="center" border="0" cellpadding="2" cellspacing="0">
          <tr>
            <xsl:for-each select="./file">
              <xsl:variable name="pos" select="position() - 1"/>
              <xsl:variable name="file"><xsl:value-of select="./name"/></xsl:variable>
              <xsl:variable name="cwd"><xsl:value-of select="//relativeRootDir"/></xsl:variable>

              <xsl:variable name="ftype">
                <xsl:choose>
                  <xsl:when test="./config">cfg</xsl:when>
                  <xsl:when test="./disk">
                    <xsl:choose>
                      <xsl:when test="./disk@type='vmfs'">vmdk-vmfs</xsl:when>
                      <xsl:otherwise>vmdk</xsl:otherwise>
                    </xsl:choose>
                  </xsl:when>
                  <xsl:otherwise>file</xsl:otherwise>
                </xsl:choose>
              </xsl:variable>

              <td width="50%">
                <table border="0" cellpadding="4" cellspacing="0">
                  <tr>
                    <input type="hidden" name="f_type" value="{$ftype}"/>
                    <td><input type="checkbox" name="file" value="{$cwd}/{$file}"/></td>
                    <td>
                      <xsl:choose>
                        <xsl:when test="$ftype='cfg'">
                          <a href="javascript:;" onclick="regWndw('{$cwd}/{$file}');"><img src="{$common.imx}fm/{$ftype}.gif" name='f_{$pos}' width="32" height="32" border="0"/></a>
                        </xsl:when>
                        <xsl:otherwise>
                          <img src="{$common.imx}fm/{$ftype}.gif" name='f_{$pos}' width="32" height="32" border="0"/>
                        </xsl:otherwise>
                      </xsl:choose>
                    </td>
                    <td>
                      <b><xsl:choose>
                        <xsl:when test="$ftype='cfg'">
                          <a href="javascript:;" onclick="regWndw('{$cwd}/{$file}');"><font color="#000000"><xsl:value-of select="./name"/></font></a>
                        </xsl:when>
                        <xsl:otherwise>
                          <xsl:value-of select="./name"/>
                        </xsl:otherwise>
                        </xsl:choose></b><br/>
                      <font face="monospace">
                        <xsl:apply-templates select="./permissions"/>
                      </font> : <xsl:value-of select="./size"/> <xsl:value-of select="./size/@units"/>  : <xsl:value-of select="./mtime"/>
                    </td>
                  </tr>

                  <xsl:choose>
                    <xsl:when test="//dirInfo/vmfsMountPoint">
                      <xsl:if test="./disk[@type='virtual'] ">
                        <tr>
                          <td colspan="2"><img src="{$imx}spacer.gif" width="1" height="1"/></td>
                          <td><a href="javascript: parent.convert({$pos})"><img src="{$common.imx}fm/convert.gif" width="49" height="14" border="0" align="left"/></a></td>
                        </tr>
                      </xsl:if>
                    </xsl:when>
                    <xsl:otherwise>
                      <xsl:if test="./disk[@type='vmfs'] ">
                        <tr>
                          <td colspan="2"><img src="{$imx}spacer.gif" width="1" height="1"/></td>
                          <td><a href="javascript: alert('convert ' + '{$file}')"><img src="{$common.imx}fm/convert.gif" width="49" height="14" border="0" align="left"/></a></td>
                        </tr>
                      </xsl:if>
                    </xsl:otherwise>
                  </xsl:choose>

                </table>
              </td>
              <xsl:if test="not(position()=last()) and (position() mod 2=0)">
                <xsl:variable name="open_table"><![CDATA[</tr></table><table width="100%" align="center" border="0" cellpadding="1" cellspacing="0"><tr>]]></xsl:variable>
                <xsl:text disable-output-escaping="yes"><xsl:value-of select="$open_table"/></xsl:text>
              </xsl:if>
            </xsl:for-each>
          </tr>
        </table>
      </xsl:for-each>
  </xsl:template>

  <xsl:template name="diskAvailSpace">
    <script>
      var v  = <xsl:value-of select="/exec/out/diskAvailSpace"/>;
      var kb = 1024;
      var mb = kb * kb;
      var gb = mb * kb;
      var tb = gb * kb;

      if (v >= tb) {
        document.write(new Number(v / tb).toFixed(2) + "TB");
      } else if (v >= gb) {
        document.write(new Number(v / gb).toFixed(2) + "GB");
      } else if (v >= mb) {
        document.write(new Number(v / mb).toFixed(2) + "MB");
      } else if (v >= kb) {
        document.write(new Number(v / kb).toFixed(2) + "KB");
      } else {
        document.write(v);
      }
    </script>
  </xsl:template>

  <xsl:template match="permissions">
   <xsl:choose>
      <xsl:when test="./r">r
      </xsl:when>
      <xsl:otherwise>-
      </xsl:otherwise>
   </xsl:choose>
   <xsl:choose>
      <xsl:when test="./w">w
      </xsl:when>
      <xsl:otherwise>-
      </xsl:otherwise>
   </xsl:choose>
   <xsl:choose>
      <xsl:when test="./x">x
      </xsl:when>
      <xsl:otherwise>-
      </xsl:otherwise>
   </xsl:choose>
  </xsl:template>

</xsl:stylesheet>
