<?xml version="1.0" encoding="iso-8859-1"?>
<!-- Todo:
  
     [!DOCTYPE] Put common enitity declarations into a DTD. But DTDs don't seem
     to be working correctly. Hmmm.

  -->
<!DOCTYPE html [
<!ENTITY nbsp "<xsl:text disable-output-escaping='yes'>&amp;nbsp;</xsl:text>">
<!ENTITY ampersand "<xsl:text disable-output-escaping='yes'>&amp;</xsl:text>">
]>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
  <!-- [ ! ] -->

  <xsl:include href="common.xsl"/>

  <xsl:variable name="fmimx">/vmware/themes/default/imx/</xsl:variable>
  <xsl:variable name="selected">
    <xsl:value-of select="/exec/out/selected" />
  </xsl:variable>

  <xsl:template match="/">
   <xsl:choose>
    <xsl:when test="/exec/returncode='0'">
      <HTML>
      <HEAD><TITLE>VMware MUI File Manager</TITLE></HEAD>
      <body bgcolor="#FFFFFF"></body>
      </HTML>
    </xsl:when>
    <xsl:otherwise>
    <HTML>
      <HEAD>
        <STYLE type="text/css">
          A:link {text-decoration: none}
          A:visited {text-decoration: none}
          A:hover {text-decoration: underline}
        </STYLE>

        <TITLE><xsl:value-of select="/server/host"/>.<xsl:value-of select="/server/host@domain"/> - VMware Management Interface</TITLE>
        <LINK rel="stylesheet" href="{$common}style.css" type="text/css" />
	<xsl:call-template name="fileUtils"/>
        <SCRIPT>
          function changeDir(dir)
          {
	    var safeDir = escapeFileName(dir);
            parent.hidden.document.hiddenform.lastdir.value = parent.hidden.document.hiddenform.destdir.value;
            parent.hidden.document.hiddenform.destdir.value = dir;
            document.location.replace("/showdirtree?cwd=" + safeDir + "#" + safeDir);
            parent.showdir.location.href = "/showdir?op=ls" + unescape("%26") + "dir="+safeDir;
          }
        </SCRIPT>
      </HEAD>

      <BODY bgcolor="#FFFFFF" link="#000000" vlink="#000000" topmargin="6" leftmargin="6" marginwidth="6" marginheight="6">

       <xsl:if test="/exec/messages">
         <xsl:value-of select="/exec/messages" />
       </xsl:if>

       <xsl:for-each select="/exec/out/directory">
          <xsl:call-template name="directory">
             <xsl:with-param name="depth">0</xsl:with-param>
          </xsl:call-template>
       </xsl:for-each>

      </BODY>
    </HTML>
    </xsl:otherwise>
   </xsl:choose>
  </xsl:template>

  <xsl:template name="directory">
    <xsl:param name="depth">
      <none/>
    </xsl:param>

    <xsl:variable name="url"><xsl:value-of select="@abspath" /></xsl:variable>
    <xsl:variable name="bgcolor">
      <xsl:choose>
        <xsl:when test="@abspath = $selected">#3a6ea5</xsl:when>
        <xsl:otherwise>#FFFFFF</xsl:otherwise>
      </xsl:choose>
    </xsl:variable>
    <xsl:variable name="fgcolor">
      <xsl:choose>
        <xsl:when test="@abspath = $selected">#FFFFFF</xsl:when>
        <xsl:otherwise>#000000</xsl:otherwise>
      </xsl:choose>
    </xsl:variable>

    <A name="{$url}" />
    <TABLE height="16" cellspacing="0" cellpadding="0" border="0">
      <tr><td valign="top"><nobr>

        <xsl:call-template name="lines">
          <xsl:with-param name="num">
            <xsl:value-of select="$depth - 1" />
          </xsl:with-param>
        </xsl:call-template>

        <xsl:variable name="folderimg">
          <xsl:choose>
            <xsl:when test="directory">folder-o.gif</xsl:when>
            <xsl:otherwise>
              <xsl:choose>
                <xsl:when test="@abspath = $selected">folder-o.gif</xsl:when>
                <xsl:otherwise>folder-c.gif</xsl:otherwise>
              </xsl:choose>
            </xsl:otherwise>
          </xsl:choose>
        </xsl:variable>
        <xsl:if test="$depth > 0">
          <xsl:variable name="lineimg">
            <xsl:choose>
              <xsl:when test="position() != last()">t-line.gif</xsl:when>
              <xsl:otherwise>l-line.gif</xsl:otherwise>
            </xsl:choose>
          </xsl:variable>
          <IMG src="{$fmimx}fm/{$lineimg}" width="16" height="16" border="0"/>
        </xsl:if>
        <A HREF="javascript: changeDir('{$url}')">
          <IMG src="{$fmimx}fm/{$folderimg}" width="16" height="16" border="0"/>
        </A>
        <IMG src="{$imx}spacer.gif" width="5" height="16" border="0"/>
      </nobr></td><td bgcolor="{$bgcolor}" valign="middle">
      <FONT size="-2"><NOBR>&nbsp;<A HREF="javascript: changeDir('{$url}')" style="color:{$fgcolor}">
        <xsl:value-of select="@name"/></A>&nbsp;</NOBR></FONT>
      </td></tr> 
    </TABLE>

    <xsl:for-each select="directory">
      <xsl:call-template name="directory">
        <xsl:with-param name="depth">
          <xsl:value-of select="$depth + 1" />
        </xsl:with-param>
      </xsl:call-template>
    </xsl:for-each>

  </xsl:template>

  <xsl:template name="lines">
    <xsl:param name="num">
      <none/>
    </xsl:param>  
    <xsl:if test="$num > 0">
      <IMG src="{$imx}spacer.gif" width="16" height="16" border="0"/>

      <xsl:call-template name="lines">
        <xsl:with-param name="num">
          <xsl:value-of select="$num - 1" />
        </xsl:with-param>
      </xsl:call-template>
    </xsl:if>
  </xsl:template>

</xsl:stylesheet>