<?xml version="1.0" encoding="iso-8859-1"?>
<!-- Todo:

     [!DOCTYPE] Put common enitity declarations into a DTD. But DTDs don't seem
     to be working correctly. Hmmm.

  -->
<!DOCTYPE html [
<!ENTITY nbsp "<xsl:text disable-output-escaping='yes'>&amp;nbsp;</xsl:text>">
<!ENTITY ampersand "<xsl:text disable-output-escaping='yes'>&amp;</xsl:text>">
]>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
  <!-- [ ! ] --><xsl:include href="common.xsl"/>
  <xsl:include href="../../js-import.xsl"/>
  <xsl:include href="pageHelp.xsl"/>
  <xsl:include href="controlmenu.xsl"/>

  <xsl:variable name="vm_colspan">11</xsl:variable>

  <xsl:template match="/">
    <HTML>
      <HEAD>
        <TITLE><xsl:value-of select="/server/host"/>.<xsl:value-of select="/server/host@domain"/> - Memory Utilization</TITLE>
        <xsl:choose>
          <xsl:when test="/server/mui@layout='new'">
            <script>
              setTimeout("this.location='/stats/memory?mui=new'", 180000);
              function initPage () {
               setup();
               ctrlMenuSetup();
              }
            </script>
            <script src="/vmware/src/init.js"></script>
            <script src="/vmware/src/xuaLib.js"></script>
          </xsl:when>
          <xsl:otherwise>
           <META http-equiv="Refresh" content="180; url=/stats/memory?auto-refresh=1"/>
          </xsl:otherwise>
        </xsl:choose>
        <SCRIPT>
          var product = "ESX";
          var noRefresh = true;
          var hostOS = "<xsl:value-of select="/server/host@os"/>";
          <xsl:call-template name="js-src">
            <xsl:with-param name="src">../../util-js.xml</xsl:with-param>
            <xsl:with-param name="use">
              <obj use-recommended="1">Is</obj>
            </xsl:with-param>
          </xsl:call-template>
          <xsl:call-template name="js-src">
            <xsl:with-param name="src">controlmenu-js.xml</xsl:with-param>
          </xsl:call-template>
        </SCRIPT>
        <SCRIPT src="{$common}server.js"></SCRIPT>
        <LINK rel="stylesheet" href="{$common}style.css" type="text/css" />
      </HEAD>

      <xsl:param name="jsInit">setup();ctrlMenuSetup();</xsl:param>
      <BODY bgcolor="#FFFFFF" link="#000000" vlink="#000000" topmargin="6" leftmargin="6" marginwidth="6" marginheight="6">
      <xsl:choose>
        <xsl:when test="not(/server/mui@layout='new')">
          <xsl:attribute name="onLoad"><xsl:value-of select="$jsInit"/></xsl:attribute>
        </xsl:when>
        <xsl:otherwise><none/></xsl:otherwise>
      </xsl:choose>

        <xsl:call-template name="poweroffMenu"/>
        <xsl:call-template name="poweronMenu"/>
        <xsl:call-template name="suspendMenu"/>
        <xsl:call-template name="softableMenu"/>
        <xsl:call-template name="readonlyMenu"/>
        <xsl:call-template name="unreachableMenu"/>

        <xsl:call-template name="operationForm"/>

        <FORM name="form" method="POST" action="javascript:noop();" onSubmit="javascript:handleSubmit();">

          <xsl:call-template name="pageHeader">
            <xsl:with-param name="uiPath">
              <location href="/overview">VMs on <xsl:value-of select="/server/host"/><xsl:if test="/server/host@domain">.<xsl:value-of select="/server/host@domain"/></xsl:if></location>
              <current>Memory Utilization</current>
            </xsl:with-param>

            <xsl:with-param name="xtra_ctrl">
              <xsl:choose>
                <xsl:when test="/server/product@id='ESX'">
                  <xsl:if test="/server/username='root' and not(/server/mui@layout='new')">
                    <ctrl>
                      <label>Resources Overview</label>
                      <action>/resources?mui=new</action>
                    </ctrl>
                  </xsl:if>
                </xsl:when>
                <xsl:otherwise><none/></xsl:otherwise>
              </xsl:choose>
            </xsl:with-param>

            </xsl:call-template>

          <xsl:if test="/server/error">
            <P>
              <TABLE><TR>
                <TD><IMG src="{$imx}spacer.gif" width="128" height="1"/></TD>
                <TD>
                  <xsl:call-template name="error"/>
                </TD>
                <TD><IMG src="{$imx}spacer.gif" width="128" height="1"/></TD>
              </TR></TABLE>
            </P>
          </xsl:if>

          <!--
          =====================
          System summary charts
          =====================
          -->

          <TABLE width="100%" border="0" cellpadding="1" cellspacing="0">
            <TR><TD><IMG src="{$imx}spacer.gif" width="1" height="6"/></TD></TR>
            <TR><TD bgcolor="#999980">

              <!-- Accumulate statistics for system summary -->

              <!-- Shared Memory -->
              <xsl:variable name="shared-total" select="/server/memory/shared/total div 1024"/>
              <xsl:variable name="shared-actual" select="/server/memory/shared/actual div 1024"/>
              <xsl:variable name="shared-saved" select="$shared-total - $shared-actual"/>

              <!-- Physical Memory -->
              <xsl:variable name="console" select="/server/memory/vmnix div 1024"/>
              <xsl:variable name="overhead" select="sum(/server/vm/memory/overhead)"/>
              <!-- Don't double-count shared pages -->
              <xsl:variable name="actual" select="sum(/server/vm/memory/actual) - $shared-saved"/>
              <xsl:variable name="total" select="/server/memory/total div 1024"/>
              <xsl:variable name="free" select="$total - $console - $overhead - $actual"/>

              <!-- Reclaimed Memory -->
              <xsl:variable name="memctl" select="sum(/server/vm/memory/memctl/actual)"/>
              <xsl:variable name="swap-tot" select="/server/memory/swap/total div 1024"/>
              <xsl:variable name="swap-used" select="/server/memory/swap/used div 1024"/>
              <xsl:variable name="swap-rsvd" select="/server/memory/swap/reserved div 1024"/>
              <xsl:variable name="swap-free" select="$swap-tot - $swap-used - $swap-rsvd"/>

              <!-- Make summary charts 512 pixels wide, scale to fit largest value -->
              <xsl:variable name="scale">
                <xsl:choose>
                  <xsl:when test="$total > ($memctl + $swap-tot)">
                    <xsl:value-of select="$total div 512"/>
                  </xsl:when>
                  <xsl:otherwise>
                    <xsl:value-of select="($memctl + $swap-tot) div 512"/>
                  </xsl:otherwise>
                </xsl:choose>
              </xsl:variable>

              <!-- Server Summary: Physical Memory -->

              <table width="100%" border="0" cellpadding="0" cellspacing="0"><tr><td bgcolor="#FFFFE6"><table width="100%" border="0" cellpadding="3" cellspacing="1">
                <tr><td colspan='3' align='center' class='hdr'>
                  <nobr><b>Server Summary: Memory Utilization</b></nobr>
                </td></tr>

                <xsl:call-template name="summary-entry">
                  <xsl:with-param name="label">Console OS</xsl:with-param>
                  <xsl:with-param name="scale" select="$scale"/>
                  <xsl:with-param name="base">0</xsl:with-param>
                  <xsl:with-param name="value" select="$console"/>
                  <xsl:with-param name="color">#000066</xsl:with-param>
                </xsl:call-template>

                <xsl:call-template name="summary-entry">
                  <xsl:with-param name="label">VM Overhead</xsl:with-param>
                  <xsl:with-param name="scale" select="$scale"/>
                  <xsl:with-param name="base" select="$console"/>
                  <xsl:with-param name="value" select="$overhead"/>
                  <xsl:with-param name="color">#333399</xsl:with-param>
                </xsl:call-template>

                <xsl:call-template name="summary-entry">
                  <xsl:with-param name="label">Virtual Machines</xsl:with-param>
                  <xsl:with-param name="scale" select="$scale"/>
                  <xsl:with-param name="base" select="$console + $overhead"/>
                  <xsl:with-param name="value" select="$actual"/>
                  <xsl:with-param name="color">#6666cc</xsl:with-param>
                </xsl:call-template>

                <xsl:call-template name="summary-entry">
                  <xsl:with-param name="label">Free Memory</xsl:with-param>
                  <xsl:with-param name="scale" select="$scale"/>
                  <xsl:with-param name="base" select="$console + $overhead + $actual"/>
                  <xsl:with-param name="value" select="$free"/>
                  <xsl:with-param name="color">#339966</xsl:with-param>
                </xsl:call-template>

                <tr class="bdy">
                  <td width="150" align="left"><nobr><b>Total Memory</b></nobr></td>
                  <td width="50" align="right"><b><xsl:value-of select="round($total)"/>MB</b></td>
                  <td width="512">&nbsp;</td>
                </tr>

              </table></td></tr></table>

              <!-- Server Summary: Reclaimed Memory -->

              <table width="100%" border="0" cellpadding="0" cellspacing="0"><tr><td bgcolor="#FFFFE6"><table width="100%" border="0" cellpadding="3" cellspacing="1">
                <tr><td colspan='3' align='center' class='hdr'>
                  <nobr><b>Server Summary: Reclaimed Memory</b></nobr>
                </td></tr>

                <xsl:call-template name="summary-entry">
                  <xsl:with-param name="label">VMMemCtl</xsl:with-param>
                  <xsl:with-param name="scale" select="$scale"/>
                  <xsl:with-param name="base">0</xsl:with-param>
                  <xsl:with-param name="value" select="$memctl"/>
                  <xsl:with-param name="color">#ff3333</xsl:with-param>
                </xsl:call-template>

                <xsl:call-template name="summary-entry">
                  <xsl:with-param name="label">Used Swap</xsl:with-param>
                  <xsl:with-param name="scale" select="$scale"/>
                  <xsl:with-param name="base" select="$memctl"/>
                  <xsl:with-param name="value" select="$swap-used"/>
                  <xsl:with-param name="color">#ff3333</xsl:with-param>
                </xsl:call-template>

                <xsl:call-template name="summary-entry">
                  <xsl:with-param name="label">Reserved Swap</xsl:with-param>
                  <xsl:with-param name="scale" select="$scale"/>
                  <xsl:with-param name="base" select="$memctl + $swap-used"/>
                  <xsl:with-param name="value" select="$swap-rsvd"/>
                  <xsl:with-param name="color">#ff9999</xsl:with-param>
                </xsl:call-template>

                <xsl:call-template name="summary-entry">
                  <xsl:with-param name="label">Free Swap</xsl:with-param>
                  <xsl:with-param name="scale" select="$scale"/>
                  <xsl:with-param name="base" select="$memctl + $swap-used + $swap-rsvd"/>
                  <xsl:with-param name="value" select="$swap-free"/>
                  <xsl:with-param name="color">#339966</xsl:with-param>
                </xsl:call-template>
              </table></td></tr></table>

              <!-- Server Summary: Memory Sharing -->

              <table width="100%" border="0" cellpadding="0" cellspacing="0"><tr><td bgcolor="#FFFFE6"><table width="100%" border="0" cellpadding="3" cellspacing="1">
                <tr><td colspan='3' align='center' class='hdr'>
                  <nobr><b>Server Summary: Memory Sharing</b></nobr>
                </td></tr>

                <xsl:call-template name="summary-entry">
                  <xsl:with-param name="label">Shared VM Memory</xsl:with-param>
                  <xsl:with-param name="scale" select="$scale"/>
                  <xsl:with-param name="base">0</xsl:with-param>
                  <xsl:with-param name="value" select="$shared-total"/>
                  <xsl:with-param name="color">#660033</xsl:with-param>
                </xsl:call-template>

                <xsl:call-template name="summary-entry">
                  <xsl:with-param name="label">Actual Memory Used</xsl:with-param>
                  <xsl:with-param name="scale" select="$scale"/>
                  <xsl:with-param name="base">0</xsl:with-param>
                  <xsl:with-param name="value" select="$shared-actual"/>
                  <xsl:with-param name="color">#660033</xsl:with-param>
                </xsl:call-template>

                <xsl:call-template name="summary-entry">
                  <xsl:with-param name="label">Memory Savings</xsl:with-param>
                  <xsl:with-param name="scale" select="$scale"/>
                  <xsl:with-param name="base">0</xsl:with-param>
                  <xsl:with-param name="value" select="$shared-saved"/>
                  <xsl:with-param name="color">#660033</xsl:with-param>
                </xsl:call-template>
              </table></td></tr></table>

              <TR><TD><IMG src="{$imx}spacer.gif" width="1" height="6"/></TD></TR>
            </TD></TR>
          </TABLE>

          <!--
          =================
          VM summary charts
          =================
          -->

          <TABLE width="100%" border="0" cellpadding="1" cellspacing="0">
            <TR><TD bgcolor="#999980">

              <table width="100%" border="0" cellpadding="0" cellspacing="0"><tr><td bgcolor="#FFFFE6"><table width="100%" border="0" cellpadding="3" cellspacing="1">

                <tr><td colspan='{$vm_colspan}' align='center' class='hdr'>
                  <nobr><b>Virtual Machine Summary: Memory Allocation</b></nobr>
                </td></tr>

                <!-- VM summary charts -->

                <xsl:call-template name="vmHeader">
                  <xsl:with-param name="stats"><mem-chart/></xsl:with-param>
                </xsl:call-template>

                <xsl:variable name="count" select="count(/server/vm[@type='vmm'])"/>
                <xsl:choose>
                  <xsl:when test="$count > 0">
                    <xsl:call-template name="VMs"/>
                  </xsl:when>
                  <xsl:otherwise>
                    <TR bgcolor="#FFFFE6">
                      <TD colspan="{$vm_colspan}" align="center"><SMALL>There are no registered virtual machines.</SMALL></TD>
                    </TR>
                  </xsl:otherwise>
                </xsl:choose>

                <xsl:call-template name="legend"/>

              </table></td></tr></table>
              <TR><TD><IMG src="{$imx}spacer.gif" width="1" height="6"/></TD></TR>
            </TD></TR>
          </TABLE>

          <xsl:call-template name="pageFooter"/>

          <xsl:if test="not(/server/mui@layout='new')">
            <P>
              <xsl:call-template name="help-src">
               <xsl:with-param name="src">en/memstats.xml</xsl:with-param>
              </xsl:call-template>
            </P>
            <xsl:call-template name="labelFooter"/>
          </xsl:if>

        </FORM>
      </BODY>
    </HTML>
  </xsl:template>

  <xsl:template name="summary-entry">
    <xsl:param name="label"/>
    <xsl:param name="scale">1</xsl:param>
    <xsl:param name="base">0</xsl:param>
    <xsl:param name="value">0</xsl:param>
    <xsl:param name="color">#000000</xsl:param>

    <xsl:variable name="indent" select="round($base div $scale)"/>
    <xsl:variable name="width" select="round($value div $scale)"/>
    <tr class="bdy">
      <td width="150" align="left">
        <nobr><xsl:value-of select="$label"/></nobr>
      </td>
      <td width="50" align="right">
        <nobr><xsl:value-of select="round($value)"/>MB</nobr>
      </td>
      <td width="512" align="left">
        <xsl:choose>
          <xsl:when test="$width &gt; 0">
            <nobr><table cellpadding="0" cellspacing="0"><tr>
              <td>
                <img src="{$imx}spacer.gif" width="{$indent}" height="12"/>
              </td>
              <td bgcolor="{$color}">
                <img src="{$imx}spacer.gif" width="{$width}" height="12"/>
              </td>
            </tr></table></nobr>
          </xsl:when>
          <xsl:otherwise>
            &nbsp;
          </xsl:otherwise>
        </xsl:choose>
      </td>
    </tr>
  </xsl:template>

  <xsl:template name="VMs">
    <xsl:for-each select="/server/vm[@type='vmm']">
      <xsl:call-template name="vmRow">
        <xsl:with-param name="position">
          <xsl:value-of select="position()"/>
        </xsl:with-param>
        <xsl:with-param name="stats"><mem-chart/></xsl:with-param>
        <xsl:with-param name="vm_script_name">/resources/editor</xsl:with-param>
      </xsl:call-template>

      <!-- Try to chunk the table every 3 rows of VMs so Navigator doesn't barf on long lists. -->
      <xsl:choose>
        <xsl:when test="not(position()=last()) and (position() mod 9=0)">
          <xsl:variable name="new_table"><![CDATA[</TABLE></TD></TR></TABLE></TD></TR></TABLE><TABLE width="100%" border="0" cellpadding="1" cellspacing="0"><TR><TD><IMG src="]]><xsl:value-of select="$imx"/><![CDATA[spacer.gif" width="1" height="1"/></TD></TR><TR><TD bgcolor="#999980"><TABLE width="100%" border="0" cellpadding="0" cellspacing="0"><TR><TD bgcolor="#FFFFE6"><TABLE width="100%" border="0" cellpadding="3" cellspacing="1">]]></xsl:variable>
          <xsl:text disable-output-escaping="yes"><xsl:value-of select="$new_table"/></xsl:text>
        </xsl:when>
        <xsl:when test="not(position()=last()) and (position() mod 3=0)">
          <TR bgcolor="#E6E6CC">
            <TD colspan="{$vm_colspan}"><IMG src="{$imx}spacer.gif" width="1" height="1"/></TD>
          </TR>
        </xsl:when>
      </xsl:choose>
    </xsl:for-each>
  </xsl:template>

  <xsl:template name="legend">
    <tr><td colspan='{$vm_colspan}' align='center' class='hdr'>
      <table width="600"><tr>
        <td width="20" bgcolor="#6699ff"><img src="{$imx}spacer.gif" width="20" height="12"/></td>
        <td width="100" class='txt'><b>Active</b></td>

        <td width="20" bgcolor="#99ccff"><img src="{$imx}spacer.gif" width="20" height="12"/></td>
        <td width="100" class='txt'><b>Idle</b></td>

        <td width="20" bgcolor="#ff3333" background="{$imx}stripe.gif"><img src="{$imx}spacer.gif" width="20" height="12"/></td>
        <td width="100" class='txt'><b>Swapped</b></td>

        <td width="20" bgcolor="#ff9999" background="{$imx}stripe.gif"><img src="{$imx}spacer.gif" width="20" height="12"/></td>
        <td width="100" class='txt'><b>VMMemCtl</b></td>

        <td width="20" bgcolor="#cccccc" background="{$imx}stripe.gif"><img src="{$imx}spacer.gif" width="20" height="12"/></td>
        <td width="100" class='txt'><b>Unused</b></td>
      </tr></table>
    </td></tr>
  </xsl:template>
</xsl:stylesheet>
