var DISK_SIZE = 4000;

function getarg (arg)
{
  var s=window.location.search.substring(1);
  var a=s.split("&");
  for (var i=0; i<a.length; i++) {
    a[i]=a[i].split('=');
    if (a[i][0]==arg) {
      return a[i][1];
    }
  }
  return null;
}

function undo()
{
  OS_OnChange();
  SetOption(window.document.forms[0].diskSize, DISK_SIZE);
  SetOption(window.document.forms[0].displayDepth, 16);
}

function SetOption(frmSelect, value)
{
  for(i = 0; i < frmSelect.options.length; i++) {
    if(frmSelect.options[i].value == value) {
      frmSelect.options.selectedIndex = i;
      return 1;
    }
  }

  return 0;
}

function OS_OnChange()
{
  var theForm = window.document.forms[0];
  var prettyOS = "";
  var selectedOS = theForm.os.options[theForm.os.selectedIndex].value;

  theForm.fileName.value = homeDir + "/vmware/" + selectedOS + "/" + selectedOS + ".cfg";

  switch(selectedOS)
  {
    case "nt4":
       prettyOS = "Windows NT4";
       break;
    case "win2000":
       prettyOS = "Windows 2000";
       break;
    case "linux":
       prettyOS = "Linux";
       break;
    case "winXPPro":
       prettyOS = "Windows XP Professional";
       break;
    case "winNetWeb":
       prettyOS = "Windows Server 2003, Web Edition";
       break;
    case "winNetStandard":
       prettyOS = "Windows Server 2003, Standard Edition";
       break;
    case "winNetEnterprise":
       prettyOS = "Windows Server 2003, Enterprise Edition";
       break;
  }
  theForm.displayName.value = "My " + prettyOS + " VM";

  switch(theForm.os.options[theForm.os.selectedIndex].value)
  {
    case "dos":
       theForm.memSize.value = RAM_MSDOS;
       break;
    case "win31":
       theForm.memSize.value = RAM_WIN31;
       break;
    case "win95":
       theForm.memSize.value = RAM_WIN95;
       break;
    case "win98":
       theForm.memSize.value = RAM_WIN98;
       break;
    default:
       theForm.memSize.value = RAM_DEFAULT;
       break;
  }
}

function getVFLN(n) {
  for(v in vmfs) {
    if (vmfs[v]['logical_name']==n)
      return v;
  }
  return n;
  // If there isn't a device associated with the logical name, just pass it back.
}

function setVolume(n,v){
  var w=document.w;
  w[n+'_volume'].value=v;
  loadSelections();
  if(v && !vmfs[v]){
    v=getVFLN(v);
  }
  if (!v) {
    w[n+'_fileName'].value='';
    w[n+'_size'].value='';
    w[n+'_present'].checked=false;
    w[n+'_mode'].value='';
    modes[n]='N/A';
  } else if (!vmfs[v]) {
    // [ ! ] XXX This assumes that if there is no logical_name:device_name
    // mapping that the device is a scsi pass-through device
    w[n+'_fileName'].value='';
    w[n+'_size'].value='';
    w[n+'_present'].checked=true;
    w[n+'_mode'].value='';
    modes[n]='N/A';
  } else {
    var i=w[n+'_fileName_select'].selectedIndex;
    if (i<0) {
      w[n+'_fileName'].value="";
      w[n+'_size'].value="";
    } else {
      var d=w[n+'_fileName_select'].options[i].value;
      w[n+'_fileName'].value=d;
      w[n+'_size'].value=vmfs[v][d];
    }
    w[n+'_present'].checked=true;
    w[n+'_mode'].value='persistent';
    modes[n]='persistent';
  }
  loadSelections();
}

function setDisk(n,f){
  var w=document.w;
  var i=w[n+'_volume_select'].selectedIndex;
  var v=w[n+'_volume_select'].options[i].value;
  w[n+'_fileName'].value=f;
  if(!vmfs[v]){
    v=getVFLN(v);
  }
  w[n+'_size'].value=vmfs[v][f];
  w[n+'_present'].checked=true;
}

function setMode(n,m){
  var w=document.w;
  w[n+'_mode'].value=m;
  modes[n]=m;
}

function verifyVmfs(p,f,s,i){
  for(var d in vmfs[p]){
    if(f==d)return;
  }
  vmfs[p][f]=s;
  modes[i]='persistent';
}

function loadSelections(){
  var f=document.w;
  var vword='_volume';
  var dword='_fileName';
  var mword='_mode';
  var sword='_select';
  var NC = 'Not Configured';
  var NA = 'N/A';
  for(var i=0;i<f.elements.length;i++){
    // Setup the vmfs volume options for the current select object.
    if(f.elements[i].type=='select-one'&&f.elements[i].name.indexOf(vword)!=-1){
      f.elements[i].options.length=0;
      var sel=false;
      var n=f.elements[i].name.substring(0,f.elements[i].name.indexOf(vword+sword)); // disk id (e.g., scsi1)
      for(var v in vmfs){
        var pname = vmfs[v]['physical_name'];
        var lname = vmfs[v]['logical_name'] ? vmfs[v]['logical_name'] : pname;
        var sd=f[n+vword].value==pname||f[n+vword].value==lname; // selected
        f.elements[i].options[f.elements[i].options.length]=new Option(lname+(v!=NC?' (VMFS) ':''),(v!=NC?lname:''),sd?sd:null,sd?sd:null);
        f.elements[i].options[f.elements[i].options.length-1].selected=sd;
        if(sd)sel=sd;
      }
      for(var p in spt){ // scsi pass-through devices
        var sd=f[n+vword].value==p; // selected
        f.elements[i].options[f.elements[i].options.length]=new Option(p + ' (' + spt[p] + ')',p,sd?sd:null,sd?sd:null);
        f.elements[i].options[f.elements[i].options.length-1].selected=sd;
        if(sd)sel=sd;
      }
      if(!sel&&f.elements[i].options.length>0) {
        if (f[n+vword].value!=''){
          f.elements[i].options[f.elements[i].options.length]=new Option("Nonexistent volume: '"+f[n+vword].value+"'",f[n+vword].value,true,true);
          f.elements[i].options[f.elements[i].options.length-1].selected=true;
        } else {
          f.elements[i].options[0].selected=true;
        }
      }
      continue;
    }
    // Setup the vmfs disk options for the current select object.
    if(f.elements[i].type=='select-one'&&f.elements[i].name.indexOf(dword)!=-1){
      for(var v in vmfs){
        var pname = vmfs[v]['physical_name'];
        var lname = vmfs[v]['logical_name'] ? vmfs[v]['logical_name'] : pname;
        var n=f.elements[i].name.substring(0,f.elements[i].name.indexOf(dword+sword)); // disk id (e.g., scsi1)
        var vol=f[n+vword].value==pname||f[n+vword].value==lname||v==NC;
        if (vol){ // only emit options for the current vmfs volume
          f.elements[i].options.length=0;
          var sel=false;
          for(var d in vmfs[v]) {
            if (d!='size'&&d!='free'&&d!='logical_name'&&((d==NA)||(d.match(/.dsk$/)))){
              var sd=f[n+dword].value==d;
              f.elements[i].options[f.elements[i].options.length]=new Option(d+(d!=NA?' ('+vmfs[v][d]+'MB)':''),(d!=NA?d:''),sd,sd);
              f.elements[i].options[f.elements[i].options.length-1].selected=sd;
              if(sd)sel=sd;
            }
          }
          if(!sel&&f.elements[i].options.length>0) {
            if (f[n+dword].value!=''){
              f.elements[i].options[f.elements[i].options.length]=new Option("Nonexistent file: '"+f[n+dword].value+"'",f[n+dword].value,true,true);
              f.elements[i].options[f.elements[i].options.length-1].selected=true;
            } else {
              f.elements[i].options[0].selected=true;
            }
          }
        }
      }
      continue;
    }
    var MODES = new Array();
    MODES['persistent']='Persistent';
    MODES['nonpersistent']='Nonpersistent';
    MODES['undoable']='Undoable';
    MODES['append']='Append';
    // Setup the mode options for the current select object.
    if(f.elements[i].type=='select-one'&&f.elements[i].name.indexOf(mword)!=-1){
      f.elements[i].options.length=0;
      var sel=false;
      var n=f.elements[i].name.substring(0,f.elements[i].name.indexOf(mword+sword)); // disk id (e.g., scsi1)
      if(modes[n]!=NA){
        for(var M in MODES){
          var sd=f[n+mword].value==M; // selected
          f.elements[i].options[f.elements[i].options.length]=new Option(MODES[M],(modes[n]!=NA?M:''),sd,sd);
          f.elements[i].options[f.elements[i].options.length-1].selected=sd;
          if(sd)sel=sd;
        }
      } else {
        f.elements[i].options[f.elements[i].options.length]=new Option(modes[n],'',true,true);
        sel=f.elements[i].options[f.elements[i].options.length-1].selected=true;
      }
      if(!sel&&f.elements[i].options.length>0) {
        if (f[n+mword].value!=''){
          f.elements[i].options[f.elements[i].options.length]=new Option("Invalid mode: '"+f[n+mword].value+"'",f[n+mword].value,true,true);
          f.elements[i].options[f.elements[i].options.length-1].selected=true;
        } else {
          f.elements[i].options[0].selected=true;
        }
      }
      continue;
    }
  }
}

function togglePresent(which){
  var name=which.name.substring(0,which.name.indexOf('_present'));
  var f=document.w;
  if(!which.checked){
    f[name+'_volume'].value=f[name+'_fileName'].value=f[name+'_size'].value=f[name+'_mode'].value='';
    modes[name]='N/A';
    loadSelections();
  }else{
    f[name+'_volume_select'].options[f[name+'_volume_select'].selectedIndex].selected=false;
    f[name+'_volume_select'].options[1].selected=true;
    modes[name]='persistent';
    setVolume(name,f[name+'_volume_select'].options[f[name+'_volume_select'].selectedIndex].value);
  }
}
