<?xml version="1.0" encoding="iso-8859-1"?>
<!-- Todo:

     [!DOCTYPE] Put common enitity declarations into a DTD. But DTDs don't seem
     to be working correctly. Hmmm.

  -->
<!DOCTYPE html [
<!ENTITY nbsp "<xsl:text disable-output-escaping='yes'>&amp;nbsp;</xsl:text>">
<!ENTITY ampersand "<xsl:text disable-output-escaping='yes'>&amp;</xsl:text>">
]>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
  <!-- [ ! ] --><xsl:include href="common.xsl"/>
  <xsl:include href="../../js-import.xsl"/>
  <xsl:include href="pageHelp.xsl"/>
  <xsl:include href="controlmenu.xsl"/>

  <xsl:variable name="vm_colspan">17</xsl:variable>

  <xsl:template match="/">
    <HTML>
      <HEAD>
        <TITLE><xsl:value-of select="/server/host"/>.<xsl:value-of select="/server/host@domain"/> - VMkernel Configuration</TITLE>
        <SCRIPT>
          <xsl:choose>
            <xsl:when test="/server/product@id='ESX'">
              var product = "ESX";
            </xsl:when>
            <xsl:otherwise>
              var product = "GSX";
            </xsl:otherwise>
          </xsl:choose>
          var noRefresh = true;
          var hostOS = "<xsl:value-of select="/server/host@os"/>";
          //var refreshRate = new Array( );
          //refreshRate['minutes'] = '3';
          //refreshRate['seconds'] = '0';
          <xsl:call-template name="js-src">
            <xsl:with-param name="src">../../util-js.xml</xsl:with-param>
            <xsl:with-param name="use">
              <obj use-recommended="1">Is</obj>
            </xsl:with-param>
          </xsl:call-template>
          <xsl:call-template name="js-src">
            <xsl:with-param name="src">controlmenu-js.xml</xsl:with-param>
          </xsl:call-template>
        </SCRIPT>
        <SCRIPT src="{$common}server.js"></SCRIPT>
        <LINK rel="stylesheet" href="{$common}style.css" type="text/css" />
      </HEAD>

      <BODY bgcolor="#FFFFFF" link="#000000" vlink="#000000" topmargin="6" leftmargin="6" marginwidth="6" marginheight="6" onload="setup();ctrlMenuSetup();">
        <xsl:call-template name="poweroffMenu"/>
        <xsl:call-template name="poweronMenu"/>
        <xsl:call-template name="suspendMenu"/>
        <xsl:call-template name="softableMenu"/>
        <xsl:call-template name="readonlyMenu"/>
        <xsl:call-template name="unreachableMenu"/>

        <xsl:call-template name="operationForm"/>

        <xsl:if test="not(/server/mui='new')">
           <xsl:call-template name="pageHeader">
             <xsl:with-param name="uiPath">
               <location href="/vmware/config">VMware ESX Server Configuration</location>
               <current>VMkernel Configuration</current>
             </xsl:with-param>
           </xsl:call-template>
        </xsl:if>
        <xsl:if test="not(/server/username='root')">
          <p>
            <table><tr>
              <td><img src="{$imx}spacer.gif" width="128" height="1"/></td>
              <td>
                <table border="0" cellpadding="5" cellspacing="0">
                  <tr>
                    <xsl:variable name="icon">info.gif</xsl:variable>
                    <td rowspan="2" valign="top"><IMG src="{$common.imx}{$icon}" width="32" height="32"/></td>
                    <td><b>Notice</b></td>
                  </tr>
                  <tr>
                    <td>
                      <p><small>You must login as the root user in order to modify VMkernel parameters.</small></p>
                    </td>
                  </tr>
                </table>
              </td>
              <td><img src="{$imx}spacer.gif" width="128" height="1"/></td>
            </tr></table>
          </p>
        </xsl:if>
        <xsl:if test="/server/error">
          <P>
            <TABLE><TR>
              <TD><IMG src="{$imx}spacer.gif" width="128" height="1"/></TD>
              <TD>
                <xsl:call-template name="error"/>
              </TD>
              <TD><IMG src="{$imx}spacer.gif" width="128" height="1"/></TD>
            </TR></TABLE>
          </P>
        </xsl:if>
        <TABLE width="100%" border="0" cellpadding="1" cellspacing="0">
          <TR><TD><IMG src="{$imx}spacer.gif" width="1" height="6"/></TD></TR>
          <TR><TD bgcolor="#999980">
            <TABLE width="100%" border="0" cellpadding="0" cellspacing="0"><TR><TD bgcolor="#FFFFE6"><TABLE width="100%" border="0" cellpadding="3" cellspacing="1">
               <TR valign="baseline" bgcolor="#CCCCB3">
                  <TD><SMALL><B>Parameter</B></SMALL></TD>
                  <TD width="150"><SMALL>
                    <B>Value</B>
                    <xsl:if test="/server/username='root'">
                      <SMALL>&nbsp;(click to change)</SMALL>
                    </xsl:if>
                  </SMALL></TD>
              </TR>
               <xsl:for-each select="/server/vmkernel/param">
                <xsl:call-template name="vmk-config-param"/>
              </xsl:for-each>
             </TABLE></TD></TR></TABLE>
            <TR><TD><IMG src="{$imx}spacer.gif" width="1" height="6"/></TD></TR>
          </TD></TR>
        </TABLE>
        <xsl:if test="not(/server/mui='new')">
           <xsl:call-template name="labelFooter"/>
        </xsl:if>
      </BODY>
    </HTML>
  </xsl:template>

  <xsl:template name="vmk-config-param">
    <xsl:variable name="clr">
      <xsl:choose>
        <xsl:when test="position() mod 2=0">E6E6CC</xsl:when>
        <xsl:otherwise>FFFFE6</xsl:otherwise>
      </xsl:choose>
    </xsl:variable>
       <TR valign="baseline" bgcolor="#{$clr}">
      <TD><SMALL>
        <B><xsl:value-of select="name"/></B>
        <BR/>
        <SMALL><xsl:value-of select="desc"/>&nbsp;</SMALL>
      </SMALL></TD>
      <TD width="120"><SMALL>
      <xsl:variable name="valstr">
        <xsl:choose>
          <xsl:when test="value = ''">
            [empty]
          </xsl:when>
          <xsl:otherwise>
            <xsl:value-of select="value"/>
          </xsl:otherwise>
        </xsl:choose>
      </xsl:variable>
      <xsl:variable name="dfltstr">
        <xsl:choose>
          <xsl:when test="default = ''">
            [empty]
          </xsl:when>
          <xsl:otherwise>
            <xsl:value-of select="default"/>
          </xsl:otherwise>
        </xsl:choose>
      </xsl:variable>
        <xsl:choose>
          <xsl:when test="/server/username='root'">
            <SCRIPT language="JavaScript">
              function VMKernelUpdate(param,value,def)
              {
                <xsl:if test="/server/mui='new'">
                  browseWin = window.open('/vmkernel-update?mui=new'+unescape('%26')+'p='+param+unescape('%26')+'v='+value+unescape('%26')+'d='+def, 'VMKernelUpdate', 'width=350,height=175,resizable,scrollbars');
                </xsl:if>
                <xsl:if test="not(/server/mui='new')">
                  browseWin = window.open('/vmkernel-update?p='+param+unescape('%26')+'v='+value+unescape('%26')+'d='+def, 'VMKernelUpdate', 'width=350,height=175,resizable,scrollbars');
                </xsl:if>
                browseWin.clientData = param;
              }
            </SCRIPT>
            <a href="javascript:VMKernelUpdate('{name}','{value}','{default}')">
            <xsl:value-of select="$valstr"/>
            </a>
          </xsl:when>
          <xsl:otherwise>
            <xsl:value-of select="$valstr"/>
          </xsl:otherwise>
        </xsl:choose>
        <xsl:if test="not(value=default)">
          <BR/>
          <SMALL>(default = <xsl:value-of select="$dfltstr"/>)</SMALL>
        </xsl:if>
      </SMALL></TD>
    </TR>
  </xsl:template>

</xsl:stylesheet>