<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html [
  <!ENTITY nbsp "<xsl:text disable-output-escaping='yes'>&amp;nbsp;</xsl:text>">
  <!ENTITY copy "<xsl:text disable-output-escaping='yes'>&amp;copy;</xsl:text>">
  <!ENTITY ampersand "<xsl:text disable-output-escaping='yes'>&amp;</xsl:text>">
]>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
  <!-- [ ! ] --><xsl:include href="common.xsl"/>
  <!-- <xsl:include href="../vmware/common/operation-btn.xsl"/> -->

  <xsl:variable name="username">
    <xsl:value-of select="input/username" />
  </xsl:variable>
  <xsl:variable name="hostOS">
    <xsl:value-of select="input/hostOS" />
  </xsl:variable>
  <xsl:variable name="os">
    <xsl:value-of select="input/os" />
  </xsl:variable>
  <xsl:variable name="displayname">
    <xsl:value-of select="input/displayName" />
  </xsl:variable>
  <xsl:variable name="dir">
    <xsl:value-of select="input/dir" />
  </xsl:variable>
  <xsl:variable name="disksize">
    <xsl:value-of select="input/diskSize" />
  </xsl:variable>
  <xsl:variable name="memsize">
    <xsl:value-of select="input/memSize" />
  </xsl:variable>
  <xsl:variable name="networking">
    <xsl:value-of select="input/networking" />
  </xsl:variable>
  <xsl:variable name="displaydepth">
    <xsl:value-of select="input/displayDepth" />
  </xsl:variable>
  <xsl:variable name="floppy0FileName">
    <xsl:value-of select="input/floppy0/fileName" />
  </xsl:variable>
  <xsl:variable name="floppy0FileType">
    <xsl:value-of select="input/floppy0/fileType" />
  </xsl:variable>
  <xsl:variable name="floppy0StartConnected">
    <xsl:value-of select="input/floppy0/startConnected" />
  </xsl:variable>
  <xsl:variable name="cdromFileName">
    <xsl:value-of select="input/cdrom/fileName" />
  </xsl:variable>
  <xsl:variable name="cdromDeviceType">
    <xsl:value-of select="input/cdrom/deviceType" />
  </xsl:variable>
  <xsl:variable name="cdromStartConnected">
    <xsl:value-of select="input/cdrom/startConnected" />
  </xsl:variable>
  <xsl:variable name="win32_suffix">
    <xsl:if test="$hostOS = 'MSWin32'">/index.pl</xsl:if>
  </xsl:variable>

  <xsl:variable name="wgs"><xsl:value-of select="$docroot"/>themes/vmware/wgs/</xsl:variable>
  <xsl:template match="/">
    <HTML>
      <HEAD>
        <TITLE>New Virtual Machine</TITLE>
        <SCRIPT src="/vmware/themes/default/guestdefaults.js"></SCRIPT>
        <SCRIPT>
          <xsl:choose>
            <xsl:when test="string(/server/product@id)='SS'">
              var product = "SS";
            </xsl:when>
            <xsl:otherwise>
              var product = "WGS";
            </xsl:otherwise>
          </xsl:choose>

          var homedir = "<xsl:value-of select="input/homeDir" />";
	  var reply = "<xsl:value-of select="input/os" />";

          var hostOS = "<xsl:value-of select="$hostOS" />";
          var replyOS = "<xsl:value-of select="$os" />";
          var replyDisplayName = "<xsl:value-of select="$displayname" />";
          var replyDir = "<xsl:value-of select="$dir" />";
          var replyDiskSize = "<xsl:value-of select="$disksize" />";
          var replyMemSize = "<xsl:value-of select="$memsize" />";
          var replyNetworking = "<xsl:value-of select="$networking" />";
          var replyDisplayDepth = "<xsl:value-of select="$displaydepth" />";

          var defaultFloppy0FileName = "<xsl:value-of select="input/defaults/common/floppy/filename"/>";
          var replyFloppy0FileName = "<xsl:value-of select="$floppy0FileName" />";
          var replyFloppy0FileType = "<xsl:value-of select="$floppy0FileType" />";
          var replyFloppy0StartConnected = "<xsl:value-of select="$floppy0StartConnected" />";

          var defaultCdromFileName = "<xsl:value-of select="input/defaults/common/cdrom/filename"/>";
          var replyCdromFileName = "<xsl:value-of select="$cdromFileName" />";
          var replyCdromDeviceType = "<xsl:value-of select="$cdromDeviceType" />";
          var replyCdromStartConnected = "<xsl:value-of select="$cdromStartConnected" />";

          <xsl:if test="/input/defaults">
            <xsl:for-each select="/input/defaults/guests/guest">
              <xsl:variable name="os"><xsl:value-of select="./os"/></xsl:variable>

	      <!-- Create the guest defaults objects -->
	      var guestMem_<xsl:value-of select="$os"/> = 
                       new GuestOS_MemDefaults("<xsl:value-of select="$os" />",
                                               "<xsl:value-of select="./memory/minimum" />",
                                               "<xsl:value-of select="./memory/maximum" />",
                                               "<xsl:value-of select="./memory/recommended" />",
                                               "<xsl:value-of select="./memory/warning" />");

	      var guest_<xsl:value-of select="$os"/> =
                       new GuestOS_Defaults("<xsl:value-of select="$os" />",
                                            "<xsl:value-of select="./displayName" />",
                                            "<xsl:value-of select="./scsi" />",
                                            "<xsl:value-of select="./size" />",
                                            "<xsl:value-of select="./colorDepth" />",
                                            guestMem_<xsl:value-of select="$os"/>);
            </xsl:for-each>

	    guestOsList = new Array(
            <xsl:for-each select="/input/defaults/guests/guest">
              <xsl:variable name="os"><xsl:value-of select="./os"/></xsl:variable>
                                    guest_<xsl:value-of select="$os"/><xsl:if test="position()!=last()">,</xsl:if>
            </xsl:for-each>
                                    );

          </xsl:if>
       </SCRIPT>
       <LINK rel="stylesheet" href="{$common}style.css" type="text/css" />
        <META http-equiv="Content-Type" content="text/html; charset=utf-8" />
        <SCRIPT src="/vmware/themes/default/wgs/vmnew.js"></SCRIPT>
        <SCRIPT src="{$common}server.js"></SCRIPT>
        
      </HEAD>

      <BODY bgcolor="#FFFFFF" link="#000000" vlink="#000000" topmargin= "6" leftmargin="6" marginwidth="6" marginheight="6" onLoad="OS_OnChange();">

        <xsl:call-template name="pageHeader">
          <xsl:with-param name="uiPath">
            <location href="/overview">VMs on <xsl:value-of select="/input/host"/><xsl:if test="/input/host@domain">.<xsl:value-of select="/input/host@domain"/></xsl:if></location>
            <current>New Virtual Machine</current>
          </xsl:with-param>
        </xsl:call-template>

         <TABLE width="100%" border="0" cellpadding="1" cellspacing="0">
            <TR><TD><IMG src="{$imx}spacer.gif" width="1" height="3"/></TD></TR>
            <TR><TD bgcolor="#999980">
              <TABLE width="100%" border="0" cellpadding="3" cellspacing="0">
                <TR bgcolor="#E6E6CC">
                  <TD>
                    <xsl:if test="/input/error">
                      <xsl:call-template name="reply_error"/>
                    </xsl:if>
                    <xsl:choose>
                      <xsl:when test="/input/success">
                        <xsl:call-template name="reply_success"/>
                      </xsl:when>
                      <xsl:otherwise>
                        <xsl:call-template name="input"/>
                      </xsl:otherwise>
                    </xsl:choose>
                  </TD>
                </TR>
              </TABLE>
            </TD></TR>
          </TABLE>

          <p>
            <TABLE width="100%" border="0" cellpadding="0" cellspacing="0">
              <TR>
                <TD align="right" nowrap="true" background="{$theme.imx}footer-bg.gif">
                  <NOBR><SMALL><SMALL>&nbsp;</SMALL></SMALL></NOBR>
                </TD>
                <TD width="1%" nowrap="true"><IMG src="{$theme.imx}footer.gif" width="451" height="49"/></TD>
              </TR>
            </TABLE>
          </p>

          <p align="center"><small><small>&copy; 1998-2006 VMware, Inc. All rights reserved. U.S.<br />
          Protected by one or more of U.S. Patent Nos. 6,397,242, 6,496,847, 6,704,925, 6,711,672, 6,725,289, 6,735,601, 6,785,886, 6,789,156, 6,795,966, 6,880,022 6,961,941, 6,961,806 and 6,944,699; patents pending.
          </small></small></p>

      </BODY>
    </HTML>
  </xsl:template>

<xsl:template name="input">

<form name="vm_input" method="get">
<table width="550">
  <tr>
    <td>
       <!-- OPERATING SYSTEM -->
      <xsl:if test="not(/input/error)">
        <p>
          <small>
            Use this form to create your new virtual machine. After creating
            the virtual machine, you can make any changes using the
            Configuration Editor. To access the Configuration Editor, in a
            local or remote console, choose Settings &gt; Configuration
            Editor.
          </small>
        </p>
      </xsl:if>
       <table width="550" cellspacing="0" cellpadding="3" border="0">
         <tr>
           <td bgcolor="#66664D">
              &nbsp;&nbsp;<b><font color="#FFFFFF">Operating System</font></b>
           </td>
         </tr>
         <tr>
           <td valign="top">
              <img src="{$imx}spacer.gif" width="546" height="1" /><br />
              <table cellspacing="0" cellpadding="10" border="0">
                <tr>
                  <td width="180"><small><b>Guest OS:</b></small>
                  </td>
                  <td><small>
                      <select name="os" onChange="OS_OnChange();">
                        <xsl:for-each select="/input/defaults/guests/guest">
                          <xsl:variable name="os"><xsl:value-of select="./os"/></xsl:variable>
                          <xsl:variable name="displayName"><xsl:value-of select="./displayName"/></xsl:variable>
                          <option value="{$os}"><xsl:value-of select="$displayName"/></option>
                        </xsl:for-each>
                      </select></small>
                  </td>
                </tr>
                <tr>
                  <td width="180"><small><b>Display Name:</b></small>
                  </td>
                  <td>
                    <input name="displayname" value="" size="48" />
                  </td>
                </tr>                <tr>
                  <td><small><b>Virtual Machine Directory:</b></small>
                  </td>
                  <td>
                   <input name="dir" value="" size="48" />
                  </td>
                </tr>
              </table>
           </td>
         </tr>
       </table>

       <br />

       <!-- HARDWARE SETTINGS -->
       <table width="550" cellspacing="0" cellpadding="3" border="0">
         <tr>
           <td bgcolor="#66664D">
              &nbsp;&nbsp;<b><font color="#FFFFFF">Drive and Memory Settings</font></b>
           </td>
         </tr>
         <tr>
           <td valign="top">
              <img src="{$imx}spacer.gif" width="546" height="1" /><br />
              <table cellspacing="0" cellpadding="10" border="0">
                <tr>
                  <td><small><b>Virtual Disk Size:&nbsp;&nbsp;</b></small>
                  </td>
                  <td><small>
                      <select name="disksize">
                         <option value="1">1 GB </option>
                         <option value="2">2 GB </option>
                         <option value="4" selected="1">4 GB </option>
                         <option value="8">8 GB </option>
                         <option value="16">16 GB </option>
                         <option value="32">32 GB </option>
                         <option value="64">64 GB </option>
                         <option value="128">128 GB </option>
                       </select></small>
		       <input name="scsi" type="hidden" value="0"/>
                  </td>
                </tr>
                <tr>
                  <td><small><b>Memory Size (RAM):&nbsp;&nbsp;</b></small>
                  </td>
                  <td><input name="memsize" value="128" size="6" /><small> MB</small>
                  &nbsp;&nbsp;&nbsp;
                  <small><small><b>Note</b>: Value must be a multiple of four.</small></small>
                  </td>
                </tr>
                <tr>
                  <td valign="baseline"><small><b>CD-ROM Drive:&nbsp;&nbsp;</b></small></td>
                  <td>
                    <input name="cdromFileName" size="25">
                      <xsl:attribute name="value">
                        <xsl:value-of select="/input/defaults/common/cdrom/filename"/>
                      </xsl:attribute>
                    </input>
                    <table border="0" cellpadding="3" cellspacing="1">
                      <tr>
                        <td><input name="cdromDeviceType" type="checkbox" value="TRUE"/></td>
                        <td><small>Drive is an ISO image</small></td>
                      </tr>
                      <tr>
                        <td><input name="cdromStartConnected" type="checkbox" checked="1" value="TRUE"/></td>
                        <td><small>Start connected</small></td>
                      </tr>
                    </table>
                  </td>
                </tr>
                <tr>
                  <td valign="baseline"><small><b>Floppy Drive:&nbsp;&nbsp;</b></small></td>
                  <td>
                    <input name="floppy0FileName" size="25">
                      <xsl:attribute name="value">
                        <xsl:value-of select="/input/defaults/common/floppy/filename"/>
                      </xsl:attribute>
                    </input>
                    <table border="0" cellpadding="3" cellspacing="1">
                      <tr>
                        <td><input name="floppy0FileType" type="checkbox" value="TRUE"/></td>
                        <td><small>Drive is a floppy image</small></td>
                      </tr>
                      <tr>
                        <td><input name="floppy0StartConnected" type="checkbox" checked="1" value="TRUE"/></td>
                        <td><small>Start connected</small></td>
                      </tr>
                    </table>
                  </td>
                </tr>
              </table>
           </td>
         </tr>
       </table>

       <br />

       <!-- NETWORKING -->
       <table width="550" cellspacing="0" cellpadding="3" border="0">
         <tr>
           <td bgcolor="#66664D">
              &nbsp;&nbsp;<b><font color="#FFFFFF">Networking</font></b>
           </td>
         </tr>
         <tr>
           <td valign="top">
              <img src="{$imx}spacer.gif" width="546" height="1" /><br />
              <table cellspacing="0" cellpadding="10" border="0">
                <tr>
                  <td>
                    <small>
                      A virtual machine can be connected directly to a local 
                      Ethernet via an Ethernet network adapter card in your
                      computer.
                      <p />
                      <input type="checkbox" name="networking" value="1" checked="1" />
                      &nbsp;&nbsp;
                      <b>Enable Networking</b>
                      <!--
                      <select name="networking">
                        <option value="ethernet0">Bridged over ethernet0</option>
                        <option value="ethernet1">Bridged over ethernet1</option>
                        <option value="ethernet2">Bridged over ethernet2</option>
                        <option value="none">No Networking</option>
                      </select>
                      -->
                    </small>
                  </td>
                </tr>
              </table>
           </td>
         </tr>
       </table>
       
       <br />

       <!-- MISC -->
       <table width="550" cellspacing="0" cellpadding="3" border="0">
         <tr>
           <td bgcolor="#66664D">
              &nbsp;&nbsp;<b><font color="#FFFFFF">Misc</font></b>
           </td>
         </tr>
         <tr>
           <td valign="top">
              <img src="{$imx}spacer.gif" width="546" height="1" /><br />
              <table cellspacing="0" cellpadding="10" border="0">
                <tr>
                  <td>
                    <small>
                      <b>Display Depth:</b>&nbsp;&nbsp;&nbsp;
                      <select name="displaydepth">
                        <option value="8">8</option>
                        <option value="15">15</option>
                        <option value="16" selected="1">16</option>
                        <option value="24">24</option>
                      </select>
                    </small>
                  </td>
                </tr>
              </table>
           </td>
         </tr>
       </table>

       <br />

       <table width="550" cellspacing="0" cellpadding="0" border="0">
         <tr>
           <td colspan="3" align="right" valign="bottom">
             <table>
               <tr>
                 <td> 
                    <xsl:call-template name="button">
                      <xsl:with-param name="label">Create VM</xsl:with-param>
                      <xsl:with-param name="action">Javascript:window.document.forms[0].submit()</xsl:with-param>
                      <xsl:with-param name="gutter-shadow">CCCCB3</xsl:with-param>
                      <xsl:with-param name="gutter-hilite">FFFFE6</xsl:with-param>
                      <xsl:with-param name="edge-shadow">CCCCB3</xsl:with-param>
                      <xsl:with-param name="edge-hilite">FFFFE6</xsl:with-param>
                      <xsl:with-param name="base">E6E6CC</xsl:with-param>
                    </xsl:call-template>
                 </td>
                 <td>
                    <xsl:call-template name="button">
                      <xsl:with-param name="label">Reset to Defaults</xsl:with-param>
                      <xsl:with-param name="action">Javascript:ResetForm()</xsl:with-param>
                      <xsl:with-param name="gutter-shadow">CCCCB3</xsl:with-param>
                      <xsl:with-param name="gutter-hilite">FFFFE6</xsl:with-param>
                      <xsl:with-param name="edge-shadow">CCCCB3</xsl:with-param>
                      <xsl:with-param name="edge-hilite">FFFFE6</xsl:with-param>
                      <xsl:with-param name="base">E6E6CC</xsl:with-param>
                    </xsl:call-template>
                 </td>
                 <td>
                    <xsl:call-template name="button">
                      <xsl:with-param name="label">Return to Overview Page</xsl:with-param>
                      <xsl:with-param name="action">/overview</xsl:with-param>
                      <xsl:with-param name="gutter-shadow">CCCCB3</xsl:with-param>
                      <xsl:with-param name="gutter-hilite">FFFFE6</xsl:with-param>
                      <xsl:with-param name="edge-shadow">CCCCB3</xsl:with-param>
                      <xsl:with-param name="edge-hilite">FFFFE6</xsl:with-param>
                      <xsl:with-param name="base">E6E6CC</xsl:with-param>
                    </xsl:call-template>
                 </td>
               </tr>
             </table>
           </td>
         </tr>
       </table>
    </td>
  </tr>     
</table>
</form>

</xsl:template>

  <xsl:template name="reply_error">
      <table width="475" border="0" cellpadding="5" cellspacing="0">
        <tr>
          <td rowspan="2" valign="top"><img src="{$common.imx}error.gif" width="32" height="32"/></td>
          <td><small><b>Error</b></small></td>
        </tr>
        <tr>
          <td width="100%" valign="top">
            <p><small>One or more errors were encountered while creating your new virtual machine.</small></p>

            <xsl:for-each select="/input/error">
              <ul>
                <li><small><xsl:value-of select="."/></small></li>
              </ul>
            </xsl:for-each>
          </td>
        </tr>
      </table>
  </xsl:template>

  <xsl:template name="warnings">
      <table width="475" border="0" cellpadding="5" cellspacing="0">
        <tr>
          <td rowspan="2" valign="top"><img src="{$common.imx}warning.gif" width="32" height="32"/></td>
          <td><small><b>Warning</b></small></td>
        </tr>
        <tr>
          <td width="100%" valign="top">
            <p><small>One or more warnings were encountered while creating your new virtual machine.</small></p>

            <xsl:for-each select="/input/success/warning">
              <ul>
                <li><small><xsl:value-of select="."/></small></li>
              </ul>
            </xsl:for-each>
          </td>
        </tr>
      </table>
  </xsl:template>

  <xsl:template name="reply_success">
    <center>
    <xsl:if test="/input/success/warning">
      <p>
        <table><tr>
          <td><img src="{$imx}spacer.gif" width="128" height="1"/></td>
          <td>
            <xsl:call-template name="warnings"/>
          </td>
          <td><img src="{$imx}spacer.gif" width="128" height="1"/></td>
        </tr></table>
      </p>
    </xsl:if>
    <table width="475">
      <tr>
        <td>
           <small>
           <br />
           Congratulations!  You have finished configuring your
           virtual machine.  Please review the following information and
           make sure it is correct.
           <p />
           You have created a new virtual machine with the following settings:
           <p />
           <ul>
             <b>
               <img src="{$imx}spacer.gif" width="8" height="8" border="1" />&nbsp;&nbsp;
               <xsl:value-of select="input/success/os" />
               virtual machine
               <br />

               <img src="{$imx}spacer.gif" width="8" height="8" border="1" />&nbsp;&nbsp;
               <xsl:value-of select="input/success/ram" />
               MB of RAM
               <br />

               <img src="{$imx}spacer.gif" width="8" height="8" border="1" />&nbsp;&nbsp;
               <xsl:value-of select="input/success/diskSize" />
               GB persistent hard disk

               <br />
             </b>
           </ul> 
      
           <p />
           
           <table>
             <tr><td> 
               <xsl:call-template name="button">
                 <xsl:with-param name="label">More info...</xsl:with-param>
                 <xsl:with-param name="action">/details<xsl:value-of select="$win32_suffix"/>?c=<xsl:value-of select="input/success/cfg" />
                 </xsl:with-param>
                 <xsl:with-param name="gutter-shadow">CCCCB3</xsl:with-param>
                 <xsl:with-param name="gutter-hilite">FFFFE6</xsl:with-param>
                 <xsl:with-param name="edge-shadow">CCCCB3</xsl:with-param>
                 <xsl:with-param name="edge-hilite">FFFFE6</xsl:with-param>
                 <xsl:with-param name="base">E6E6CC</xsl:with-param>
               </xsl:call-template>
              </td><td>
              <xsl:call-template name="button">
                <xsl:with-param name="label">Create Another VM</xsl:with-param>
                <xsl:with-param name="action">/newvm<xsl:value-of select="$win32_suffix"/></xsl:with-param>
                <xsl:with-param name="gutter-shadow">CCCCB3</xsl:with-param>
                <xsl:with-param name="gutter-hilite">FFFFE6</xsl:with-param>
                <xsl:with-param name="edge-shadow">CCCCB3</xsl:with-param>
                <xsl:with-param name="edge-hilite">FFFFE6</xsl:with-param>
                <xsl:with-param name="base">E6E6CC</xsl:with-param>
              </xsl:call-template>
              </td><td>
              <xsl:call-template name="button">
                <xsl:with-param name="label">Return to Overview</xsl:with-param>
                <xsl:with-param name="action">/</xsl:with-param>
                <xsl:with-param name="gutter-shadow">CCCCB3</xsl:with-param>
                <xsl:with-param name="gutter-hilite">FFFFE6</xsl:with-param>
                <xsl:with-param name="edge-shadow">CCCCB3</xsl:with-param>
                <xsl:with-param name="edge-hilite">FFFFE6</xsl:with-param>
                <xsl:with-param name="base">E6E6CC</xsl:with-param>
               </xsl:call-template>
              </td></tr>
           </table> 

           </small>
        </td>
      </tr>
    </table>
    </center>
  </xsl:template>

</xsl:stylesheet>
